(  . Ver 3.02  17.08.2000
 :
 1.   [ ].
 2. .
 3.    .
 4.   

        
        ~~~~~~~~~~ 
 :
    CLASS: class-name     \   
      <size-of-field> FIELD field-name  \  
      CONSTR: constructor-name ... ;    \ 
      DESTR: destructor-name ... ;      \ 
      M: method-name ... ;              \ 
    ;CLASS                  \   
    ...
    class-name REOPEN     \  
    ...
    ;CLASS                  \      
    ...

 :
    CLASS: subclass-name <SUPER class-name
    \ 
    class-name SUBCLASS: subclass-name
        <size-of-field> FIELD subclass-field-name
        CONSTR: constructor-name ...
            constructor-name    \    
            ... ;               \    .
        ...
        M: subclass-method-name ... ;
        M: method-name ... method-name ... ;
    ;CLASS

     :
    class-name OBJECT: object-name  \   
    \ 
    0 VALUE p-obj
    class-name NEW TO p-obj         \   
    ...
    object-name field-name @ ...    \   
    object-name method-name ...     \   
    p-obj ->CLASS class-name field-name @ ... 
    p-obj ->CLASS class-name method-name ...
    p-obj DELETE    \   
    ...
    WITH class-name     \       
        p-obj => field-name @ ...
        p-obj => method-name ...
    ENDWITH

    subclass-name OBJECT: object1
    object1 subclass-field-name ...
    object1 field-name ...
    object1 subclass-method-name ...
    object1 method-name ...

 :
    PARENT       -    
    SELF         -    
                        this
)       

HERE 

C" SP-FORTH?" FIND NIP 0= [IF] TRUE CONSTANT SP-FORTH? [THEN]

ONLY FORTH DEFINITIONS


: +ORDER ( wid -- ) >R GET-ORDER 1+ R> SWAP SET-ORDER ;

C" CELL+" FIND NIP 0= [IF] : CELL+ 1 CELLS + ; [THEN]
C" CELL"  FIND NIP 0= [IF] : CELL 1 CELLS ; [THEN]
C" ?COMP" FIND NIP 0= [IF] 
    : ?COMP STATE @ 0= ABORT" Compilation state only" ; [THEN]
C" LATEST" FIND NIP 0= [IF] : LATEST LAST @ ; [THEN]
C" SMUDGE" FIND NIP 0= [IF]
       CREATE C-SMUDGE 12 C,
       : SMUDGE ( => )
         C-SMUDGE C@  LATEST 1+ C@
         C-SMUDGE C!  LATEST 1+ C!  ;
    [THEN]

: ?EXECUTE ?DUP IF EXECUTE THEN ;

VOCABULARY OOP
ALSO OOP DEFINITIONS

SP-FORTH? 0= [IF] : -- CREATE OVER , + DOES> @ + ; [THEN]

0
CELL -- CLASS-WID       \ wid         
CELL -- CLASS-SUPER     \  
CELL -- CLASS-SIZE      \   
CELL -- CLASS-CONSTR    \        
CELL -- CLASS-DESTR     \         
DROP

CONTEXT @
FORTH DEFINITIONS

CREATE SUPERCLASS
    ,               \ wid 
    0 ,             \ parent class
    0 ,             \  
    0 ,             \ 
    0 ,             \ 
OOP DEFINITIONS

\    
SUPERCLASS VALUE CURR 

SP-FORTH?
[IF]
    USER-VALUE this             \   
[ELSE]
    0 VALUE this
[THEN]

SP-FORTH?
[IF]
: xt-field-ext R> @ + ;  \     

: FIELD
    CREATE ['] xt-field-ext COMPILE, 
    CURR CLASS-SIZE @ DUP , + CURR CLASS-SIZE !
    DOES>  >BODY @ this + ;
[ELSE]
: FIELD   
    CREATE
    CURR CLASS-SIZE @ DUP , + CURR CLASS-SIZE !
    DOES> @ this + ;

[THEN]

: CFIELD ( class -- )  \ -
    CLASS-SIZE @ FIELD ;

CELL NEGATE FIELD SELF
CELL        FIELD PARENT

: >CURR CURR SWAP TO CURR ;
: CURR> TO CURR ;

: GENEALOGY ( class -- )
    0 SWAP
    BEGIN ?DUP WHILE
      DUP @ >R
      CLASS-SUPER @
      SWAP 1+ SWAP
    REPEAT
    >R GET-ORDER R>
    BEGIN ?DUP WHILE
      1- SWAP 1+ SWAP
      R> ROT ROT
    REPEAT
    SET-ORDER ;

: ?CLASS 123 -
    [ SP-FORTH? ]
    [IF] -22 ?ERROR 
    [ELSE]
        ABORT" ;CLASS error. Stack destroyed."
    [THEN]
        ;


FORTH DEFINITIONS
ALSO OOP
: REOPEN ( class -- ...)    \   
    >CURR GET-ORDER GET-CURRENT 123 ( this is a tag)
    CURR GENEALOGY DEFINITIONS ;
PREVIOUS
OOP DEFINITIONS

: ;CLASS ?CLASS SET-CURRENT SET-ORDER CURR> ;

: SUPER ( class -- )        \ 
    CURR >R >R ;CLASS
    R> DUP R@ CLASS-SUPER !
    CLASS-SIZE R@ CLASS-SIZE 3 CELLS CMOVE
    R> REOPEN 
;

: <SUPER ' EXECUTE SUPER ;

0 VALUE LAST-M

SP-FORTH?
[IF]
: xt-exit-ext R> TO this ;
: xt-enter-ext R> this >R ['] xt-exit-ext >R >R TO this ;
: xt-enter-int R> >BODY >R ;

: M:
    WARNING @ >R 0 WARNING !
    : HERE TO LAST-M
    POSTPONE xt-enter-int
    POSTPONE xt-enter-ext
    R> WARNING !
;
[ELSE]
: M: WARNING @ >R 0 WARNING !
     : LATEST NAME> TO LAST-M
     R> WARNING ! ;
[THEN]

M: CONSTR PARENT @ CLASS-CONSTR @ ?EXECUTE ;
M: DESTR  PARENT @ CLASS-DESTR @ ?EXECUTE ;
: CONSTR: M: LAST-M CURR CLASS-CONSTR ! ; IMMEDIATE
: DESTR:  M: LAST-M CURR CLASS-DESTR ! ; IMMEDIATE
M: >PARENT PARENT @ @ +ORDER ;    \   
M: SIZE PARENT @ CLASS-SIZE @ ;    \   ( parent)

PREVIOUS DEFINITIONS

: WITH GET-ORDER 124 ' EXECUTE [ ALSO OOP ] GENEALOGY [ PREVIOUS ] ; IMMEDIATE
: ENDWITH 124 - 
    [ SP-FORTH? ] [IF] -22 ?ERROR
        [ELSE] ABORT" ENDWITH error. Stack destroyed" [THEN]
    SET-ORDER ; IMMEDIATE

SP-FORTH?
[IF]

    : ->
        ' >BODY
        STATE @
        IF
            COMPILE, 
        ELSE
            >R
        THEN
    ; IMMEDIATE

[ELSE]
    ALSO OOP DEFINITIONS
\    : M-EXIT R> TO this ;
    : INVOKE-METHOD ( object xt-method -- )
        this >R
        SWAP TO this
        EXECUTE
        R> TO this
    ;
    PREVIOUS DEFINITIONS
    : ->
        WITH SUPERCLASS
            ' 
            STATE @
            IF
                POSTPONE LITERAL
                POSTPONE INVOKE-METHOD
            ELSE
                INVOKE-METHOD
            THEN
        ENDWITH
    ; IMMEDIATE

[THEN]

: CLASS:
    WORDLIST CREATE HERE >R
    , ( wid) SUPERCLASS , 
    0 , ( size) 0 , ( constructor) 0 , ( destructor)
    R> REOPEN
;

SP-FORTH?
[IF]
    : ->CLASS POSTPONE WITH POSTPONE => POSTPONE ENDWITH ; IMMEDIATE
    : OBJECT@ R> CELL+ ;

\    : ORDER>R   \ place search order list to the return stack 
\        R> ( return address)
\        GET-ORDER DUP
\        BEGIN ?DUP WHILE
\          1- ROT >R
\        REPEAT
\        >R >R
\    ;
\    : R>ORDER    \ restore search order list from the return stack
\        R> ( return address)
\        R> DUP
\        BEGIN ?DUP WHILE
\          1- R> ROT ROT
\        REPEAT
\        SET-ORDER
\        >R
\    ;

    : OBJECT: ( class -- )
        WITH SUPERCLASS
            >R
            CREATE IMMEDIATE ['] OBJECT@ COMPILE, 
            R@ , 
            HERE DUP R> CLASS-SIZE @ DUP ALLOT ERASE
            => CONSTR
            DOES>
                CONTEXT >R  \   .  SPF
                DUP >BODY @ GENEALOGY
                STATE @ IF COMPILE, ELSE EXECUTE THEN
                POSTPONE ->
                R> TO CONTEXT \ 
        ENDWITH
    ;
[ELSE]
    : ->CLASS
        STATE @
        IF POSTPONE WITH POSTPONE => POSTPONE ENDWITH
        ELSE ['] WITH EXECUTE
             ['] =>   EXECUTE
             ['] ENDWITH EXECUTE 
        THEN
        ; IMMEDIATE
    : OBJECT: ( class -- )
        WITH SUPERCLASS
            >R
            CREATE IMMEDIATE R@ ,
            HERE DUP R> CLASS-SIZE @ DUP ALLOT ERASE
            => CONSTR
            DOES>
\                ORDER>R
                   GET-ORDER DUP
                   BEGIN ?DUP WHILE
                     1- ROT >R
                   REPEAT >R 
                DUP @ GENEALOGY
                CELL+
                STATE @
                IF
                    POSTPONE LITERAL
                    POSTPONE ->
                ELSE
                    ['] => EXECUTE
                THEN
\                R>ORDER
                   R> DUP
                   BEGIN ?DUP WHILE
                     1- R> ROT ROT
                   REPEAT
                   SET-ORDER
        ENDWITH
    ;
[THEN]

: SUBCLASS: ( class -- ...)
    >R CLASS: R>
    WITH SUPERCLASS
        SUPER
    ENDWITH
;

: NEW ( class -- object )
    WITH SUPERCLASS
        DUP CLASS-SIZE @ CELL+ DUP ALLOCATE THROW >R
        R@ SWAP ERASE R@ !
        R> CELL+ >R R@ => CONSTR R>
    ENDWITH
;    

: DELETE ( address-of-instance -- )
    WITH SUPERCLASS
        >R R@ => DESTR 
\        R@ IMAGE-BASE <
 \       R@ IMAGE-BASE IMAGE-SIZE + > OR
\        IF
            R@ => PARENT FREE THROW
\        THEN
        R> DROP
    ENDWITH 
;

: SIZEOF ( class -- size-of-instance )
    WITH SUPERCLASS
        CLASS-SIZE @
    ENDWITH
;

HERE SWAP - .( Size of class implementation is ) . CR

