(  . Ver 3.02  17.08.2000
 :
 1.   [ ].
 2. .
 3.    .
 4.   

        
        ~~~~~~~~~~ 
 :
    CLASS: class-name     \   
      <size-of-field> FIELD field-name  \  
      ...
      STRUCT: struct-name   \  
        <size-of-field> FIELD str-fld-name
        ...
      ;STRUCT /struct-name  \       

      CONSTR: constructor-name ... ;    \ 
      DESTR: destructor-name ... ;      \ 
      M: method-name ... ;              \ 
    ;CLASS                  \   
    ...
    class-name REOPEN     \  
    ...
    ;CLASS                  \      
    ...

 :
    CLASS: subclass-name <SUPER class-name
    \ 
    class-name SUBCLASS: subclass-name
        <size-of-field> FIELD subclass-field-name
        CONSTR: constructor-name ...
            constructor-name    \    
            ... ;               \    .
        ...
        M: subclass-method-name ... ;
        M: method-name ... method-name ... ;
    ;CLASS

     :
    class-name OBJECT: object-name  \   
    \ 
    0 VALUE p-obj
    class-name NEW TO p-obj         \   
    ...
    object-name field-name @ ...    \   
    object-name method-name ...     \   
    p-obj ->CLASS class-name field-name @ ... 
    p-obj ->CLASS class-name method-name ...
    p-obj DELETE    \   
    ...
    WITH class-name     \       
        p-obj => field-name @ ...
        p-obj => method-name ...
    ENDWITH

    subclass-name OBJECT: object1
    object1 subclass-field-name ...
    object1 field-name ...
    object1 subclass-method-name ...
    object1 method-name ...

 :
    PARENT       -    
    SELF         -    
                        this
)       

HERE 

C" SP-FORTH?" FIND NIP 0= [IF] TRUE CONSTANT SP-FORTH? [THEN]

ONLY FORTH DEFINITIONS


: +ORDER ( wid -- ) >R GET-ORDER 1+ R> SWAP SET-ORDER ;

C" CELL+" FIND NIP 0= [IF] : CELL+ 1 CELLS + ; [THEN]
C" CELL"  FIND NIP 0= [IF] : CELL 1 CELLS ; [THEN]
C" ?COMP" FIND NIP 0= [IF] 
    : ?COMP STATE @ 0= ABORT" Compilation state only" ; [THEN]
C" LATEST" FIND NIP 0= [IF] : LATEST LAST @ ; [THEN]
C" SMUDGE" FIND NIP 0= [IF]
       CREATE C-SMUDGE 12 C,
       : SMUDGE ( => )
         C-SMUDGE C@  LATEST 1+ C@
         C-SMUDGE C!  LATEST 1+ C!  ;
    [THEN]

: ?EXECUTE ?DUP IF EXECUTE THEN ;

VOCABULARY OOP
ALSO OOP DEFINITIONS

SP-FORTH? 0= [IF] : -- CREATE OVER , + DOES> @ + ; [THEN]

0
CELL -- .WID       \ wid         
CELL -- .SUPER     \  
CELL -- .SIZE      \   
CELL -- .CONSTR    \        
CELL -- .DESTR     \         
CELL -- .VMT       \  . 
CELL -- .#VM       \  
CONSTANT /CLASS

CONTEXT @
FORTH DEFINITIONS

CREATE SUPERCLASS
    ,               \ wid 
    0 ,             \ parent class
    0 ,             \  
    0 ,             \ 
    0 ,             \ 
    0 ,             \ vmt
    0 ,             \ #vm
OOP DEFINITIONS

123 CONSTANT CL-TAG
124 CONSTANT WI-TAG
125 CONSTANT VM-TAG
126 CONSTANT M-TAG
127 CONSTANT REC-TAG

\    
SUPERCLASS VALUE CURR 

SP-FORTH?
[IF]
    USER-VALUE this             \   
[ELSE]
    0 VALUE this
[THEN]

SP-FORTH?
[IF]
: >EXT-ENTRY >BODY ;
: ext-field-entry R> 1+ @ + ;  \     

: FIELD
    CREATE
    POSTPONE ext-field-entry
    M-TAG C, 
    CURR .SIZE @ DUP , + CURR .SIZE !
    DOES>  >BODY 1+ @ this + ;
[ELSE]
: FIELD   
    CREATE
    CURR .SIZE @ DUP , + CURR .SIZE !
    DOES> @ this + ;

[THEN]

: CFIELD ( class -- )  \ -
    .SIZE @ FIELD ;

CELL NEGATE FIELD SELF
CELL        FIELD PARENT

SP-FORTH?
[IF]
: RECORD: 0 FIELD HERE 0 , REC-TAG ;
: ;RECORD \ size-rec-name ( addr-rec rec-tag -- )
    REC-TAG - -22 ?ERROR
    CURR .SIZE @ OVER 1 CELLS - @ - DUP CONSTANT
    SWAP !
;
[ELSE]
[THEN]

: >CURR CURR SWAP TO CURR ;
: CURR> TO CURR ;

: GENEALOGY ( class -- )
    0 SWAP
    BEGIN ?DUP WHILE
      DUP @ >R
      .SUPER @
      SWAP 1+ SWAP
    REPEAT
    >R GET-ORDER R>
    BEGIN ?DUP WHILE
      1- SWAP 1+ SWAP
      R> ROT ROT
    REPEAT
    SET-ORDER ;

: ?CLASS CL-TAG -
    [ SP-FORTH? ]
    [IF] -22 ?ERROR 
    [ELSE]
        ABORT" ;CLASS error. Stack destroyed."
    [THEN]
        ;


FORTH DEFINITIONS
ALSO OOP
: REOPEN ( class -- ...)    \   
    >CURR GET-ORDER GET-CURRENT 0 ( #vm) CL-TAG ( this is a tag)
    CURR GENEALOGY DEFINITIONS ;
PREVIOUS
OOP DEFINITIONS

: VMT! ( xt index -- )  CELLS CURR .VMT @ +   ! ;

: VMT ( ... #vm -- )
    ?DUP
    IF 
        HERE >R
        CURR .#VM @   +  DUP CELLS ALLOT  ( ... new-#vm)
        CURR .VMT @  R@  CURR .#VM @ CELLS  CMOVE
        CURR .#VM @  ( ... new-#vm old-#vm) OVER CURR .#VM !
        R> CURR .VMT !
        1+ SWAP
        DO I 1- VMT!  -1 +LOOP
        
    THEN
;
: ;CLASS ?CLASS VMT SET-CURRENT SET-ORDER CURR> ;

: SUPER ( class -- )        \ 
    CURR >R >R ;CLASS
    R> DUP R@ .SUPER !
    .SIZE R@ .SIZE 5 CELLS CMOVE
    R@ .#VM @
    IF
        R@ .VMT @ ( from)
        HERE ( from to)
        R@ .#VM @ CELLS ALLOT
        DUP R@ .VMT !
        R@ .#VM @ CELLS CMOVE
    THEN
    R> REOPEN 
;

: <SUPER ' EXECUTE SUPER ;

0 VALUE LAST-M

SP-FORTH?
[IF]
    : ?METHOD ( xt ) >BODY >BODY C@
        DUP M-TAG = SWAP VM-TAG = OR 
        0= ABORT" is not a class member." ;

    FORTH DEFINITIONS            
    ALSO OOP

    : ->
        ' DUP ?METHOD
        >EXT-ENTRY
        STATE @ IF  COMPILE,  ELSE  >R  THEN ;  IMMEDIATE
    
    DEFINITIONS

: ext-exec ( ... object xt -- )
    this >R  SWAP TO this 
    CATCH R> TO this THROW ;
: ext-entry R> 1+  ext-exec ;
: int-entry R> >BODY 1+ >R ;

: M:
    : HERE TO LAST-M
    POSTPONE int-entry
    POSTPONE ext-entry
    M-TAG C, 
;

: VM-xt ( addr object -- xt )
    1 CELLS - @ .VMT @  SWAP @ + @ ;

: vm-ext-entry ( object -- )
    R> ( 'vm-tag)   1+ ( 'offset)
    OVER VM-xt ext-exec ;
: vm-int-entry  R> >BODY 1+ this VM-xt >R ;

: VM ( -- offs t= | -- f=)
    >IN @  BL WORD FIND  
    IF >BODY >BODY DUP C@ VM-TAG =
       IF  1+ @ NIP TRUE EXIT THEN
    THEN
    DROP >IN ! FALSE
;

: VM: 
    VM IF :NONAME SWAP CURR .VMT @ + !
    ELSE : HERE TO LAST-M
        POSTPONE vm-int-entry
        POSTPONE vm-ext-entry  VM-TAG C, 
        ?CLASS
        DUP CURR .#VM @ + CELLS , 
        1+  HERE SWAP
        CL-TAG
    THEN
;


[ELSE]

\    : M-EXIT R> TO this ;
    : INVOKE-METHOD ( object xt-method -- )
        this >R
        SWAP TO this
        EXECUTE
        R> TO this
    ;
    FORTH DEFINITIONS
    : ->
        [ ALSO OOP ]
            ' 
            STATE @
            IF
                POSTPONE LITERAL
                POSTPONE INVOKE-METHOD
            ELSE
                INVOKE-METHOD
            THEN
        [ PREVIOUS ]
    ; IMMEDIATE
    ALSO OOP DEFINITIONS

    : M: WARNING @ >R 0 WARNING !
        : LATEST NAME> TO LAST-M
        R> WARNING ! ;
[THEN]

M: CONSTR PARENT @ .CONSTR @ ?EXECUTE ;
M: DESTR  PARENT @ .DESTR @ ?EXECUTE ;
: CONSTR: M: LAST-M CURR .CONSTR ! ; IMMEDIATE
: DESTR:  M: LAST-M CURR .DESTR ! ; IMMEDIATE
M: >PARENT PARENT @ @ +ORDER ;    \   
M: SIZE PARENT @ .SIZE @ ;    \   ( parent)

PREVIOUS DEFINITIONS
ALSO OOP
: WITH GET-ORDER  WI-TAG ' EXECUTE GENEALOGY ; IMMEDIATE
: ENDWITH WI-TAG - 
    [ SP-FORTH? ] [IF] -22 ?ERROR
        [ELSE] ABORT" ENDWITH error. Stack destroyed" [THEN]
    SET-ORDER ; IMMEDIATE
PREVIOUS


ALSO OOP
: CLASS:
    WORDLIST CREATE HERE >R
    , ( wid) SUPERCLASS , 
    SUPERCLASS 2 CELLS +
    HERE /CLASS 2 CELLS - DUP ALLOT CMOVE
    R> REOPEN
;
PREVIOUS 

SP-FORTH?
[IF]
    : ->CLASS
        STATE @ 
        IF
            POSTPONE WITH     POSTPONE =>   POSTPONE ENDWITH
        ELSE  >R
            POSTPONE WITH  R> POSTPONE =>   POSTPONE ENDWITH
        THEN
        ; IMMEDIATE

    : OBJECT@ R> CELL+ ;

    : OBJECT: ( class -- )
        WITH SUPERCLASS
            >R
            CREATE
            IMMEDIATE ['] OBJECT@ COMPILE, 
            R@ , 
            HERE DUP R> .SIZE @ DUP ALLOT ERASE
            => CONSTR
            DOES>
                CONTEXT >R  \   .  SPF
                DUP >BODY @ GENEALOGY
                STATE @ IF COMPILE, ELSE EXECUTE THEN
                POSTPONE ->
                R> TO CONTEXT \ 
        ENDWITH
    ;

[ELSE]
    : ->CLASS
        STATE @
        IF POSTPONE WITH POSTPONE => POSTPONE ENDWITH
        ELSE ['] WITH EXECUTE
             ['] =>   EXECUTE
             ['] ENDWITH EXECUTE 
        THEN
        ; IMMEDIATE
    : OBJECT: ( class -- )
        WITH SUPERCLASS
            >R
            CREATE IMMEDIATE R@ ,
            HERE DUP R> .SIZE @ DUP ALLOT ERASE
            => CONSTR
            DOES>
\                ORDER>R
                   GET-ORDER DUP
                   BEGIN ?DUP WHILE
                     1- ROT >R
                   REPEAT >R 
                DUP @ GENEALOGY
                CELL+
                STATE @
                IF
                    POSTPONE LITERAL
                    POSTPONE ->
                ELSE
                    ['] => EXECUTE
                THEN
\                R>ORDER
                   R> DUP
                   BEGIN ?DUP WHILE
                     1- R> ROT ROT
                   REPEAT
                   SET-ORDER
        ENDWITH
    ;
[THEN]

: SUBCLASS: ( class -- ...)
    >R CLASS: R>
    WITH SUPERCLASS
        SUPER
    ENDWITH
;

: NEW ( class -- object )
    WITH SUPERCLASS
        DUP .SIZE @ CELL+ DUP ALLOCATE THROW >R
        R@ SWAP ERASE R@ !
        R> CELL+ >R R@ => CONSTR R>
    ENDWITH
;    

: DELETE ( address-of-instance -- )
    WITH SUPERCLASS
        >R R@ => DESTR 
\        R@ IMAGE-BASE <
 \       R@ IMAGE-BASE IMAGE-SIZE + > OR
\        IF
            R@ => PARENT FREE THROW
\        THEN
        R> DROP
    ENDWITH 
;

: SIZEOF ( class -- size-of-instance )
    WITH SUPERCLASS
        .SIZE @
    ENDWITH
;

HERE SWAP - .( Size of class implementation is ) . CR

