
TRUE CONSTANT SP-FORTH?

S" class.f" INCLUDED
S" pointer.f" INCLUDED
S" list.f" INCLUDED

HERE
CLASS: REAL-OBJECT
    CELL FIELD name       \ 
    CELL FIELD prt        \ 
    M: name!
        DUP 2 + ALLOCATE THROW name !
        DUP name @ C!
        name @ 1+ SWAP CMOVE
        0 name @ COUNT + C!  ;
    M: PRINT name @ COUNT TYPE ;
    CONSTR: CONSTRUCTOR ( S" NAME" --)
        name!
        ['] PRINT prt !
    ;
    DESTR: DESTRUCTOR  name @ FREE THROW ;
    M: EXEC-PRINT prt @ EXECUTE ;
;CLASS

REAL-OBJECT
SUBCLASS: MATTER       \ 
    CELL FIELD density    \  /3
    M: PRINT ." Matter: " PRINT CR
        ." Density is " density @ . CR
    ;
    CONSTR: CONSTRUCTOR ( density S" NAME" --)
        CONSTRUCTOR \  INHERIT
        density !
        ['] PRINT prt !
        ;
;CLASS

CLASS: BODY   <SUPER REAL-OBJECT       \ 
    CELL FIELD mass       \ 
    CELL FIELD volume     \ 
    CELL FIELD matt     \   ,     
    M: PRINT
        ." Body: " PRINT CR
        matt @ ->CLASS MATTER PRINT
        ." Volume is " volume @ . ." , "
        ." mass is " mass @ . CR
    ;
    CONSTR: CONSTRUCTOR ( mass volume matter S" name" )
        CONSTRUCTOR  \  INHERIT
        ['] PRINT prt !
        matt !
        volume !
        mass !
    ;
;CLASS

2000 S" iron" MATTER OBJECT: IRON
1000 S" water" MATTER OBJECT: WATER

CLASS: IRON-CUBE <SUPER BODY
    CELL FIELD edge
    CONSTR: CONSTRUCTOR  ( edge --)
        edge !
        edge @ DUP DUP * *
        DUP IRON density @ *
        SWAP
        IRON SELF
        S" iron cube"
        CONSTRUCTOR \  INHERIT
    ;
;CLASS

2 IRON-CUBE OBJECT: CUBE1 
3 IRON-CUBE OBJECT: CUBE2

3000 S" cast iron" MATTER NEW VALUE CAST-IRON
LIST OBJECT: L1
CUBE1 SELF L1 APPEND
CUBE2 SELF L1 APPEND
IRON  SELF L1 ADD
WATER SELF L1 APPEND
CAST-IRON  L1 APPEND

HERE SWAP - .( Size of TEST is ) . CR

: PP ( addr-instance -- )
    ." ---------------------------" CR
    ->CLASS REAL-OBJECT EXEC-PRINT
;

' PP L1 FOR-EACH

IRON-CUBE POINTER P
100 IRON-CUBE NEW TO P
P PRINT