\  
\ :
\ 1. .
\ 2.    .

       

ONLY FORTH DEFINITIONS

\ S" search-wordlist.f" INCLUDED    \  
S" high-level-search-wordlist.f" INCLUDED   \  
                                            \  ,  
                                            \     5 
' CLASS-SEARCH-WORDLIST ' SEARCH-WORDLIST JMP

HERE 
ONLY FORTH DEFINITIONS
: +ORDER ( wid -- ) >R GET-ORDER 1+ R> SWAP SET-ORDER ;
: FEX FIND IF EXECUTE THEN ;
: FEX2 FIND IF CFL + EXECUTE THEN ;
: WITH ALSO ' EXECUTE ; IMMEDIATE
: ENDWITH PREVIOUS ; IMMEDIATE

VOCABULARY SUPERCLASS
ALSO SUPERCLASS DEFINITIONS

USER-VALUE this
VARIABLE size       \  ;    
                    \  

: size@ C" size" FEX @ ;
: size! C" size" FEX ! ;


: xt-item-ext R> @ + ;  \     

: FIELD
    CREATE ['] xt-item-ext COMPILE, 
    size@ DUP , + size!
    DOES> CFL + @ this + ;

1 CELLS NEGATE FIELD SELF
1 CELLS        FIELD PARENT

: (DERIVE) ( xt -- )        \ 
    ALSO EXECUTE
    CONTEXT @ CURRENT @ CLASS!
    size@
    PREVIOUS
    size!
;

: DERIVE ' (DERIVE) ;

: ;CLASS PREVIOUS SET-CURRENT ;
: xt-exit-ext R> TO this ;
: xt-enter-ext R> this >R ['] xt-exit-ext >R >R TO this ;
: xt-enter-int R> CFL + >R ;

: M:
    WARNING @ WARNING 0!
    :
    POSTPONE xt-enter-int
    POSTPONE xt-enter-ext
    WARNING !
;

M: CONSTRUCTOR ;
M: DESTRUCTOR ;
M: >PARENT PARENT @ +ORDER ;    \   
M: SIZE >PARENT size@ PREVIOUS ;    \   ( parent)

: INHERIT
    ?COMP
    SMUDGE
    LATEST COUNT >R PAD 1+ R@ CMOVE R> PAD C!
    SMUDGE     
    PAD FIND
    IF COMPILE, THEN
; IMMEDIATE

: CONSTR C" CONSTRUCTOR" FEX2 ;
: DESTR C" DESTRUCTOR" FEX2 ;
: (NEW) ( xt -- address-of-instance )
    ALSO EXECUTE
    size@ CELL+ ALLOCATE THROW
    CONTEXT @ OVER !
    CELL+
    >R R@ CONSTR R>
    PREVIOUS
;    
    
PREVIOUS DEFINITIONS

: CLASS: GET-CURRENT
    VOCABULARY
    ALSO LATEST NAME> EXECUTE DEFINITIONS
    S" VARIABLE size" EVALUATE
    WITH SUPERCLASS
        ['] SUPERCLASS (DERIVE)
    ENDWITH
;

: ->
    ' CFL + 
    STATE @
    IF
        COMPILE, 
    ELSE
        EXECUTE
    THEN
; IMMEDIATE

: SEE-> POSTPONE WITH POSTPONE => POSTPONE ENDWITH ; IMMEDIATE

: INSTANCE
    WITH SUPERCLASS
      POSTPONE WITH
      CREATE IMMEDIATE
      CONTEXT @ , 
      HERE DUP size@ DUP ALLOT ERASE
      CONSTR
      POSTPONE ENDWITH
      DOES>
          DUP @ +ORDER
          CELL+ POSTPONE LITERAL
          POSTPONE ->
          PREVIOUS
    ENDWITH
;

: NEW
    WITH SUPERCLASS
        ' POSTPONE LITERAL
        ['] (NEW) STATE @ IF COMPILE, ELSE EXECUTE THEN
    ENDWITH
; IMMEDIATE

: DELETE ( address-of-instance -- )
    WITH SUPERCLASS
        >R R@ => >PARENT R@ DESTR PREVIOUS
        R@ IMAGE-BASE <
        R@ IMAGE-BASE IMAGE-SIZE + > OR
        IF
            R@ => PARENT FREE THROW
        THEN
        RDROP
    ENDWITH 
;


HERE SWAP - .( Size of class implementation is ) . CR