REQUIRE TEMP-MEMORY ~nn/lib/tempalloc.f

0 [IF]
\ USER-VALUE toOEMbuf
\ WINAPI: CharToOemBuffA USER32.DLL

: toOEM ( a u -- a u ) 
    DUP 1024 MIN ROT
    toOEMbuf ?DUP 0= IF 1024 ALLOCATE THROW DUP TO toOEMbuf THEN
    SWAP CharToOemBuffA DROP 
    toOEMbuf SWAP 2DUP + 0 SWAP C!
;
[THEN]

: toOEM ( a u -- a u ) 
\    toOEMbuf ?DUP IF FREE DROP THEN
    DUP CELL+ TEMP-ALLOC >R \ ALLOCATE THROW TO toOEMbuf
    DUP ROT R@ SWAP CharToOemBuffA DROP 
    R> SWAP 2DUP + 0 SWAP C!
;

: toANSI ( a u -- a u ) 
\    toOEMbuf ?DUP IF FREE DROP THEN
    DUP CELL+ TEMP-ALLOC >R \ ALLOCATE THROW TO toOEMbuf
    DUP ROT R@ SWAP OemToCharBuffA DROP 
    R> SWAP 2DUP + 0 SWAP C!
;

' toOEM TO ANSI><OEM

( 
REQUIRE ?MS ~nn/lib/timer.f
: test
    TIMER-RESET
    PAD 512 [CHAR]  FILL
    1000000 0 DO PAD 512 toOEM 2DROP LOOP
    .ELAPSED
;
test
)