\ Exception processing
\ Usage:
\ : my_word
\     try
\        ( sequence of not reliable words)
\     exception ( error-code -- )
\        ( exception processing)
\     endtry
\ ;

: (try) 
    R@ CFL + CFL + CATCH ?DUP
    IF R> CFL + >R THEN
;

: try 
    ?COMP
    POSTPONE (try)
    HERE BRANCH, >MARK 2
    HERE BRANCH, >MARK 2
; IMMEDIATE

: exception
    ?COMP
    RET, >RESOLVE
; IMMEDIATE

: endtry
    ?COMP
    >RESOLVE
; IMMEDIATE

\ example
1 [IF]
: div ?DUP 0= IF 1000 THROW THEN / ;

: test1  ( divident divisor -- quotient )
    try
        div
    exception
        CR ." Error # " . CR ( err code)
        2DROP
        ." Divide by thero"
        -1
    endtry
;
100 3 div .  CR
5 0 div . CR


[THEN]