REQUIRE { ~nn/lib/locals.f
REQUIRE S>ZALLOC ~nn/lib/az.f
REQUIRE ENV ~nn/lib/env.f

\ HINSTANCE FindExecutable(
\    LPCTSTR lpFile,
\    LPCTSTR lpDirectory,
\    LPTSTR lpResult
\ );

WINAPI: FindExecutableA shell32.dll

: get-ext { ext ext_l ext_i -- a u ext_i1 }
    ext_i ext_l <
    IF
        ext ext_i +
        DUP
        BEGIN DUP C@ DUP 0= SWAP [CHAR] ; = OR 0= WHILE
          1+ 
        REPEAT
        DUP ext - 1+ TO ext_i
        OVER - 
    ELSE
        S" "
    THEN
    ext_i
;

: FindExecutableExt { buf dir p \ p1 p_l ext ext_l ext_i -- res } 
    S" PATHEXT" ENV TO ext_l TO ext
    0 TO ext_i
    p ASCIIZ> DUP TO p_l 
    p_l ext_l + CELL+ ALLOCATE THROW TO p1
    p1 ZPLACE
    BEGIN 
\        p1 ASCIIZ> TYPE CR
        buf dir p1 FindExecutableA DUP 32 > 0=
    WHILE
        DROP
\        p1 FREE DROP
        ext ext_l ext_i get-ext TO ext_i
        ( a u )
        ?DUP
        IF
\            p_l OVER + CELL+ ALLOCATE THROW TO p1
\            p p_l p1 ZPLACE
            p1 p_l + ZPLACE
        ELSE
            DROP
            2 EXIT
        THEN
    REPEAT
    p1 FREE DROP
;

: EXE-PATH { cmd u1 dir u2 \ buf p i res -- exe-path u3 }
    cmd u1 S>ZALLOC TO p
    u2 IF 0 dir u2 + C! THEN
    1024 ALLOCATE THROW TO buf
    0 TO res
    p
    BEGIN DUP C@ WHILE
      DUP C@ BL = 
      IF
         0 OVER C!
         buf dir p FindExecutableExt 32 >
         IF
            buf ASCIIZ> S>ZALLOC TO res
         ELSE
            BL OVER C!
            1+
         THEN
      ELSE
         1+
      THEN
    REPEAT
    DROP
    res 0= IF 
              buf dir p FindExecutableExt 32 >
              IF
                 buf ASCIIZ> S>ZALLOC TO res
              THEN
           THEN
    p FREE DROP
    buf FREE DROP
    res ?DUP IF ASCIIZ> ELSE S" " THEN
;

REQUIRE <EOF> ~nn/lib/eof.f

\ <EOF>
: test
    S" which" 0 0 EXE-PATH TYPE CR
;
test

