\ <EOF>
\ S" ~nn/LIB/WINCON.F" INCLUDED

REQUIRE ENV ~nn/lib/env.f

WINAPI: SHGetMalloc shell32.dll
\ HRESULT SHGetMalloc( LPMALLOC *ppMalloc);

WINAPI: SHGetSpecialFolderLocation shell32.dll
\ WINSHELLAPI HRESULT WINAPI SHGetSpecialFolderLocation(
\    HWND hwndOwner,  int nFolder, LPITEMIDLIST *ppidl);  

WINAPI: SHGetPathFromIDListA SHELL32.DLL

\ WINSHELLAPI BOOL WINAPI SHGetPathFromIDList(
\    LPCITEMIDLIST pidl, LPSTR pszPath );


VARIABLE pMalloc
USER pIDL

: GetSpecialFolder ( folder-id -- a u )
    PAD 0!
    pMalloc @ 0= IF pMalloc SHGetMalloc  IF S" ." EXIT THEN THEN
    pIDL SWAP 0 SHGetSpecialFolderLocation IF S" ." EXIT THEN
    PAD pIDL @ SHGetPathFromIDListA DROP
    PAD ASCIIZ>
;



\ _vFolder_AppData    Contains path to the application data folder.
: FOLDER-APP-DATA CSIDL_APPDATA GetSpecialFolder ;

\ _vFolder_CommonDesktop  Contains path to the all users desktop folder.
: FOLDER-COMMON-DESKTOP CSIDL_COMMON_DESKTOPDIRECTORY GetSpecialFolder ;

\ _vFolder_CommonPrograms Contains path to the all users start menu programs folder.
: FOLDER-COMMON-PROGRAMS CSIDL_COMMON_PROGRAMS GetSpecialFolder ;

\ _vFolder_CommonStartMenu  Contains path to the all users start menu folder.
: FOLDER-COMMON-STARTMENU CSIDL_COMMON_STARTMENU GetSpecialFolder ;

\ _vFolder_Cookies    Contains path to the cookies folder.
\ : FOLDER-COOKIES CSIDL_COOKIES GetSpecialFolder ;

\ _vFolder_Desktop    Contains path to the desktop folder.
: FOLDER-DESKTOP CSIDL_DESKTOP  GetSpecialFolder ;

\ _vFolder_Favourites Contains path to the favourites folder.
: FOLDER-FAVOURITES CSIDL_FAVORITES GetSpecialFolder ;

\ _vFolder_Personal   Contains path to the personal folder.
: FOLDER-PERSONAL CSIDL_PERSONAL  GetSpecialFolder ;

\ _vFolder_Programs   Contains path to the start menu programs folder.
: FOLDER-PROGRAMS CSIDL_PROGRAMS GetSpecialFolder ;

\ _vFolder_Recent Contains path to the recent files folder.
: FOLDER-RECENT CSIDL_RECENT GetSpecialFolder ;

\ _vFolder_SendTo Contains path to the "send to" folder.
: FOLDER-SENDTO CSIDL_SENDTO GetSpecialFolder ;

\ _vFolder_StartMenu  Contains path to the start menu folder.
: FOLDER-STARTMENU CSIDL_STARTMENU GetSpecialFolder ;

\ _vFolder_Startup    Contains path to the start menu start up folder.
: FOLDER-STARTUP CSIDL_STARTUP GetSpecialFolder ;

\ _vFolder_Templates  Contains path to the templates folder.
: FOLDER-TEMPLATES CSIDL_TEMPLATES GetSpecialFolder ;

\ : ENV ( a u -- a1 u1) DROP 1024 PAD ROT GetEnvironmentVariableA
\    ?DUP 0= IF S" ." ELSE PAD SWAP THEN ;

\ _vFolder_Temp   Contains path to the temporary folder.
: FOLDER-TEMP S" TEMP" ENV ;

\ _vFolder_Windows    Contains path to the windows folder.
\ : FOLDER-WINDOWS CSIDL_WINDOWS GetSpecialFolder ;
: FOLDER-WINDOWS WinNT? IF S" SystemRoot" ELSE S" windir" THEN ENV ;

\ _vFolder_System Contains path to the system folder.
\ : FOLDER-SYSTEM CSIDL_SYSTEM GetSpecialFolder ;
: FOLDER-SYSTEM FOLDER-WINDOWS ;


<EOF>
: ?? TYPE CR ;
: TEST
FOLDER-APP-DATA ??
FOLDER-COMMON-DESKTOP ??
FOLDER-COMMON-PROGRAMS ??
FOLDER-COMMON-STARTMENU 
\ FOLDER-COOKIES ??
FOLDER-DESKTOP ??
FOLDER-FAVOURITES ??
FOLDER-PERSONAL ??
FOLDER-PROGRAMS ??
FOLDER-RECENT ??
FOLDER-SENDTO ??
FOLDER-STARTMENU ??
FOLDER-STARTUP ??
FOLDER-TEMPLATES ??
FOLDER-WINDOWS ??
FOLDER-SYSTEM ??
FOLDER-TEMP ??
;
TEST