\ [:NONAME
\  ( C: -- sys ) "bracket-colon-noname"
\ start compilation of a nameless definition within
\ the current definition

\ ;]
\  ( C: sys -- ) ( S: -- xt ) "semi[colon]-bracket"
\ finish compilation of the nameless definition started 
\ with [:NONAME . Leave xt on the stack.

: [:NONAME
        CSP @
        [COMPILE] AHEAD
        LATEST IT 2>R
        [COMPILE] [
        :NONAME
        2R> $10ca1c01
; IMMEDIATE
: ;]
        $10ca1c01 ?PAIRS
        2>R [COMPILE] ;
        2R> TO IT TO LATEST
        [COMPILE] ]
        >R
           [COMPILE] THEN
           CSP !
        R>
; IMMEDIATE

\ Typical use:

DEFER xyz
: foo
        ...
        [:NONAME bla bla bla ;] LITERAL TO xyz
        ...
;

\ In principle, one can do something else with it, e.g.

DEFER do-it
DEFER xyz
DEFER zyx

: bar
        [:NONAME bla bla bla ;] [ DUP TO do-it ]
        [ DUP ] LITERAL TO xyz
                LITERAL TO zyx
;
