REQUIRE SocketLine ~nn/lib/net/socketline.f
REQUIRE DEBUG? ~nn/lib/qdebug.f
REQUIRE HOLDS lib/ext/string.f
REQUIRE <TIB ~nn/lib/tib.f
( 

CREATE sbuf 32 ALLOT
: xx 
    HLD @ DUP >R
    ?DUP IF sbuf 32 CMOVE THEN
    CR .  ." Depth " DEPTH . .S
    sbuf R> DUP HLD ! ?DUP IF 32 CMOVE ELSE DROP THEN
     ;
)

CLASS: POP3 <SUPER SocketLine
    var vUser
    var vPass
    var vLine
    var vLen

    CONSTR: init 
        init 110 vPort ! ;


    M: write ( addr u -- )
\        [ DEBUG? ] [IF] 2DUP TYPE CR [THEN]
        WriteLine ;

    M: read ( -- a u )
        ReadLine DUP vLen ! OVER vLine !
\        [ DEBUG? ] [IF] 2DUP TYPE CR [THEN]  
        ;

    M: replyERR ( -- !flag )
        read IF C@ [CHAR] - = ELSE DROP TRUE THEN ;

    : 0#> 0. #> ;
    M: Login ( a-name u1 a-pass u2 -- flag )
        S>ZALLOC vPass !
        S>ZALLOC vUser !
        Create
        Connect
        replyERR IF FALSE EXIT THEN
        <# vUser @ ASCIIZ> HOLDS S" USER " HOLDS 0#> write 
        replyERR IF FALSE EXIT THEN
        <# vPass @ ASCIIZ> HOLDS S" PASS " HOLDS 0#> write
        replyERR 0= ;

    M: Logout
        <# S" QUIT" HOLDS 0#> write
        replyERR DROP
        Close
    ;

    : NUM: 0 0 BL WORD COUNT >NUMBER 2DROP D>S ;

    M: Stat ( -- cnt )
        <# S" STAT" HOLDS 0#> write
        replyERR IF 0 EXIT THEN
        vLine @ vLen @  <TIB BL WORD DROP NUM: TIB> ;
;CLASS
