REQUIRE DEBUG? ~nn/lib/qdebug.f
REQUIRE CLASS: ~nn/class/class.f
REQUIRE <EOF>  ~nn/lib/eof.f
REQUIRE ICOMPARE agents/pop3rules/wcmatch.f
REQUIRE ZPLACE ~nn/lib/az.f

WINAPI: RasDialA               RASAPI32.DLL
WINAPI: RasHangUpA             RASAPI32.DLL
WINAPI: RasEnumConnectionsA    RASAPI32.DLL
WINAPI: RasGetErrorStringA     RASAPI32.DLL


CLASS: RASConn
    RECORD: RASDIALPARAMS
        var dwSize
    257 chars szEntryName
    129 chars szPhoneNumber
    129 chars szCallbackNumber
    257 chars szUserName
    257 chars szPassword
     19 chars szDomain
        var dwSubEntry
        var dwCallbackId
    ;RECORD /RASDIALPARAMS

    var SAVE-SP
    var lpcConnections
    var lpcb
    var HRASCONN
    var Error
    var Attempts
    var Pause

    0    
    1 CELLS -- rc-dwSize
    1 CELLS -- rc-hrasconn
    257     -- rc-szEntryName
    DROP
    412 CONSTANT /RASCONN

(  0
  4 -- RASCONNSTATUS.dwSize
  4 -- RASCONNSTATUS.rasconnstate
  4 -- RASCONNSTATUS.dwError
257 -- RASCONNSTATUS.szDeviceType
257 -- RASCONNSTATUS.szDeviceName
\ CONSTANT /RASCONNSTATUS
160 CONSTANT /RASCONNSTATUS
)


CONSTR: init    1 Attempts ! 30 Pause !  /RASDIALPARAMS dwSize ! ;
DESTR: free ;

: MyConnection? ( a u -- ?)  szEntryName ASCIIZ>  ICOMPARE 0= ;

M: Online ( -- ?)
  SP@ SAVE-SP ! \ ⨢  RasEnumConnections
  10000 lpcb ! lpcConnections 0!
  lpcConnections lpcb 10000 ALLOCATE THROW >R
  R@ /RASCONN ERASE
  /RASCONN R@ !
  R@ RasEnumConnectionsA 0=
  lpcConnections @ 0 > AND
  IF ( ᮥ ⠭, ஢ 㦭 )
    SAVE-SP @ SP!
    R@ lpcConnections @ /RASCONN * +  R@
    ?DO
      I rc-szEntryName ASCIIZ> MyConnection?
      IF
        I rc-hrasconn @ HRASCONN !
        UNLOOP R> FREE DROP TRUE EXIT
      THEN
    /RASCONN +LOOP
    DROP
  ELSE
    SAVE-SP @ SP!
  THEN
  FALSE
  R> FREE THROW
;


M: User! ( addr u --)   szUserName ZPLACE ;
M: Password!            szPassword ZPLACE ;
M: Domain!              szDomain ZPLACE ;
M: Entry!               szEntryName ZPLACE ;
M: Phone!               szPhoneNumber ZPLACE ;

DEBUG?
[IF]
: .Z ." <" ASCIIZ> TYPE ." >" CR ; 
: .RDP
    ." RAS Parameters" CR
    ." EntryName: "        szEntryName         .Z
    ." PhoneNumber: "      szPhoneNumber       .Z
    ." CallbackNumber: "   szCallbackNumber    .Z
    ." UserName: "         szUserName          .Z
    ." Password: "         szPassword          .Z
    ." Domain: "           szDomain            .Z
;
[THEN]

M: Dial ( -- ?)
    Attempts @ 0
    ?DO
        HRASCONN 0!
        HRASCONN 0 0 RASDIALPARAMS 0 0 RasDialA
        DUP Error !
        IF 
            I 1+ Attempts @ <> IF Pause @ 1000 * PAUSE THEN 
        ELSE
            LEAVE
        THEN
    LOOP
    Error @ 0=
;

M: Hangup ( -- )
    Error 0!
    Online
    IF
        HRASCONN @ RasHangUpA Error !
    THEN
;

;CLASS

<EOF>
RASConn POINTER r
: TEST
    RASConn NEW TO r
    S" PSC" r Entry!
    S" Nicholas" r User!
    S" xxxxxxxx" r Password!
    r Dial .
;