S" ~nn\lib\services.f" INCLUDED

\      API  
\ .   :

\ 1. OpenSCManager
\ 2. OpenService
\ 3. StartService    ControlService  
\ 4. CloseServiceHandle(hService)
\ 5. CloseServiceHandle(hSCM)

\       MSDN,     
\    .

HEX
00010000 CONSTANT DELETE_SVC
DECIMAL


: doDeleteService ( addr u -- ior )
  2>R DELETE_SVC 2R> DROP
  SC_MANAGER_ALL_ACCESS 0 0 OpenSCManagerA DUP >R
  OpenServiceA DUP >R DeleteService
  R> CloseServiceHandle DROP
  R> CloseServiceHandle DROP
;

: doCreateService ( addr u -- )
  2DUP doDeleteService DROP
  2>R
  0 0 0 0 0
  ModuleName DROP
  SERVICE_ERROR_NORMAL SERVICE_AUTO_START   \ SERVICE_DEMAND_START 
  SERVICE_WIN32_OWN_PROCESS SERVICE_INTERACTIVE_PROCESS OR
  SERVICE_ALL_ACCESS
  2R@ DROP
  2R> DROP
  SC_MANAGER_ALL_ACCESS 0 0 OpenSCManagerA
  CreateServiceA
;

\ ***********************
VARIABLE CtrlHandler

:NONAME ( fdwControl -- )
  \   
  \   =1  =4
  DUP SERVICE_CONTROL_STOP = SWAP SERVICE_CONTROL_SHUTDOWN = OR
  IF
    SERVICE_WIN32 SERVICE_INTERACTIVE_PROCESS OR
                        SERVICE_STATUS dwServiceType !
    SERVICE_STOPPED     SERVICE_STATUS dwCurrentState !
    SERVICE_ACCEPT_STOP SERVICE_ACCEPT_SHUTDOWN OR
        SERVICE_STATUS dwControlsAccepted !
    SERVICE_STATUS CtrlHandler @ SetServiceStatus DROP
  THEN 0
; WNDPROC: ServiceControlHandler

0 VALUE SERVICE_TABLE

VECT ServiceProc  ' NOOP TO ServiceProc

:NONAME  ( dwArgc *lpszArgv -- )
  2DROP

  R>
  RP@ 100 - RP!
  >R
  SP@ 100 - SP!

  SERVICE_WIN32 SERVICE_INTERACTIVE_PROCESS OR
                      SERVICE_STATUS dwServiceType !
  SERVICE_RUNNING     SERVICE_STATUS dwCurrentState !
  SERVICE_ACCEPT_STOP SERVICE_ACCEPT_SHUTDOWN OR
    SERVICE_STATUS dwControlsAccepted !

  ['] ServiceControlHandler SERVICE_TABLE @ \    
  RegisterServiceCtrlHandlerA DUP CtrlHandler !  \    Win95
  SERVICE_STATUS SWAP SetServiceStatus DROP      \  

  ServiceProc
  -1 Sleep DROP
; WNDPROC: ServiceMain

: doStartService ( addr u -- flag )
  HERE DUP >R SWAP DUP ALLOT MOVE 0 C,
  HERE TO SERVICE_TABLE R> , ['] ServiceMain , 0 , 0 ,
  SERVICE_TABLE StartServiceCtrlDispatcherA 0=
  ( flag=true   ,  Win95 
        -  )
;

: DoStopService { a u \ hsc hs -- }
  SERVICE_STOP a 
  SC_MANAGER_ALL_ACCESS 0 0 OpenSCManagerA ( DUP .) DUP TO hsc
  OpenServiceA ( DUP .) TO hs 
  PAD SERVICE_CONTROL_STOP hs ControlService ( DUP .) DROP
\  GetLastError . CR
  hs CloseServiceHandle DROP
  hsc CloseServiceHandle DROP
;
