REQUIRE S>ZALLOC ~nn/lib/az.f
REQUIRE /STARTUPINFO ~nn/lib/process.f
REQUIRE AZ>UNICODE ~nn/lib/unicode.f

\ WINAPI: WaitForSingleObject KERNEL32.DLL

\ BOOL CreateProcessWithLogonW(
\   LPCWSTR lpUsername,                 // user's name
\   LPCWSTR lpDomain,                   // user's domain
\   LPCWSTR lpPassword,                 // user's password
\   DWORD dwLogonFlags,                 // logon option
\   LPCWSTR lpApplicationName,          // executable module name
\   LPWSTR lpCommandLine,               // command-line string
\   DWORD dwCreationFlags,              // creation flags
\   LPVOID lpEnvironment,               // new environment block
\   LPCWSTR lpCurrentDirectory,         // current directory name
\   LPSTARTUPINFOW lpStartupInfo,       // startup information
\   LPPROCESS_INFORMATION lpProcessInfo // process information
\ );


: (StartAppLogon0) { si cmd u1 user u2 pass u3 domain u4 flags \ si0? wuser wpass wdomain wdir wcmd -- ? }
    -1 TO ExitCodeProc
    si 0= TO si0?
    si 0= IF /STARTUPINFO ALLOCATE THROW
            DUP /STARTUPINFO ERASE
            TO si THEN
    /STARTUPINFO si cb !

    APP-pi  si
    APP-Dir @ AZ>UNICODE DUP TO wdir
    0 \ env
    APP-Flags @ ( ." Priority: " DUP . CR) APP-Flags 0! \ creation flags
    cmd u1 S>UNICODE DROP DUP TO wcmd
    0 \ app name
    flags
    pass u3 S>UNICODE DROP DUP TO wpass
    domain u4 S>UNICODE DROP DUP TO wdomain
    user u2  S>UNICODE DROP DUP TO wuser
    [ DEBUG? ] [IF] ." before" .S [THEN]
    CreateProcessWithLogonW \ DUP . CR
    [ DEBUG? ] [IF] ." after" .S [THEN]
    si0? IF si FREE DROP THEN
    wuser FREE DROP    wpass FREE DROP    wdomain FREE DROP    wdir FREE DROP
    APP-Dir @ ?DUP IF FREE DROP THEN APP-Dir 0!
;

: (StartAppLogon) ( 'startup-info S" app" user u2 pass u3 domain u4 flags -- ? )
    (StartAppLogon0) DUP (epilog)
;

: StartAppLogon ( 'startup-info S" application.exe" user u2 pass u3 domain u4 flags  -- flag )
    APP-WAIT? 0!
    (StartAppLogon) ;

: StartAppLogonNC ( 'startup-info S" application.exe" user u2 pass u3 domain u4 flags  -- flag )
    APP-WAIT? 0!
    (StartAppLogon0) ;

: StartAppLogonWait ( 'startup-info S" application.exe" user u2 pass u3 domain u4 flags  -- flag )
    TRUE APP-WAIT? !
    (StartAppLogon) ;

