REQUIRE CLASS: ~nn/class/class.f
REQUIRE SEMAPHORE ~nn/lib/win/sys/semaphore.f

CLASS: QUEUE 
    var end-buf
    var beg-buf
    var head     ( get from head)
    var tail     ( put to tail)
    var size-queue
    var not-empty ( semaphore)
    var not-full  ( semaphore)
    var not-busy  ( semaphore)

;CLASS


M: Init
        beg-buf @ dup head ! tail !
        BEG-BUF @ END-BUF @ OVER - ERASE
        size-queue @
          not-full  @ see-> resource count !
        0 not-empty @ see-> resource count !
        1 not-busy  @ see-> resource count ! ;

    ::constr QUEUE ( size-of-queue size-of-element ->)
        dup size-elem ! over size-queue !
        here beg-buf !
        * allot here end-buf !
        size-queue @ new resource not-full !
                   0 new resource not-empty !
                   1 NEW RESOURCE NOT-BUSY !
        init ;

    : ++  ( adr -> next-adr)
        size-elem @ + dup end-buf @ =
        if drop beg-buf @ then ;


( QUEUE FULL? EMPTY? moveto movefrom                11.Dec.96 )

    ::virtual moveto ( value to ->) ! ;
    ::virtual movefrom ( from ->)  @ ;
    ::VIRTUAL DROP-EL DROP ;



( PUT GET                                           10.Jul.97 )
    :: put ( elem ->)
        not-full @ see-> resource get
        not-busy @ see-> resource get
        tail @ moveto   tail @ ++ tail !
        not-empty @ see-> resource release
        not-busy @ see-> resource release ;
    :: get ( -> elem)
        not-empty @ see-> resource get
        not-busy @ see-> resource get
        head @ movefrom head @ ++ head !
        not-full @ see-> resource release
        not-busy @ see-> resource release ;



( NOT-EMPTY? NOT-FULL? NOT-BUSY? ?PUT ?GET          10.Jul.97 )

    :: NOT-BUSY?  NOT-BUSY  @ SEE-> RESOURCE FREE ;
    :: NOT-EMPTY? NOT-EMPTY @ SEE-> RESOURCE FREE ;
    :: NOT-FULL?  NOT-FULL  @ SEE-> RESOURCE FREE ;
    :: ?PUT NOT-FULL? NOT-BUSY? AND
            IF PUT ELSE DROP-EL THEN ;
    :: ?GET NOT-EMPTY? NOT-BUSY? AND
            IF GET TRUE ELSE FALSE THEN ;
end QUEUE






