REQUIRE ICOMPARE ~nn/lib/wcmatch.f
REQUIRE ZPLACE ~nn/lib/az.f

WINAPI: RasDialA               RASAPI32.DLL
WINAPI: RasHangUpA             RASAPI32.DLL
WINAPI: RasEnumConnectionsA    RASAPI32.DLL
WINAPI: RasGetErrorStringA     RASAPI32.DLL
WINAPI: RasGetConnectStatusA   RASAPI32.DLL

 0
  4 -- dwSize
257 -- szEntryName
129 -- szPhoneNumber
129 -- szCallbackNumber
257 -- szUserName
257 -- szPassword
 19 -- szDomain
DUP CONSTANT /RASDIALPARAMS-95
 4  -- dwSubEntry
 4  -- dwCallbackId
CONSTANT /RASDIALPARAMS-NT
: /RASDIALPARAMS WinNT? IF /RASDIALPARAMS-NT ELSE /RASDIALPARAMS-95 THEN ;
\ CREATE RASDIALPARAMS /RASDIALPARAMS ALLOT
USER-VALUE RDP     \ RasDialParameters

  0
  4 -- RASCONN.dwSize
  4 -- RASCONN.hrasconn
257 -- RASCONN.szEntryName
CONSTANT /RASCONN-95
412 CONSTANT /RASCONN-NT
: /RASCONN /RASCONN-NT ;

  0
  4 -- rasstat.dwSize
  4 -- rasstat.rasconnstate
  4 -- rasstat.dwError
 17 -- rasstat.szDeviceType
129 -- rasstat.szDeviceName
2 +  \ ࠢ
CONSTANT /RASCONNSTATUS
\ 160 CONSTANT /RASCONNSTATUS

USER SAVE-SP
USER RASCONN#
USER lpcb
USER-CREATE CONN-NAME 2 CELLS USER-ALLOT
USER HRASCONN

: MyConnection? ( addr u -- ?)
    CONN-NAME 2@ ?DUP
    IF ICOMPARE 0=
    ELSE DROP 2DROP TRUE THEN ;

USER CONN-TEST

: CONNECTIONS ( xt-test -- ? )
  CONN-TEST !
  SP@ SAVE-SP ! \ ⨢  RasEnumConnections
  10000 lpcb ! RASCONN# 0!
  RASCONN# lpcb 10000 ALLOCATE THROW >R
  R@ /RASCONN ERASE
  /RASCONN R@ !
  R@ RasEnumConnectionsA DUP IF ." RasEnumConn error #" DUP . CR THEN
  0=
  RASCONN# @ 0 > AND >R 
  SAVE-SP @ SP!
  R>
  IF ( ᮥ ⠭, ஢ 㦭 )
    R@ RASCONN# @ /RASCONN * +  R@
    ?DO
      I RASCONN.szEntryName ASCIIZ> CONN-TEST @ EXECUTE
      IF
        I RASCONN.hrasconn @ HRASCONN !
        UNLOOP R> FREE DROP TRUE EXIT
      THEN
    /RASCONN +LOOP
  THEN
  FALSE
  R> FREE THROW
;

: RAS-STATUS ( h -- state error ior )
    /RASCONNSTATUS ALLOCATE THROW >R
    /RASCONNSTATUS R@ !
    R@ SWAP RasGetConnectStatusA ?DUP 0=
    IF
        R@ rasstat.rasconnstate @ 
        R@ rasstat.dwError @
        0
    ELSE 
        0 0 ROT
    THEN
    R> FREE THROW
;

: SONLINE? ( a u -- ? )
    CONN-NAME 2! ['] MyConnection? CONNECTIONS 
    DUP IF 
            HRASCONN @ RAS-STATUS 0=
            IF
                DROP 0x2000 = AND
            ELSE
                2DROP
            THEN
( 
            /RASCONNSTATUS ALLOCATE THROW >R
            /RASCONNSTATUS R@ !
            R@ HRASCONN @ RasGetConnectStatusA 0=
            IF
                R@ rasstat.rasconnstate @ 0x2000 = AND
            THEN
            R> FREE THROW
)
        THEN
;

: +WORDPLACE0 ( a u -- false )
    PAD C@ IF S" , " PAD +ZPLACE THEN
    PAD +ZPLACE 
    FALSE ;

: CONNECTION ( -- a u )
    PAD 0!
    ['] +WORDPLACE0 CONNECTIONS DROP 
    PAD ASCIIZ> 
;

WINAPI: GlobalAlloc kernel32.dll

: ?ALLOC-RDP
    RDP 0=
    IF
        /RASDIALPARAMS GPTR GlobalAlloc ?DUP ERR THROW
        TO RDP
        RDP /RASDIALPARAMS ERASE
        /RASDIALPARAMS RDP dwSize !
    THEN
;


USER-VALUE RASError

: RASUser ( addr u --)   ?ALLOC-RDP  RDP szUserName ZPLACE ;
: RASPassword            ?ALLOC-RDP  RDP szPassword ZPLACE ;
: RASDomain              ?ALLOC-RDP  RDP szDomain ZPLACE ;
: RASEntry               ?ALLOC-RDP  RDP szEntryName ZPLACE ;
: RASPhone               ?ALLOC-RDP  RDP szPhoneNumber ZPLACE ;

DEBUG?
[IF]
: .Z ." <" ASCIIZ> TYPE ." >" CR ; 
: .RDP
    ." RAS Parameters" CR
    ." EntryName: "       RDP szEntryName         .Z
    ." PhoneNumber: "     RDP szPhoneNumber       .Z
    ." CallbackNumber: "  RDP szCallbackNumber    .Z
    ." UserName: "        RDP szUserName          .Z
    ." Password: "        RDP szPassword          .Z
    ." Domain: "          RDP szDomain            .Z
;
[THEN]

VARIABLE DialOnce

: (?DIAL) ( -- ?)
    RDP szEntryName ASCIIZ> SONLINE? DialOnce @ AND 0=
    IF
        0 TO RASError
        HRASCONN 0!
\    [ DEBUG? ] [IF] .RDP [THEN]
        HRASCONN 0 0 RDP 0 0 RasDialA
        DUP TO RASError
        DUP IF HRASCONN @ RasHangUpA DROP THEN
        0=
    ELSE
        TRUE
    THEN
;

: ?DIAL ( addr u -- ?)  RASEntry  (?DIAL) ;

: DIAL ?DIAL DROP ;

: #DIAL ( u1 addr2 u2 -- )
    ROT 0
    ?DO
        2DUP ?DIAL
        IF LEAVE THEN
    LOOP
    2DROP
;    

: SHANGUP ( addr u -- )
    0 TO RASError
    SONLINE?
    IF
        HRASCONN @ RasHangUpA TO RASError
        BEGIN 
            HRASCONN @ RAS-STATUS ( -- state error ior )
            IF  
                2DROP FALSE
            ELSE
                NIP ERROR_INVALID_HANDLE <>
            THEN
        WHILE
            100 PAUSE
        REPEAT
    THEN
;

