REQUIRE CEZ: ~nn/lib/protect/cipher.f
REQUIRE S>NUM ~nn/lib/s2num.f
REQUIRE GET-REG ~nn/lib/registry.f
REQUIRE CUR-DATE ~nn/lib/time.f

VARIABLE H-REG
0 VALUE R-DATE
CEZ: MAKE-R-P ( addr u -- a)
    256 ALLOCATE THROW >R
    S" HKEY_LOCAL_MACHINE\SOFTWARE\nnSoft\" R@ ZPLACE
\    2DUP TYPE CR
    R@ +ZPLACE
    S" \@" R@ +ZPLACE
    R> 
;CEZ

: DATE-VALUE ( -- addr len)
    CUR-DATE  S>D
    <#  0 HOLD #S #> 1-
;

CEZ: ADD-R-D ( S" progname" --)
    [NONAME
    BASE @ >R DECIMAL
    MAKE-R-P >R
    PAD 0! PAD R@ ASCIIZ> ['] GET-REG CATCH PAD C@ 0= OR
    IF 2DROP DROP
        R@ ASCIIZ> DATE-VALUE REG-SZ
        CUR-DATE TO R-DATE
    ELSE
        PAD ASCIIZ> S>NUM TO R-DATE
    THEN
    R> FREE DROP
    R> BASE !
    NONAME] CATCH IF 2DROP THEN
;CEZ

0 [IF]
UseDLL ADVAPI32.DLL

VARIABLE H-REG
0 VALUE R-DATE
CEZ: MAKE-R-P ( addr u -- a)
    S" SOFTWARE\nnSoft\" PAD1 PLACE PAD1 +PLACE
    PAD1 $+0 PAD1 1+ ;CEZ

: DateDays@ Year@ 12 * Mon@ 1- + 31 * Day@ + ;

: DATE-VALUE ( -- addr len)
    DateDays@ S>D
    <#  0 HOLD #S #> 1-
;

CEZ: ADD-R-D ( S" ProgName" --)
    BASE @ >R DECIMAL
    MAKE-R-P >R
    256 SP@ PAD R@ HKEY_LOCAL_MACHINE RegQueryValueA ERROR_SUCCESS - OVER 2 < OR
    IF \ Not found
        \ ." Reg Key Not found" CR
        DROP
        H-REG R@ HKEY_LOCAL_MACHINE RegCreateKeyA ERROR_SUCCESS =
        IF
            H-REG @ RegCloseKey DROP
            DATE-VALUE SWAP REG_SZ R@ HKEY_LOCAL_MACHINE RegSetValueA DROP
            DateDays@ TO R-DATE
        THEN
    ELSE
        PAD SWAP
        0 0 2SWAP >NUMBER 2DROP D>S TO R-DATE
    THEN
    RDROP
    R> BASE !
;CEZ

[THEN]