\ File variables
REQUIRE FILE ~nn/lib/subst1.f
REQUIRE get-string ~nn/lib/getstr.f
REQUIRE S+ ~nn/lib/az.f
REQUIRE REG-SZ ~nn/lib/registry.f

VARIABLE regVAR-PATH HERE 1+
   C" HKEY_LOCAL_MACHINE\Software\nnSoft\var\" ", 0 C,  regVAR-PATH ! \ "
USER uregVAR-PATH
: RegVarPath! S>ZALLOC regVAR-PATH ! ;
: uRegVarPath! S>ZALLOC uregVAR-PATH ! ;

: regVAR-PATH@ uregVAR-PATH @ ?DUP 0= IF regVAR-PATH @ THEN ASCIIZ> ;
: regVAR-FILENAME ( a -- a1 u1) @ COUNT regVAR-PATH@ 2SWAP S+ ;

:NONAME \ _TOfVAR-CODE
    R> CFL CELL+ - regVAR-FILENAME OVER >R 2SWAP REG-SZ
    R> FREE DROP ;

: regVAR
  CREATE LATEST ,
  LITERAL ( _TOfVAR-CODE) COMPILE,
  DOES>
    PAD DUP 0! SWAP
    regVAR-FILENAME OVER >R
    ['] GET-REG CATCH IF 2DROP DROP THEN
    PAD ASCIIZ>
    R> FREE DROP  ;

(
regVAR test1
regVAR test2

S" hello1" TO test1
S" hello2" TO test2
test1 TYPE CR
test2 TYPE CR
)