#ifndef MD5_H
#define MD5_H

#ifdef __alpha
typedef unsigned int uint32;
#else
typedef unsigned long uint32;
#endif

struct MD5Context {
    uint32 buf[4];
    uint32 bits[2];
    unsigned char in[64];
};

int CALLBACK MD5Init(struct MD5Context *context);
int CALLBACK MD5Update(struct MD5Context *context, unsigned char const *buf, unsigned len);
int CALLBACK MD5Final(struct MD5Context *context, unsigned char digest[16]);
void MD5Transform(uint32 buf[4], uint32 const in[16]);

/*
 * This is needed to make RSAREF happy on some MS-DOS compilers.
 */
typedef struct MD5Context MD5_CTX;

#endif /* !MD5_H */
