REQUIRE { ~nn/lib/locals.f
REQUIRE ExitCodeProc ~nn/lib/process.f

\ HINSTANCE ShellExecute(
\    HWND hwnd, 
\    LPCTSTR lpOperation,
\    LPCTSTR lpFile, 
\    LPCTSTR lpParameters, 
\    LPCTSTR lpDirectory,
\    INT nShowCmd
\ );  
WINAPI: ShellExecuteA SHELL32.DLL

\ WINSHELLAPI BOOL WINAPI ShellExecuteEx( LPSHELLEXECUTEINFO lpExecInfo );  
WINAPI: ShellExecuteEx SHELL32.DLL

\ typedef struct _SHELLEXECUTEINFO{
0
1 CELLS -- sei_cbSize
1 CELLS -- sei_fMask
1 CELLS -- sei_hwnd
1 CELLS -- sei_lpVerb
1 CELLS -- sei_lpFile
1 CELLS -- sei_lpParameters
1 CELLS -- sei_lpDirectory
1 CELLS -- sei_nShow
1 CELLS -- sei_hInstApp
\    // Optional members 
1 CELLS -- sei_lpIDList
1 CELLS -- sei_lpClass 
1 CELLS -- sei_hkeyClass
1 CELLS -- sei_dwHotKey
1 CELLS -- sei_hIcon
1 CELLS -- sei_hProcess
CONSTANT /SHELLEXECUTEINFO
 


: ShellStart { a u -- }
    0 ( SW_MAXIMIZE) 0 0
    a  S" open" DROP 0
    ShellExecuteA DROP
;

: (ShellStartApp) { sei wait -- ? }
    /SHELLEXECUTEINFO sei sei_cbSize !
    SEE_MASK_NOCLOSEPROCESS SEE_MASK_FLAG_NO_UI OR
    sei sei_fMask @ OR sei sei_fMask !
    sei sei_lpVerb 0!
    sei sei_hProcess 0!
    sei ShellExecuteEx
    DUP 0<> wait AND sei sei_hProcess @ 0<> AND
    IF
        -1 sei sei_hProcess @ WaitForSingleObject DROP 
        0 SP@ sei sei_hProcess @ GetExitCodeProcess DROP
        TO ExitCodeProc
    THEN
    sei sei_hProcess @ ?DUP IF CLOSE-FILE DROP THEN
;

: ShellStartApp ( sei -- ?) FALSE (ShellStartApp) ;
: ShellStartAppWait ( sei -- ?) TRUE (ShellStartApp) ;