REQUIRE AppendNode ~nn/lib/list.f
REQUIRE S>ZALLOC ~nn/lib/az.f
REQUIRE <EOF> ~nn/lib/eof.f

USER SPLIT-LIST

: ADD-SPLIT S>ZALLOC SPLIT-LIST AppendNode ;
: SPLIT ( a u char -- list )
    SPLIT-LIST 0! >R
    BEGIN 
        2DUP RP@ 1 SEARCH
    WHILE
        DUP >R 2SWAP R> -  ADD-SPLIT
        1- SWAP 1+ SWAP
    REPEAT
    2DROP  RDROP
    ?DUP IF ADD-SPLIT ELSE DROP THEN
    SPLIT-LIST @
;

<EOF>

: TYPE-NODE NodeValue ASCIIZ> TYPE CR ;
VARIABLE XLIST
: TEST S" 123456789;123456789;987654321;" [CHAR] ; SPLIT XLIST !
    ['] TYPE-NODE XLIST DoList ;
TEST