REQUIRE <EOF> ~nn/lib/eof.f
REQUIRE ISEARCH ~nn/lib/wcmatch.f
REQUIRE WDAYS  ~nn/lib/time.f


USER-VALUE BEG-RANGE
USER-VALUE END-RANGE
USER-VALUE NAME2NUM

: def-name2num 0 ;

: SET-RANGE ( lo hi --)
    TO END-RANGE TO BEG-RANGE
    ['] def-name2num TO NAME2NUM
 ;

: WEEK2NUM ( a u -- a1 u1 num )
    DUP 2 >
    IF
        OVER  WDAYS COUNT  ROT 3 ISEARCH
        IF
            DROP WDAYS - 1- 3 / 1+ >R
            3 - SWAP 3 + SWAP
            R>
        ELSE FALSE THEN
    ELSE
        FALSE
    THEN
;
: WEEKDAYS  ['] WEEK2NUM TO NAME2NUM ;
: MONTH2NUM ( a u -- a1 u1 num )
    DUP 2 >
    IF
        OVER  MONNAMES COUNT  ROT 3 ISEARCH
        IF
            DROP MONNAMES - 1- 3 / 1+ >R
            3 - SWAP 3 + SWAP
            R>
        ELSE FALSE THEN
    ELSE
        FALSE
    THEN
;

: MONTHES   ['] MONTH2NUM TO NAME2NUM ;
VARIABLE <MIN-YEAR>
10 VALUE YEAR-RANGE
: SET-MIN-YEAR <MIN-YEAR> @ 0= IF GET-CUR-TIME Year@ 1- <MIN-YEAR> ! THEN ;
: MIN-YEAR  SET-MIN-YEAR <MIN-YEAR> @ ;
: MAX-YEAR MIN-YEAR YEAR-RANGE + ;
: 0-59 0 59 SET-RANGE ;
: 0-23 0 23 SET-RANGE ;
: 1-7  1 7  SET-RANGE WEEKDAYS ;
: 1-31 1 31 SET-RANGE ;
: 1-12 1 12 SET-RANGE MONTHES ;
: 2000-3000 MIN-YEAR MAX-YEAR SET-RANGE ;


: TIME>NUMB ( Addr # -- Addr1 #1 Num)
    BASE @ >R DECIMAL
    DUP
    IF
        OVER C@ 10 DIGIT
        IF  DROP
            0 0 2SWAP >NUMBER 2SWAP DROP
        ELSE
            NAME2NUM EXECUTE
        THEN
    ELSE
        0
    THEN
    R> BASE !
;
