REQUIRE WALLOC-PATH ~nn/lib/u/file/filename.f

WINAPI: CreateFileW                   KERNEL32.DLL
WINAPI: DeleteFileW                   KERNEL32.DLL

: -1ERR DUP -1 = IF GetLastError ELSE 0 THEN ;

: WALLOC-PATH2 ( wa wu fam -- fam wz )
  >R WALLOC-PATH 2DUP UNICODE>S TYPE CR DROP R> SWAP ;

: WCREATE-FILE ( wa wu fam -- fileid ior ) \ 94 FILE
\    ,  c-addr u,     
\    fam.   fam  .
\       ,    
\  .
\       , ior , fileid  ,
\   /    .
\  ior -     /,
\  fileid .
  WALLOC-PATH2 >R >R
  0 FILE_ATTRIBUTE_ARCHIVE ( template attrs )
  CREATE_ALWAYS
  0 ( secur )
  0 ( share )
  R> ( access=fam )
  R@ ( filename )
  CreateFileW -1ERR
  R> FREE DROP
;

: WCREATE-FILE-SHARED ( wa wu fam -- fileid ior )
  WALLOC-PATH2 >R >R
  0 FILE_ATTRIBUTE_ARCHIVE ( template attrs )
  CREATE_ALWAYS
  SA ( secur )
  3 ( share )
  R> ( access=fam )
  R@ ( filename )
  CreateFileW -1ERR
  R> FREE DROP
;

: WOPEN-FILE-SHARED ( wa wu fam -- fileid ior )
  WALLOC-PATH2 >R >R
  0 FILE_ATTRIBUTE_ARCHIVE ( template attrs )
  OPEN_EXISTING
  SA ( secur )
  3 ( share )
  R> ( access=fam )
  R@ ( filename )
  CreateFileW -1ERR
  R> FREE DROP
;

: WDELETE-FILE ( waddr wu -- ior ) \ 94 FILE
\    ,   c-addr u.
\ ior -     /.
  WALLOC-PATH DROP DUP DeleteFileW ERR SWAP FREE DROP
;

: WOPEN-FILE ( wa wu fam -- fileid ior ) \ 94 FILE
\    ,   c-addr u,    fam.
\   fam  .
\    , ior , fileid  ,  
\   .
\  ior -     /,
\  fileid .
  WALLOC-PATH2 >R >R
  0 FILE_ATTRIBUTE_ARCHIVE ( template attrs )
  OPEN_EXISTING
  0 ( secur )
  0 ( share )
  R> ( access=fam )
  R@ ( filename )
  CreateFileW -1ERR
  R> FREE DROP
;
