REQUIRE CODE lib/ext/SPF-ASM-HIGH.F

BASE @ HEX

CODE W-TRAILING ( w-addr wu1 -- w-addr wu2 ) \ 94 STRING
\  u1  , u2  u1,      
\  ,  c-addr  u1.  u1     
\  , u2 .
      PUSH EDI
      MOV ECX, [EBP]
      JCXZ @@1
      MOV EDI, 4 [EBP]
      ADD EDI, ECX
      ADD EDI, ECX
      DEC EDI
      DEC EDI
      MOV AX, # 20
      STD
      REPZ SCAS WORD
      JZ  @@2
      INC ECX
@@2:  CLD
      MOV [EBP], ECX
@@1:  POP EDI
      RET
END-CODE


CODE WCOMPARE ( c-addr1 u1 c-addr2 u2 -- n ) \ 94 STRING
\  ,  c-addr1 u1,  ,  c-addr2 u2.
\  ,    ,   ,  
\        .   
\ , n .         
\ ,  n   (-1),  u1  u2,   (1).
\           ,  n 
\  (-1),     ,  c-addr1 u1
\    ,     ,
\  c-addr2 u2,     .
      PUSH EDI
      MOV EDX,   [EBP]
      MOV EDI, 4 [EBP]
      MOV ECX, 8 [EBP]
      MOV ESI, 0C [EBP]
      ADD EBP, # 0C
      CMP ECX, EDX
      PUSHFD
      JC  @@1
      MOV ECX, EDX
@@1:  JECXZ @@2
      CLD
      REPZ CMPS WORD
      JZ  @@2
      POP EBX
      MOV EAX, # -1
      JC  @@3
      NEG EAX
      JMP @@3
@@2:  XOR EAX, EAX
      POPFD
      JZ  @@3
      MOV EAX, # -1
      JC  @@3
      NEG EAX
@@3:  MOV [EBP], EAX
      POP EDI
      RET
END-CODE


CODE WSEARCH ( w-addr1 wu1 w-addr2 wu2 -- w-addr3 wu3 flag ) \ 94 STRING
\    ,  c-addr1 u1, ,  c-addr2 u2.
\   "",     c-addr3   u3
\ .   "",   ,  c-addr3  c-addr1,
\  u3  u1.
\ [EBP]-u2 [EBP+4]-a2 [EBP+8]-u1 [EBP+0C]-a1
      PUSH EDI
      CLD
      MOV EBX,   [EBP]     \     WCHAR
      SAL EBX, # 1     \   
      OR EBX, EBX          \ ?
      JZ @@5               \ ,  
      MOV EDX, 8 [EBP]     \  ,     WCHAR
      SAL EDX, # 1     \   
      MOV EDI, 0C [EBP]    \   
      ADD EDX, EDI
@@4:  MOV ESI, 4 [EBP]
      LODS WORD
      MOV ECX, EDX
      SUB ECX, EDI
      JCXZ @@1
      REPNZ SCAS WORD
      JNZ @@1   \        
      CMP EBX, # 2
      JZ @@2   \     1  
      MOV ECX, EBX
      DEC ECX
      DEC ECX
      MOV EAX, EDX
      SUB EAX, EDI
      CMP EAX, ECX
      JC @@1  \     
      PUSH EDI
      SAR ECX, # 1
      REPZ CMPS WORD
      POP EDI
      JNZ @@4
@@2:  DEC EDI           \   
      DEC EDI
      SUB EDX, EDI
      SAR EDX, # 1
      MOV 0C [EBP], EDI
      MOV  8 [EBP], EDX
@@5:  MOV EAX, # -1
      JMP @@3
@@1:  XOR EAX, EAX
@@3:  ADD EBP, # 4
      MOV [EBP], EAX
      POP EDI
      RET
END-CODE

CODE WASCIIZ> ( w-addr -- w-addr wu )
     MOV  EBX, [EBP]
     XOR  EAX, EAX
@@1: MOV  AX, [EBX]
     INC  EBX
     INC  EBX
     OR   AX, AX
     JNZ  @@1
     DEC  EBX
     DEC  EBX
     SUB  EBX, [EBP]
     SAR  EBX
     SUB  EBP, # 4
     MOV  [EBP], EBX
     RET
END-CODE

BASE !

: WTYPE ( wa wu -- )
    UNICODE>S OVER >R TYPE
    R> FREE DROP
;
