: (>UNICODE) { a u cp \ buf len -- wa wu }
\    a u  .
\ cp     .
\ wa -   ( ,   )
\ wu -    ( wide char ,   )
    0 0 u a 0 cp MultiByteToWideChar DUP ERR THROW TO len
    len 1+ 2* ALLOCATE THROW TO buf
    len buf u a 0 cp  MultiByteToWideChar ERR THROW
    buf len 2* + 0 SWAP W!
    buf len
;

: (UNICODE>) { wa wu cp \ buf len -- a u }
\  unicode   wa wu    .
\ cp     .
\ a -   ( ,   )
\ u -    ( )
    0 0 0 0 wu wa 0 cp WideCharToMultiByte DUP ERR THROW TO len
    len 1+ ALLOCATE THROW TO buf
    0 0 len buf wu wa 0 cp WideCharToMultiByte ERR THROW
    buf len + 0 SWAP C!
    buf len
;

: S>UNICODE ( a u1 -- wa u2 ) CP_ACP (>UNICODE) ;
: UNICODE>S ( a1 u1 -- a2 u2 ) CP_ACP (UNICODE>) ;
: UTF8>UNICODE ( a u1 -- wa u2 ) CP_UTF8 (>UNICODE) ;
: UNICODE>UTF8 ( a1 u1 -- a2 u2 ) CP_UTF8 (UNICODE>) ;

: KOI8>UNICODE 21866 (>UNICODE) ;
: UNICODE>KOI8 21866 (UNICODE>) ;

: OEM>UNICODE CP_OEMCP (>UNICODE) ;
: UNICODE>OEM CP_OEMCP (UNICODE>) ;

: AZ>UNICODE ( az -- wz )
    DUP IF ASCIIZ> S>UNICODE DROP THEN ;

: UASCIIZ> ( wa -- wa u )
\ slow word. see ~nn/lib/u/util/wasciiz.f
  0 OVER
  BEGIN
    DUP W@ 0<>
  WHILE
    2+ SWAP 1+ SWAP
  REPEAT DROP
;
