REQUIRE @AZ ~nn/lib/az.f
REQUIRE get-string ~nn/lib/getstr.f
REQUIRE MAKE-FILE ~nn/lib/file.f
REQUIRE toOEM ~nn/lib/convert.f

VARIABLE from-filename
VARIABLE dir
: SET-CL
  GetCommandLineA ASCIIZ> \ 2DUP TYPE CR
  TIB SWAP C/L MIN DUP #TIB ! MOVE >IN 0!
  get-string 2DROP
;

: HELP ." Usage: mkdirs.exe file_with_pathes dir" CR BYE ;

: get-files ( ) \   
  SET-CL
  get-string ?DUP 0= IF HELP THEN S>ZALLOC from-filename !
  get-string ?DUP 0= IF S" ." THEN S>ZALLOC dir !
;

: main { \ f l1 -- }
    get-files
    from-filename @AZ R/O OPEN-FILE-SHARED THROW TO f
    dir @AZ PAD ZPLACE S" \" PAD +ZPLACE PAD ASCIIZ> NIP TO l1
    BEGIN PAD l1 + 512 f READ-LINE THROW WHILE
       DUP PAD l1 + SWAP + 0!
       PAD SWAP l1 + \ 2DUP TYPE CR
       2DUP S" ." SEARCH NIP NIP 
       IF
	       2DUP R/W MAKE-FILE DUP IF 2OVER TYPE CR THEN THROW
    	   CLOSE-FILE THROW
	   THEN
       2DROP
    REPEAT
    DROP
    BYE
;

: 1BYE 1 HALT ;
' main TO <MAIN>
0 MAINX !

BASE @ HEX
: JMP  >R  0E9 R@ C! R@ 1+ CELL+ - R> 1+ ! ;
BASE !
' 1BYE ' QUIT JMP
' NOOP ' OPTIONS JMP
FALSE TO SPF-INIT?
S" mkdirs.exe" SAVE
BYE

