REQUIRE EVAL-SUBST ~nn/lib/subst1.f
REQUIRE get-string ~nn/lib/getstr.f
REQUIRE S>ZALLOC ~nn/lib/az.f
REQUIRE FWRITE ~nn/lib/file.f
REQUIRE YYYY ~nn/lib/time-vars.f
REQUIRE BUILD! ~nn/lib/build.f

VARIABLE from-filename
VARIABLE to-filename
: SET-CL
  GetCommandLineA ASCIIZ> \ 2DUP TYPE CR
  TIB SWAP C/L MIN DUP #TIB ! MOVE >IN 0!
  get-string 2DROP
;

: VER-MAJOR APP-VERSION 100 / ;
: VER-MINOR APP-VERSION 100 MOD ;
: VER-TYPE 
    APP-BETA IF S" beta" EXIT THEN
    APP-RC IF S" RC" EXIT THEN
    S" release" ;

: VER-TYPE# 
    APP-BETA ?DUP IF EXIT THEN
    APP-RC ?DUP IF EXIT THEN
    S" " ;
: VER-TYPE#|0 VER-TYPE# ?DUP 0= IF DROP 0 THEN ;

: BUILD-NUM #BUILD 1+ ;

: HELP ." Usage: rc_pre.exe file_template.rc outfile.rc" CR BYE ;

: get-files ( ) \ ஢  ப
  SET-CL
  get-string ?DUP 0= IF HELP THEN S>ZALLOC from-filename !
  get-string ?DUP 0= IF HELP THEN S>ZALLOC to-filename !
;

: main
    get-files    
    BUILD!
    from-filename @AZ FILE EVAL-SUBST
    to-filename @AZ FWRITE
    BYE
;

: 1BYE 1 HALT ;
' main TO <MAIN>
0 MAINX !

BASE @ HEX
: JMP  >R  0E9 R@ C! R@ 1+ CELL+ - R> 1+ ! ;
BASE !
' 1BYE ' QUIT JMP
' NOOP ' OPTIONS JMP
FALSE TO SPF-INIT?
S" rc_pre.exe" SAVE
BYE

