\ Window operations
: XY+ ( x1 y1 x2 y2 -- x3 y3)     ROT + >R + R> ;

: WIN-RECT ( h -- b r y x)  >R 0 0 0 0 SP@ R> GetWindowRect DROP ;
: WIN-POS WIN-RECT 2SWAP 2DROP SWAP ;

: WIN-MOVE { x y -- }  SWP_NOSIZE 0 0 y x HWND_TOP GetForegroundWindow SetWindowPos DROP ;
: WIN-MOVER { x y -- }  GetForegroundWindow WIN-POS ( x y) x y XY+ WIN-MOVE ;

: WIN-RESIZE { w h -- }
    SWP_NOMOVE h w 0 0 HWND_TOP GetForegroundWindow SetWindowPos DROP ;

: Z-ORDER { hwnd topmost -- }
    SWP_NOSIZE SWP_NOMOVE OR 0 0 0 0 topmost hwnd SetWindowPos DROP 
    GetForegroundWindow hwnd <> IF SW_SHOW hwnd ShowWindow DROP THEN
;

: WIN-TOPMOST ( hwnd -- ) HWND_TOPMOST Z-ORDER ;
: WIN-NOTOPMOST ( hwnd -- ) HWND_NOTOPMOST Z-ORDER ;

: WIN-WAIT ( ms -- )
    0 SP@ GetForegroundWindow GetWindowThreadProcessId DROP
    0 PROCESS_ALL_ACCESS OpenProcess ?DUP
    IF ( ms hp ) >R
        R@ WaitForInputIdle DROP
        R> CloseHandle DROP
    ELSE DROP 
    THEN ;
