REQUIRE :: ~yz/lib/automation.f
REQUIRE WinErrorMessage ~nn/lib/message.f
REQUIRE toOEM ~nn/lib/convert.f

0 VALUE Web

IID_IDispatch interface IID_IWebBrowser {EAB22AC1-30C1-11CF-A7EB-0000C05BAE0B}
method ::GoBack \ ();
\    [id(0x00000065), helpstring("Navigates to the next item in the history list.")]
method ::GoForward \ ();
\    [id(0x00000066), helpstring("Go home/start page.")]
method ::GoHome \ ();
\    [id(0x00000067), helpstring("Go Search Page.")]
method ::GoSearch \ ();
\    [id(0x00000068), helpstring("Navigates to a URL or file.")]
method ::Navigate \ (
\                    [in] BSTR URL, 
\                    [in, optional] VARIANT* Flags, 
\                    [in, optional] VARIANT* TargetFrameName, 
\                    [in, optional] VARIANT* PostData, 
\                    [in, optional] VARIANT* Headers);
\    [id(0xfffffdda), helpstring("Refresh the currently viewed page.")]
method ::Refresh \ ();
\    [id(0x00000069), helpstring("Refresh the currently viewed page.")]
method ::Refresh2 \ ([in, optional] VARIANT* Level);
\    [id(0x0000006a), helpstring("Stops opening a file.")]
method ::Stop \ ();
\    [id(0x000000c8), propget, helpstring("Returns the application automation object if accessible, this automation object otherwise..")]
method ::Application \ ([out, retval] IDispatch** ppDisp);
\    [id(0x000000c9), propget, helpstring("Returns the automation object of the container/parent if one exists or this automation object.")]
method ::Parent \ ([out, retval] IDispatch** ppDisp);
\    [id(0x000000ca), propget, helpstring("Returns the container/parent automation object, if any.")]
method ::Container \ ([out, retval] IDispatch** ppDisp);
\    [id(0x000000cb), propget, helpstring("Returns the active Document automation object, if any.")]
method ::Document \ ([out, retval] IDispatch** ppDisp);
\    [id(0x000000cc), propget, helpstring("Returns True if this is the top level object.")]
method ::TopLevelContainer \ ([out, retval] VARIANT_BOOL* pBool);
\    [id(0x000000cd), propget, helpstring("Returns the type of the contained document object.")]
method ::Type \ ([out, retval] BSTR* Type);
\    [id(0x000000ce), propget, helpstring("The horizontal position (pixels) of the frame window relative to the screen/container.")]
method ::Left \ ([out, retval] long* pl);
\    [id(0x000000ce), propput, helpstring("The horizontal position (pixels) of the frame window relative to the screen/container.")]
\ method ::Left \ ([in] long pl);
\    [id(0x000000cf), propget, helpstring("The vertical position (pixels) of the frame window relative to the screen/container.")]
method ::Top \ ([out, retval] long* pl);
\    [id(0x000000cf), propput, helpstring("The vertical position (pixels) of the frame window relative to the screen/container.")]
\ method ::Top \ ([in] long pl);
\    [id(0x000000d0), propget, helpstring("The horizontal dimension (pixels) of the frame window/object.")]
method ::Width \ ([out, retval] long* pl);
\    [id(0x000000d0), propput, helpstring("The horizontal dimension (pixels) of the frame window/object.")]
\ method ::Width \ ([in] long pl);
\    [id(0x000000d1), propget, helpstring("The vertical dimension (pixels) of the frame window/object.")]
method ::Height \ ([out, retval] long* pl);
\    [id(0x000000d1), propput, helpstring("The vertical dimension (pixels) of the frame window/object.")]
\ method ::Height \ ([in] long pl);
\    [id(0x000000d2), propget, helpstring("Gets the short (UI-friendly) name of the URL/file currently viewed.")]
method ::LocationName \ ([out, retval] BSTR* LocationName);
\    [id(0x000000d3), propget, helpstring("Gets the full URL/path currently viewed.")]
method ::LocationURL \ ([out, retval] BSTR* LocationURL);
\    [id(0x000000d4), propget, helpstring("Query to see if something is still in progress.")]
method ::Busy \ ([out, retval] VARIANT_BOOL* pBool);
method ::Visible
interface-end

: create-object2 ( IID -- idisp 0 / error)
  clsid-len GETMEM DUP >R prog>clsid
  ?DUP IF R> FREEMEM EXIT THEN
  R@ ( clsid)
  0 >R RP@ SWAP >R 
  IID_IDispatch CLSCTX_SERVER 0 R> CoCreateInstance
  ?DUP IF RDROP ELSE R> 0 THEN
  R> FREEMEM ;

: ?WERR ?DUP IF WinErrorMessage TYPE CR THEN ;
: test { \ p -- }
  COM-init DROP
  AT p
  CLSCTX_SERVER
  IID_IWebBrowser
  0
  IID_IDispatch
  CoCreateInstance ?WERR


  COM-destroy ;

WINAPI: ProgIDFromCLSID ole32.dll

CREATE WebCLSID
" {00020424-0000-0000-C000-000000000046}" clsid, 0 ,

: test1 { \ p -- }
  COM-init DROP

  " "  create-object DUP . CR TO p
  KEY DROP
  TRUE _bool p :: Visible !
  5000 PAUSE

  COM-destroy 
;

test1

BYE
