(  1001bytes         w32f

         Win32Forth 4.1.
  +    
)


REQUIRE CLASS: ~nn/class/class.f

260 CONSTANT max-path

WINAPI: FindFirstFileA KERNEL32.DLL
WINAPI: FindNextFileA  KERNEL32.DLL
WINAPI: FindClose      KERNEL32.DLL

\ << :fileName
\ << :showFile
\ << :findClose
\ << :findNext
\ << :findFirst
\ << :getAttr

  CLASS: DirObject \ <SUPER Object

        RECORD: FIND_DATA       \ returns the address of the structure

            CELL FIELD dwFileAttributes
               8 FIELD ftCreationTime
               8 FIELD ftLastAccessTime
               8 FIELD ftLastWriteTime
            CELL FIELD nFileSizeHigh
            CELL FIELD nFileSizeLow
            CELL FIELD dwReserved0
            CELL FIELD dwReserved1
        max-path FIELD cFileName
              14 FIELD cAlternateFileName

        ;RECORD /FIND_DATA

            CELL FIELD vFindHandle
            CELL FIELD vAttr

  CONSTR: init   -1 vFindHandle !  ;

  M: GetAttr ( -- u)  dwFileAttributes @  ;
              
  M: FindFirst ( addr len -- f )    \ f1=TRUE if found file
                DROP
                FIND_DATA SWAP
                FindFirstFileA DUP
                vFindHandle !
                ;

  M: FileName cFileName ASCIIZ> ;                
  
  M: FindNext  ( -- f )
                FIND_DATA
                vFindHandle @
                FindNextFileA
                ;


  M: FindClose ( -- f )        \  
                vFindHandle @
                FindClose 0=
                -1 vFindHandle !
                ;

  M: ShowFile  ( -- )          \   
                cFileName ASCIIZ> TYPE
                ;

  DESTR: free  FindClose DROP  ;

  ;CLASS
