REQUIRE CLASS: ~nn/class/class.f
REQUIRE Control ~nn/lib/win/control.f

WINAPI: SHBrowseForFolder SHELL32.DLL
\ WINSHELLAPI LPITEMIDLIST WINAPI SHBrowseForFolder(
\     LPBROWSEINFO lpbi
\ ); 

CLASS: ChooseDirDialog
    RECORD:  BROWSEINFO
        var hwndOwner       \ HWND hwndOwner; 
        var pidlRoot        \ LPCITEMIDLIST pidlRoot; 
        var pszDisplayName  \ LPSTR pszDisplayName; 
        var lpszTitle       \ LPCSTR lpszTitle; 
        var ulFlags         \ UINT ulFlags; 
        var lpfn            \ BFFCALLBACK lpfn; 
        var lParam          \ LPARAM lParam; 
        var iImage          \ int iImage; 
    ;RECORD /BROWSEINFO
    
    var vPIDL
CONSTR: init
    MAX_PATH ALLOCATE THROW pszDisplayName !
    BIF_RETURNONLYFSDIRS ulFlags !
;
DESTR: free pszDisplayName @ ?FREE lpszTitle @ ?FREE ;
M: SetTitle ( a u -- ) S>ZALLOC lpszTitle ! ;
M: Execute ( -- ?)
    WITH Control InitCommonControls ENDWITH
    BROWSEINFO SHBrowseForFolder DUP vPIDL ! 0<>
    
;
M: GetPath  vPIDL @ DUP W@ SWAP 2+ SWAP ;

;CLASS

ChooseDirDialog POINTER cdd
: test
    ChooseDirDialog NEW TO cdd
    S" test" cdd SetTitle
    cdd Execute .
    cdd vPIDL @ 100 DUMP
    
;
test
