REQUIRE SID2NAME ~nn/lib/win/net/sid2name.f
REQUIRE GetTrayToken ~nn/lib/win/sec/traytoken.f
REQUIRE ZPLACE ~nn/lib/az.f
REQUIRE PAD1 ~nn/lib/subst1.f
REQUIRE WinNT? ~nn/lib/winver.f
REQUIRE GetCurrentUserToken ~nn/lib/win/sec/wts.f
REQUIRE ICOMPARE ~nn/lib/wcmatch.f

WINAPI: GetTokenInformation advapi32.dll

: 9xUSERNAME  256 SP@ PAD1 GetUserNameA 2DROP PAD1 ASCIIZ> ;
: ntUSERNAME { \ need htoken buf -- a u }
    WinXP? IF GetCurrentUserToken ELSE GetTrayToken THEN
    IF DROP 9xUSERNAME EXIT THEN TO htoken
    AT need 0 0 1 htoken GetTokenInformation ERR 122 =
    IF
        need ALLOCATE THROW TO buf
        AT need need buf 1 htoken GetTokenInformation
        IF
            buf @ SID2NAME DROP
        ELSE S" " THEN
        htoken CloseHandle DROP
        buf FREE DROP
    ELSE
        9xUSERNAME
    THEN
    htoken CloseHandle DROP
;

WINAPI: GetUserNameA ADVAPI32.DLL

: USERNAME ( -- addr u)
    PAD1 0!
    WinNT?
    IF
        ntUSERNAME 2DUP PAD1 ZPLACE
        DROP FREE DROP
\        S" DefaultUserName"
\        S" SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon"
\        HKLM-VALUE
    ELSE
        256 SP@ PAD1 GetUserNameA 2DROP
\        S" SOFTWARE\Microsoft\Windows\CurrentVersion\Winlogon"
    THEN
    PAD1 ASCIIZ>
;

REQUIRE \EOF ~nn/lib/eof.f

\EOF

: test USERNAME TYPE CR ;
test
.S
BYE

\EOF

\ BOOL LookupAccountSid(
\   LPCTSTR lpSystemName,  // name of local or remote computer
\   PSID Sid,              // security identifier
\   LPTSTR Name,           // account name buffer
\   LPDWORD cbName,        // size of account name buffer
\   LPTSTR DomainName,     // domain name
\   LPDWORD cbDomainName,  // size of domain name buffer
\   PSID_NAME_USE peUse    // SID type
\ );

WINAPI: LookupAccountSidA advapi32.dll

\ BOOL GetUserObjectInformation(
\   HANDLE hObj,            // handle to object
\   int nIndex,             // type of information to retrieve
\   PVOID pvInfo,           // information buffer
\   DWORD nLength,          // size of the buffer
\   LPDWORD lpnLengthNeeded // receives required buffer size
\ );

WINAPI: GetUserObjectInformationA USer32.dll

: ObjectUser { h \ buf need nbuf dbuf nsize dsize sid_use -- a u ior }
\    AT need 0 0 UOI_USER_SID h GetUserObjectInformationA DUP . CR
\    need ALLOCATE THROW TO buf
\    AT need need buf UOI_USER_SID h GetUserObjectInformationA ERR  DUP . CR
\    ?DUP IF buf FREE DROP S" " ROT EXIT THEN
    64 DUP TO nsize TO dsize
    nsize ALLOCATE THROW TO nbuf
    dsize ALLOCATE THROW TO dbuf
    AT sid_use AT dsize dbuf AT nsize nbuf
    buf 0 LookupAccountSidA ERR DUP . CR
    dbuf FREE DROP
    nbuf ASCIIZ> ROT
;

: CurrentUser { \ hdesk -- a u ior }
    0 0 0 S" Default" DROP OpenDesktopA ?DUP
    IF
        TO hdesk
        hdesk ObjectUser
        hdesk CloseDesktop DROP
    ELSE
        GetLastError
    THEN
;


: test
    CurrentUser . . .
;

1 2 3 4 5 test
