REQUIRE ICOMPARE ~nn/lib/wcmatch.f
REQUIRE WIN-EXIST? ~nn/lib/win/windows/ops.f
REQUIRE WinXP? ~nn/lib/winver.f

: WM-SYSCMD WM_SYSCOMMAND GetDesktopWindow SendMessageA DROP ;
: MONPOWER SC_MONITORPOWER WM-SYSCMD ;
: MONITOR-LOW 1 MONPOWER ;
: MONITOR-OFF 2 MONPOWER ;
: MONITOR-ON -1 MONPOWER ;

: SYS-PAR >R 0 SP@ 0 SWAP 0 R> SystemParametersInfoA DROP ;
: MONITOR-LOW? WinXP? IF SPI_GETLOWPOWERACTIVE SYS-PAR 0<> ELSE 0 THEN ;
: MONITOR-OFF? WinXP? IF SPI_GETPOWEROFFACTIVE SYS-PAR 0<> ELSE 0 THEN ;
: MONITOR-ON? MONITOR-LOW? 0= MONITOR-OFF? 0= AND ;

: SCREENSAVER-ON 0 SC_SCREENSAVE WM-SYSCMD ;
: open-ss-desk ( -- h )
    DESKTOP_READOBJECTS DESKTOP_WRITEOBJECTS OR 0 0 S" Screen-saver" DROP 
    OpenDesktopA ;

: SCREENSAVER-ON? ( -- ?)
    Win2k? Win9x? Win95? 0= AND OR 
    IF
        ( SPI_GETSCREENSAVERRUNNING) 0x0072 SYS-PAR 0<>
    ELSE
        WinNT?
        IF
            open-ss-desk ?DUP
            IF CloseDesktop DROP TRUE
            ELSE FALSE THEN
        ELSE FALSE THEN
    THEN
;

:NONAME { par hwnd \ name -- }
    32 ALLOCATE 0=
    IF
        TO name
        31 name hwnd GetClassNameA
\        name TYPE CR
        name ASCIIZ> S" WindowsScreenSaverClass" ICOMPARE 0=
        IF
            0 0 WM_CLOSE hwnd PostMessageA DROP
        THEN
        name FREE DROP
    THEN
    1
; WNDPROC: kill-ssw

: SCREENSAVER-OFF { \ hdesk -- }
    WinNT?
    IF
        SCREENSAVER-ON?
        IF
            open-ss-desk ?DUP
            IF TO hdesk
                0 ['] kill-ssw hdesk EnumDesktopWindows DROP
                hdesk CloseDesktop DROP
            ELSE
                0 0 WM_CLOSE GetForegroundWindow PostMessageA DROP
            THEN
        THEN
    THEN
;

REQUIRE <EOF> ~nn/lib/eof.f
<EOF>
: test
    SCREENSAVER-ON
    3000 PAUSE
    SCREENSAVER-ON?
    IF SCREENSAVER-OFF THEN
    BYE
;

test
