
REQUIRE WinClass  ~nn/lib/win/winclass.f
REQUIRE CLASS:  ~nn/class/class.f
REQUIRE POINTER ~nn/class/pointer.f
REQUIRE {       ~nn/lib/locals.f
REQUIRE WinNT? ~nn/lib/winver.f
REQUIRE ZPLACE ~nn/lib/az.f

DECIMAL

CLASS: TrayIcon
\ HERE
WINAPI: Shell_NotifyIcon SHELL32.DLL
1029 CONSTANT NIN_BALLOONUSERCLICK

RECORD: NOTIFYICONDATA
    1 CELLS FIELD cbSize
    1 CELLS FIELD hWnd
    1 CELLS FIELD uID
    1 CELLS FIELD uFlags
    1 CELLS FIELD uCallbackMessage
    1 CELLS FIELD hIcon
  128       FIELD szTip

\ ----------- 5.0 --------------
    1 CELLS FIELD dwState
    1 CELLS FIELD dwStateMask
    256     FIELD szInfo
    1 CELLS FIELD uTimeout \  UINT  uVersion
    64      FIELD szInfoTitle
    1 CELLS FIELD dwInfoFlags
;RECORD /NOTIFYICONDATA

    var OnLB
    var OnRB
    var On2LB
    var OnHotkey
    var OnBalloonClick

1997 CONSTANT MsgID

CONSTR: init  ( -- )
    NOTIFYICONDATA /NOTIFYICONDATA ERASE
    Win2k? IF /NOTIFYICONDATA ELSE 88 THEN cbSize !
    this uID !
    NIF_MESSAGE NIF_ICON OR NIF_TIP OR uFlags !
;

M: Tip! ( a u -- )
  Win2k? IF 127 ELSE 63 THEN MIN
  szTip ZPLACE
;

M: DeleteIcon this NIM_DELETE Shell_NotifyIcon DROP ;

M: Delete ( -- )
    DeleteIcon
    hWnd @ ?DUP IF DestroyWindow DROP THEN ;

:NONAME  { TrayMsg Object uMsg hwnd -- }
    SP@ S0 !
\    HEX ." Tray " hwnd . uMsg . CR DECIMAL
\    S" xxxxxxx" MsgBox
    uMsg 0x3B =  IF 0 PostQuitMessage DROP FALSE EXIT THEN
    uMsg WM_QUERYENDSESSION = IF WinNT? 0= IF 0 PostQuitMessage DROP THEN 1 EXIT THEN
    uMsg WM_ENDSESSION = IF 0 PostQuitMessage DROP 0 EXIT THEN
    uMsg WM_HOTKEY = Object 0 > AND IF Object => OnHotkey @ ?DUP IF EXECUTE THEN 0 EXIT THEN
\    uMsg WM_CREATE =  IF 0 EXIT THEN

    uMsg MsgID =
    IF
\        TrayMsg 0x200 <>
\        IF .TIME HEX ." Tray " TrayMsg . CR DECIMAL THEN
        TrayMsg WM_LBUTTONDOWN =
        IF
          Object => OnLB @  ELSE
        TrayMsg WM_LBUTTONDBLCLK =
        IF
          Object => On2LB @  ELSE
        TrayMsg WM_RBUTTONDOWN =
\        TrayMsg WM_RBUTTONUP =
        IF
          Object => OnRB @   ELSE 
           TrayMsg  NIN_BALLOONUSERCLICK =
        IF Object => OnBalloonClick @
        ELSE 
            0 THEN THEN THEN THEN
        ?DUP IF EXECUTE THEN
        0
\        TrayMsg Object uMsg hwnd DefWindowProcA
    ELSE
        TrayMsg Object uMsg hwnd DefWindowProcA
    THEN
;

WNDPROC: tray-proc

WinClass POINTER TC

0 VALUE TCId

: TrayClass ( -- id )
    TCId ?DUP IF EXIT THEN
    WinClass NEW TO TC
    ['] tray-proc TC lpfnWndProc !
    0 TC style !
    S" SPFTrayClass" DROP TC lpszClassName !
    TC Register TO TCId
    TCId
;

: Window ( class style parent-hwnd -- hwnd )  \ 0 - 
         \         parent
         \  parent=0,    
  ROT >R SWAP >R >R
\  InitControls
  0 0 0 R@ CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT
  R> R> SWAP IF WS_CHILD OR THEN
  0 R> 0 CreateWindowExA
  ?DUP 0= IF GetLastError ERROR THEN
;

M: CreateIcon
  NOTIFYICONDATA NIM_ADD Shell_NotifyIcon 0= IF MsgID NEGATE THROW THEN ;

M: CreateWindow TrayClass 0 0 Window hWnd ! ;

M: Create ( addr u hicon -- )
  hIcon ! Tip!
  MsgID uCallbackMessage !
  Delete
  CreateWindow
  CreateIcon
;

M: ModifyIcon ( hicon -- )
   hIcon !
   this NIM_MODIFY Shell_NotifyIcon DROP ;

M: ModifyText ( addr u -- ) Tip! hIcon @ ModifyIcon ;

\ #define NIIF_INFO       0x00000001
\ #define NIIF_WARNING    0x00000002
\ #define NIIF_ERROR      0x00000003

M: Balloon ( a1 u1 a2 u2 info-flag time -- )
\ NIF_INFO = &H10
    uTimeout !
    dwInfoFlags !
    255 MIN szInfo ZPLACE
    63 MIN szInfoTitle ZPLACE
    16 uFlags @ OR uFlags !
    hIcon @ ModifyIcon ;

M: BalloonOFF
    uFlags @ 16 -1 XOR AND uFlags !
    hIcon @ ModifyIcon
;

;CLASS

