(    Windows )

REQUIRE { ~nn/lib/locals.f
REQUIRE S>UNICODE ~nn/lib/unicode.f

MODULE: DLGRES-MODULE

VARIABLE DLG-DP   \    
VARIABLE DLG-BEG
: DLG-ALLOT DLG-DP +! ;
: DLG-HERE DLG-DP @ ;
: DLG, DLG-HERE ! CELL DLG-ALLOT ;
: DLGW, DLG-HERE W! 2 DLG-ALLOT ;


\ --------------------------------------------------------
\ *******       
0
4 -- DLGT.style
4 -- DLGT.dwExtendedStyle
2 -- DLGT.cdit
2 -- DLGT.x
2 -- DLGT.y
2 -- DLGT.cx
2 -- DLGT.cy
CONSTANT /DLGTEMPLATE

0
4 -- DLGIT.style
4 -- DLGIT.dwExtendedStyle
2 -- DLGIT.x
2 -- DLGIT.y
2 -- DLGIT.cx
2 -- DLGIT.cy
2 -- DLGIT.id
CONSTANT /DLGITEMTEMPLATE

: L", ( a u --)
    S>UNICODE OVER >R
    DLG-HERE SWAP 2+ DUP DLG-ALLOT MOVE
    R> FREE DROP 
\ 0 ?DO DUP I + C@ DLGW, LOOP DROP 0 DLGW,
;

: LALIGN DLG-HERE 4 MOD 2 = IF -2 DLG-ALLOT BL DLG, THEN ;

: L" ( "ccc" -- ) \ *******    UNICODE
  [CHAR] " PARSE
  L",
;

\ ************************************************************************
EXPORT

: ALIGN8 ( a -- a1) 7 + 8 / 8 *  ;
: DLG-ALIGN DLG-HERE ALIGN8 DLG-HERE - DLG-ALLOT  ;


: BEGIN-DIALOG ( x y cx cy style "name" -- dlg 0 )
    { a u \ t -- }
  10240 ALLOCATE THROW DUP DLG-DP ! DLG-BEG !
  DLG-HERE 0 DLG,
  DLG-ALIGN
  DLG-HERE OVER - SWAP !    \    
  DLG-HERE DUP TO t /DLGTEMPLATE DUP DLG-ALLOT ERASE
  t DLGT.style !
  0 t DLGT.cdit W!
  t DLGT.cy W!
  t DLGT.cx W!
  t DLGT.y W!
  t DLGT.x W!
  t 0
  0 DLGW, \ menu  (no menu)
  0 DLGW, \ class (def)
\  >IN @ #TIB @ <
  a u L", LALIGN
    \ title
;

\ : DIALOG: ( x y cx cy style "name" -- dlg 0 )  CREATE  (DIALOG)  ; 

: END-DIALOG ( dlg n -- a u ) 
\    
\         
    SWAP DLGT.cdit W! 
    DLG-BEG @ DLG-HERE OVER - DUP >R RESIZE THROW
    R>
;

: DIALOG-ITEM ( N x y cx cy style class_id S" text" id -- N+1 )
  { a u id \ t -- }
  DLG-HERE DUP TO t /DLGITEMTEMPLATE DUP DLG-ALLOT ERASE
  -1 DLGW, DLGW, \ class_id
  WS_VISIBLE OR WS_CHILD OR
  t DLGIT.style !
  t DLGIT.cy   W!
  t DLGIT.cx   W!
  t DLGIT.y    W!
  t DLGIT.x    W!
  id t DLGIT.id   W!
\  >IN @ #TIB @ <
  a u L", LALIGN \ title (initial text)
\  DLG-HERE 4 MOD 2 = IF -2 DLG-ALLOT BL DLGW, 0 DLGW, THEN \ , MS, MS ... :)
  0 DLG,                   \ creation data
  1+
;

: DIALOG-FONT ( S" typeface" size codepage -- )
  SWAP DLGW, >R L", R> DLGW,
;

: DIALOG, ( a u -- a1)
\     
  HERE ALIGN8 HERE - ALLOT
  HERE >R
  SWAP DUP @ + ( u a-dlg --) SWAP
  DUP ALLOT
  R@ SWAP MOVE
  R>
;


;MODULE