REQUIRE CLASS: class.f
REQUIRE LIST list.f

CLASS: REAL-OBJECT
    CELL FIELD name       \ 
    M: name!
        DUP 2 + ALLOCATE THROW name !
        DUP name @ C!
        name @ 1+ SWAP CMOVE
        0 name @ COUNT + C!  ;
    M: CONSTRUCTOR ( S" NAME" --)  name! ;
    M: DESTRUCTOR  name @ FREE THROW ;
    M: PRINT name @ ID. ;
;CLASS

CLASS: MATTER  DERIVE REAL-OBJECT      \ 
    CELL FIELD density    \  /3
    M: CONSTRUCTOR ( density S" NAME" --)
        INHERIT
        density ! ;
    M: PRINT ." Matter: " INHERIT CR
        ." Density is " density @ . CR
    ;
;CLASS

CLASS: BODY   DERIVE REAL-OBJECT       \ 
    CELL FIELD mass       \ 
    CELL FIELD volume     \ 
    CELL FIELD matter     \   ,     
    M: CONSTRUCTOR ( mass volume matter S" name" )
        INHERIT
        matter !
        volume !
        mass !
    ;
    M: PRINT
        ." Body: " INHERIT CR
        matter @ SEE-> MATTER PRINT
        ." Volume is " volume @ . ." , "
        ." mass is " mass @ . CR
    ;
;CLASS

.( xxx) CR
2000 S" iron" INSTANCE MATTER IRON
1000 S" water" INSTANCE MATTER WATER
CLASS: IRON-CUBE DERIVE BODY
    CELL FIELD edge
    M: CONSTRUCTOR  ( edge --)
        edge !
        edge @ DUP DUP * *
        DUP IRON density @ *
        SWAP
        IRON SELF
        S" iron cube"
        INHERIT
    ;
;CLASS

2 INSTANCE IRON-CUBE CUBE1 
3 INSTANCE IRON-CUBE CUBE2


INSTANCE LIST L1
CUBE1 SELF L1 APPEND
CUBE2 SELF L1 APPEND
IRON  SELF L1 ADD
WATER SELF L1 APPEND

: PP ( addr-instance -- )
    ." ---------------------------" CR
    >R
    R@ SEE-> SUPERCLASS >PARENT 
    R@ C" PRINT" FEX2
    RDROP
    PREVIOUS
;

' PP L1 FOR-EACH
.( ------------------------) CR