REQUIRE CLASS: ~nemnick\class\ver2\class.f
REQUIRE LIST ~nemnick\class\ver2\list.f

CLASS: REAL-OBJECT
    CELL FIELD name       \ 
    CELL FIELD prt        \ 
    M: name!
        DUP 2 + ALLOCATE THROW name !
        DUP name @ C!
        name @ 1+ SWAP CMOVE
        0 name @ COUNT + C!  ;
    M: PRINT name @ ID. ;
    CONSTR: CONSTRUCTOR ( S" NAME" --)
        name!
        ['] PRINT prt !
    ;
    DESTR: DESTRUCTOR  name @ FREE THROW ;
    M: EXEC-PRINT prt @ EXECUTE ;

;CLASS

CLASS: MATTER  <SUPER REAL-OBJECT      \ 
    CELL FIELD density    \  /3
    M: PRINT ." Matter: " INHERIT CR
        ." Density is " density @ . CR
    ;
    CONSTR: CONSTRUCTOR ( density S" NAME" --)
        INHERIT
        density !
        ['] PRINT prt !
        ;
;CLASS

CLASS: BODY   <SUPER REAL-OBJECT       \ 
    CELL FIELD mass       \ 
    CELL FIELD volume     \ 
    CELL FIELD matter     \   ,     
    M: PRINT
        ." Body: " INHERIT CR
        matter @ SEE-> MATTER PRINT
        ." Volume is " volume @ . ." , "
        ." mass is " mass @ . CR
    ;
    CONSTR: CONSTRUCTOR ( mass volume matter S" name" )
        INHERIT
        ['] PRINT prt !
        matter !
        volume !
        mass !
    ;
;CLASS

2000 S" iron" INSTANCE MATTER IRON
1000 S" water" INSTANCE MATTER WATER
CLASS: IRON-CUBE <SUPER BODY
    CELL FIELD edge
    CONSTR: CONSTRUCTOR  ( edge --)
        edge !
        edge @ DUP DUP * *
        DUP IRON density @ *
        SWAP
        IRON SELF
        S" iron cube"
        INHERIT
    ;
;CLASS

2 INSTANCE IRON-CUBE CUBE1 
3 INSTANCE IRON-CUBE CUBE2


INSTANCE LIST L1
CUBE1 SELF L1 APPEND
CUBE2 SELF L1 APPEND
IRON  SELF L1 ADD
WATER SELF L1 APPEND

: PP ( addr-instance -- )
    ." ---------------------------" CR
    SEE-> REAL-OBJECT EXEC-PRINT
;

' PP L1 FOR-EACH
.( ------------------------) CR