REQUIRE { ~nn/lib/locals.f
REQUIRE WC-COMPARE ~nn/lib/wcmatch.f
REQUIRE ONLYNAME ~nn/lib/filename.f
REQUIRE WC|RE-COMPARE ~nn/lib/wcre.f

USER PROC-FULLPATH?
USER <ProcID>
: PROC-FULLPATH PROC-FULLPATH? ON ;

: KERN: ( .. a u -- ior)
    >IN @ 
    CREATE 0 , 
    >IN ! BL WORD ", 0 C, 
    DOES>
      DUP @ ?DUP 0=
      IF DUP CELL+ 1+
         S" KERNEL32.DLL" DROP GetModuleHandleA
         GetProcAddress DUP ROT !
      ELSE NIP THEN
      ?DUP IF API-CALL ELSE 0 THEN
;


KERN: CreateToolhelp32Snapshot
\ HANDLE WINAPI CreateToolhelp32Snapshot(DWORD dwFlags, DWORD th32ProcessID);

2 CONSTANT TH32CS_SNAPPROCESS

KERN: Process32First
\ BOOL WINAPI Process32First(HANDLE hSnapshot, LPPROCESSENTRY32 lppe);
 
KERN: Process32Next
\ BOOL WINAPI Process32Next(HANDLE hSnapshot, LPPROCESSENTRY32 lppe);

0 
1 CELLS -- th32dwSize
1 CELLS -- cntUsage
1 CELLS -- th32ProcessID
1 CELLS -- th32DefaultHeapID
1 CELLS -- th32ModuleID
1 CELLS -- cntThreads
1 CELLS -- th32ParentProcessID
1 CELLS -- pcPriClassBase
1 CELLS -- th32dwFlags
MAX_PATH -- szExeFile
CONSTANT /PROCESSENTRY32 

: WalkProc95 { xt \ hSnap pe -- }
    0 TH32CS_SNAPPROCESS CreateToolhelp32Snapshot TO hSnap
        hSnap -1 = IF EXIT THEN
    /PROCESSENTRY32 ALLOCATE THROW TO pe
    /PROCESSENTRY32 pe th32dwSize !
    pe hSnap Process32First
    IF
        BEGIN 
          pe szExeFile ASCIIZ> 
          PROC-FULLPATH? @ 0= IF ONLYNAME THEN
          pe th32ProcessID @ 
          xt EXECUTE 0=
          pe hSnap Process32Next 0= OR
        UNTIL
    THEN
    hSnap CloseHandle DROP
;

USER-CREATE ProcPattern 2 CELLS USER-ALLOT
USER ProcFound

: FindProc { a u id \ continue -- ? } \ false - terminate loop
    TRUE TO continue
    a u ProcPattern 2@ WC|RE-COMPARE 
    IF id ProcFound ! FALSE TO continue
    ELSE  
      <ProcID> @ ?DUP
      IF id = IF id ProcFound ! FALSE TO continue THEN THEN
    THEN
    continue
;

: (PROC-EXIST?) ( a u xt -- ProcId/0)
    >R
    ProcPattern 2!
    ProcFound 0!
    ['] FindProc R> EXECUTE
    ProcFound @
;

\ : PROC-EXIST95? ( a u --  ProcId/0) ['] WalkProc95 (PROC-EXIST?) ;