REQUIRE ENV ~nn/lib/env.f
REQUIRE HOLDS lib/ext/string.f
REQUIRE GET-CUR-TIME ~nn/lib/time.f
REQUIRE S>NUM ~nn/lib/s2num.f

0 VALUE VERSION-DATE
0 VALUE #BUILD
0 VALUE APP-VERSION
0 VALUE APP-BETA
0 VALUE APP-RC
: BUILD.TXT S" build.txt" ;

\ : S>NUM 0 0 2SWAP >NUMBER 2DROP D>S ;

: S>VB ( a u -- )
    0 0 2SWAP >NUMBER 2SWAP D>S TO APP-VERSION
    OVER C@ [CHAR] b = 
    IF 1 /STRING S>NUM TO APP-BETA   ELSE 
    OVER C@ [CHAR] r = 
    IF 1 /STRING S>NUM TO APP-RC   ELSE
    2DROP 0 THEN THEN
;

: BUILD!
    S" VER" ENV ?DUP 
    IF S>VB
    ELSE DROP THEN
    BUILD.TXT R/O OPEN-FILE THROW >R
    PAD 64 R@ READ-LINE THROW
    IF PAD SWAP S>NUM TO #BUILD
    ELSE DROP THEN
    R> CLOSE-FILE THROW
    GET-CUR-TIME
    Year@ Mon@ Day@ YMD>DATE TO VERSION-DATE
;

: BUILD++
    BUILD!
    BUILD.TXT R/W OPEN-FILE THROW >R
    #BUILD 1+ DUP TO #BUILD
    DUP ." Build # " . CR
    S>D <# #S #> 
    0. R@ RESIZE-FILE THROW
    R@ WRITE-LINE THROW
    R> CLOSE-FILE THROW
;

: SVERSION ( -- a u )
    <# VERSION-DATE DATE>YMD ROT S>D # # # # [CHAR] . HOLD 2DROP
       SWAP S>D # # [CHAR] . HOLD 2DROP
       S>D #S 2DROP BL HOLD
       #BUILD S>D #S 2DROP S"  Build " HOLDS
       APP-BETA ?DUP IF S>D #S 2DROP [CHAR] b HOLD THEN
       APP-RC ?DUP IF S>D #S 2DROP S"  RC" HOLDS THEN
       APP-VERSION S>D # # [CHAR] . HOLD #S #> ;

