WINAPI: GetColorerProc icolorer.dll
WINAPI: GetRegExpProc  icolorer.dll

42 CELLS CONSTANT /scc
CREATE scc /scc CELLS ALLOT \ scc /scc ERASE

: co-- CREATE DUP , CELL+ DOES> @ scc + @  API-CALL ;

0
CELL -- scc-size
co-- cdCreate
co-- cdCreateIndirect
co-- cdDestroy
co-- cdGetRegion
co-- cdEnumTypes
co-- cdSelType
co-- cdLoadType
co-- cdGetVersion
co-- cdGetSchemeName
co-- ccCreate
co-- ccDestroy
co-- ccClearCache
co-- ccBreakParse
co-- ccSetServices
co-- ccSetColoringSrc
co-- ccQuickParse
co-- ccFullParse
co-- crCreateRegions
co-- crDestroyRegions
co-- crSetFirstLine
co-- clrAddRegion   \ note! there is no stub for it! this is not WINAPI function!
co-- crClearRegions
co-- crAssignRegions
co-- crCompactRegions
co-- caCreate
co-- caDestroy
co-- caLoad
co-- caSave
co-- caGetCData
co-- caSetCData
co-- caMaxRegion
co-- csNext
co-- csPrev
co-- csChild
co-- csParent
co-- csGetName
co-- csGetParam
co-- csGetChrParam
co-- csGetIntParam
co-- csGetFltParam
co-- cdLoadFile
/scc <> -1 ?ERROR

: co-init { a u -- }
    /scc scc scc-size !
    scc GetColorerProc
    0= ABORT" Can't get colorer procs."
;
( 
: co_dll S" icolorer.dll" DROP ;
: co_hdll co_dll GetModuleHandleA ;
: co_load co_hdll 0= IF co_dll LoadLibraryA ERR THROW THEN ;
: co_api \ a u -- ?
    DROP co_dll GetModuleHandleA ?DUP 
    IF GetProcAddress ?DUP 
        IF API-CALL ELSE GetLastError THROW THEN
    ELSE GetLastError THROW THEN  ;

: GetColorerProc S" GetColorerProc" co_api ;
: GetRegExpProc S" GetRegExpProc" co_api ;
)
REQUIRE <EOF> ~nn/lib/eof.f
\ <EOF>
: test
    co-init
;
test