REQUIRE GetHSA ~nn/lib/security/secinfo.f
REQUIRE { ~nn/lib/locals.f

10240 VALUE COPY-FILE-BUF-SIZE
USER-VALUE COPY-FILE-BUF
\ USER COPY-FILE-XT

: (COPY-FILE) { a1 u1 a2 u2 flag_sa \ fh1 fh2 -- }
    a2 u2 DELETE-FILE DROP
    COPY-FILE-BUF-SIZE ALLOCATE THROW TO COPY-FILE-BUF
    a1 u1 R/O OPEN-FILE-SHARED THROW TO fh1
    fh1 0 
    CREATE_ALWAYS
    flag_sa IF fh1 GetHSA ELSE 0 THEN
    3 GENERIC_WRITE a2 CreateFileA 
    DUP INVALID_HANDLE_VALUE <> ERR THROW TO fh2
    
    BEGIN COPY-FILE-BUF COPY-FILE-BUF-SIZE fh1 READ-FILE THROW ?DUP WHILE
        COPY-FILE-BUF SWAP fh2 WRITE-FILE THROW
\        COPY-FILE-XT @ CATCH THROW
    REPEAT

    fh1 CLOSE-FILE THROW
    fh2 CLOSE-FILE THROW
;

: COPY-FILE ( a1 u1 a2 u2 flag_sa -- ior)
    0 TO COPY-FILE-BUF 
    ['] (COPY-FILE) CATCH
    DUP IF >R 2DROP 2DROP DROP R> THEN
    COPY-FILE-BUF ?FREE
;

( 
: test { sa -- }
    S" e:\bin\unzip.exe"
    S" e:\tmp\unzip.exe" sa COPY-FILE THROW
;
TRUE test KEY DROP
FALSE test
)