( interactive debugger for )
( Mihail Maksimov 2001     )

REQUIRE Code         ~mak\asm\ASM.FRT 
REQUIRE DISASSEMBLER lib\ext\disasm.f 
REQUIRE CASE         lib\ext\case.f 

ALSO DISASSEMBLER

VARIABLE &EIP
VARIABLE &ESP

VECT VTR

0 VALUE RANGE

: RUN ." RUN" 0xE9 RANGE C! &EIP @ RANGE - 5 - RANGE 1+ !  ;

: 1STEP ( &EIP N -- )
  DROP C@ RANGE     C!  1 &EIP +!  RDROP ;

: 2STEP ( &EIP N -- )
  DROP W@ RANGE     W!  2 &EIP +!  RDROP ;
 
: 3STEP ( &EIP N -- )
  DROP DUP C@ RANGE C!
  1+   W@ RANGE 1+  W!  3 &EIP +!  RDROP ;

: 4STEP ( &EIP N -- )
  DROP  @ RANGE      !  4 &EIP +!  RDROP ;

: 5STEP ( &EIP N -- )
  DROP DUP C@ RANGE C!
  1+    @ RANGE 1+   !  5 &EIP +!  RDROP ;

: 6STEP ( &EIP N -- )
  DROP DUP W@ RANGE W!
  2+    @ RANGE 2+   !  6 &EIP +!  RDROP ;

: 7STEP ( &EIP N -- )
  DROP DUP  @ RANGE  !
  3 +   @ RANGE 3 +  !  7 &EIP +!  RDROP ;

BASE @ HEX
: NST  ( -- )
  &EIP @
  DUP C@      \  CFA  N'
\  DUP   0C3 = IF 2DROP     EXIT THEN  \ RET

  DUP5B?      IF  5STEP  THEN \ ADD EAX, # X

\ 010X.XXXX
  DUP E0 AND 40 = IF 1STEP THEN  \ INC|DEC|PUSH|POP  E_X

\ FS: GS: D16: A16: INSB INSD OUTSB OUTSD
\ 0110.X1XX
  DUP   F4 AND 64 = IF  1STEP      THEN

  DUP   099 = IF  1STEP      THEN  \ CDQ

  DUP   0BB = IF  5STEP     THEN  \ MOV EBX, # X
  DUP   068 = IF  5STEP     THEN  \ MOV EBX, # X

\  JO JNO JB JAE JE JNE JBE JA JS JNS JP JNP JL JGE JLE JG
\ 0111.XXXX
\  DUP  F0 AND 70 = IF  2STEP     THEN

\  DUP   0E9 = IF 1A_,_STEP      THEN  \  JMP
  DROP
  DUP W@
  DUP3B?[EBP]  IF  3STEP   THEN
  DUP3B?       IF  3STEP   THEN
  DUP2B?       IF  2STEP   THEN
  DUP 0C48B =  IF  2STEP   THEN  \ MOV EAX , ESP
  DUP  C58B =  IF  2STEP   THEN  \ MOV EAX,  EBP

  DUP 06D8D =  IF  3STEP   THEN  \ LEA  EBP, OFF-EBP [EBP]

  DUP 0C583 =  IF  3STEP   THEN  \ ADD  EBP, # OFF-EBP

  DUP 0ED83 =  IF  3STEP   THEN  \ SUB  EBP, # OFF-EBP

  DUP 0C483 = IF  3STEP     THEN  \ ADD  ESP, # X
  DUP6B?      IF  6STEP      THEN  \ MOV  EAX,  # X
\  DUP 0E3FF = IF EVEN-EBP 2STEP THEN  \ JMP  EBX
\  DUP 0D3FF = IF EVEN-EBP 2STEP THEN  \ CALL EBX
\  DUP 810F  = IF 2A_,_STEP      THEN  \ JO [ESP]
  DUP 45C7   = IF 7STEP          THEN  \ MOV     X [EBP] , # X
  DROP
  DUP @
  DUP 0424448B = IF 4STEP        THEN  \  MOV  EAX, 4 [ESP]

  FFFFFF AND
  DUP 240401 = IF 3STEP      THEN \ ADD [ESP] , EAX
  DUP C09D0F = IF 3STEP      THEN \ SETGE  AL
  DUP C09E0F = IF 3STEP      THEN \ SETLE  AL

\ CMPXCHG [EAX] , AL| EAX
\ LSS     EAX , [EAX]
\ BTR     [EAX] , EAX
\ LFS     EAX , [EAX]
\ LGS     EAX , [EAX]
\ MOVZX   EAX , BYTE|WORD  PTR [EAX]
\ 0000.0000 1011.1XXX 0000.1111
  DUP FFF8FF
  AND 00B00F = IF 3STEP      THEN
  DUP 24442B = IF 4STEP      THEN \ SUB  EAX, X [ESP]
  DUP 85448B = IF 4STEP      THEN \ MOV  EAX, X [EBP] [EAX*4]
  DUP 24048B = IF 3STEP      THEN \ MOV  EAX, 0 [ESP]
  DUP 85048D = IF 7STEP      THEN \ LEA  EAX, X [EAX*4]
  DUP 45048D = IF 7STEP      THEN \ LEA  EAX, X [EAX*2]
  DUP 2404FF = IF 3STEP      THEN \ INC [ESP]
  DUP 18B60F = IF 3STEP      THEN \ MOVZX EBX, BYTE PTR [EAX]
  DUP7B?       IF 7STEP      THEN
  2DROP ." PRESS 'R' FOR RUN" CR
;

BASE !

: .FLAG ( N -- N )
 OVER AND IF ." 1 " ELSE ." 0 " THEN ;

: .REG ( ADDR -- ADDR1 )
   4 - DUP @ 8 H.N SPACE ;

: TrDO &EIP @
 6 0 DO INST CR LOOP DROP
 &ESP @
." EAX=" .REG ." ECX=" .REG ." EDX=" .REG ." EBX=" .REG CR
." ESP=" .REG ." EBP=" .REG ." ESI=" .REG ." EDI=" .REG CR
 4 -           DUP @
    ." C="   0x1   .FLAG
    ." P="   0x4   .FLAG
    ." A="   0x10  .FLAG
    ." Z="   0x40  .FLAG
    ." S="   0x80  .FLAG DROP
              DROP    CR
." EBP-10:" &ESP @ 6 CELLS - @ 0x10 - 0x30 DUMP CR
  0x90909090 DUP RANGE 2!
  KEY UPC
  CASE
  [CHAR] R OF RUN ENDOF
  [CHAR] N OF NST ENDOF
  ENDCASE
;

' TrDO TO VTR

Code TRACE
     POP DWORD PTR  [{&EIP}]
     MOV DWORD PTR  [{&ESP}], ESP
MMM:
FOR  0x60 C,        \ PUSHA
FOR  0x9C C,        \ PUSHFD
     LEA EBP, [EBP-100H]
     CALL { ' VTR}
     LEA EBP, [EBP+100H]
FOR  0x9D C,        \ POPFD
FOR  0x61 C,        \ POPAD
FOR  HERE TO RANGE  0x90909090 DUP , ,
     JMP MMM
;     JMP DWORD PTR  [{&EIP}]
EndCode

PREVIOUS

: XX TRACE 1 0 2 ROT SWAP ;
XX
