REQUIRE { ~nn/lib/locals.f
\ REQUIRE Window ~nn/lib/win/window-ac.f
REQUIRE WinClass ~nn/lib/win/winclass.f
~nn/lib/win/messageloop.f
REQUIRE ZPLACE ~nn/lib/az.f

WINAPI: SetWindowsHookExA USER32.DLL

WINAPI: set_shell_hook nnhook.dll
WINAPI: reset_shell_hook nnhook.dll
0
1 CELLS -- cp-dwData
1 CELLS -- cp-cbData 
1 CELLS -- cp-lpData
DROP

CREATE WinTitleBuf 256 ALLOT
:NONAME  { lparam wparam uMsg hwnd -- }
    uMsg WM_COPYDATA =
    IF
        lparam cp-dwData @ .
        lparam cp-lpData @ lparam cp-cbData @ PAD ZPLACE
        PAD PAD CharToOemA DROP
        PAD ASCIIZ> TYPE CR
        TRUE
    ELSE
        lparam wparam uMsg hwnd DefWindowProcA
    THEN
;
WNDPROC: WinProc

WinClass POINTER wc

0 VALUE WCId

: HookClass ( -- id )
    WCId ?DUP IF EXIT THEN
    WinClass NEW TO wc
    ['] WinProc wc lpfnWndProc !
    0 wc style !
    S" SPFHookTest" DROP wc lpszClassName !
    wc Register TO WCId
    WCId
;

: Window ( class style parent-hwnd -- hwnd )  \ 0 - 訡
         \ ᮧ  㪠   ⢥ ୥  parent
         \ ᫨ parent=0,  ⤥쭮 稭 
  ROT >R SWAP >R >R
\  InitControls
  0 0 0 R@ CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT
  R> R> SWAP IF WS_CHILD OR THEN
  0 R> 0 CreateWindowExA 
  ?DUP 0= IF GetLastError ERROR THEN
;

: hook_handler  { lparam wparam msg hwnd -- }
    msg WM_USER < 0=
    IF ." shell: " msg WM_USER - . CR 
        0
    ELSE
        HEX msg . CR DECIMAL
        lparam wparam msg hwnd DefWindowProcA
    THEN
;

0 VALUE hwnd

: test { x \ hdll hook_proc -- }
    S" nnhook.dll" DROP LoadLibraryA TO hdll

    HookClass 0 0 Window TO hwnd !
    S" SPFHookTest" DROP hdll set_shell_hook DROP

    MessageLoop

    ;

' test TASK: test-task
 0 test-task START DROP
\ test

: BYE reset_shell_hook BYE ;