#include <windows.h>
//#include <stdio.h>

//#define HookClass "SPFHookTest"


//#define DllImport   __declspec( dllimport )
//#define DllExport   __declspec( dllexport )


BOOL WINAPI DllMain(
    HINSTANCE hinstDLL,  // handle to DLL module
    DWORD fdwReason,     // reason for calling function
    LPVOID lpReserved )  // reserved
{
    // Perform actions based on the reason for calling.
    switch( fdwReason ) 
    { 
        case DLL_PROCESS_ATTACH:
         // Initialize once for each new process.
         // Return FALSE to fail DLL load.
            break;

        case DLL_THREAD_ATTACH:
         // Do thread-specific initialization.
            break;

        case DLL_THREAD_DETACH:
         // Do thread-specific cleanup.
            break;

        case DLL_PROCESS_DETACH:
         // Perform any necessary cleanup.
            break;
    }
    return TRUE;  // Successful DLL_PROCESS_ATTACH.
}

#define NUM_TITLES 6
#define LEN_TITLE 256
#pragma data_seg(".SHARD")
HWND hwshell=NULL;
HHOOK HookHandle=NULL;
HHOOK hhMOUSE=NULL;
HHOOK hhKB=NULL;
int LastActTick=0;
char HookClass[32]="NNCronCtrlClass";
int prev_ms_x;
int prev_ms_y;
#pragma data_seg()
#pragma comment(linker, "/SECTION:.SHARD,RWS") 

//#ifdef MSVC
//#pragma comment(linker, "/SECTION:.shared,RWS") 
//#endif

//void log(int num, char *s){
//   FILE *f=fopen("e:\\home\\src\\cron\\hook.txt", "at");
//   fprintf(f, "%d %s\n", num, s);
//   fclose(f);
//}
//DllExport
LRESULT CALLBACK shell_proc(
  int nCode,      // hook code
  WPARAM wParam,  // event-specific information
  LPARAM lParam   // event-specific information
){ 
   //log(nCode, HookClass);
   if(hwshell==NULL) {
        hwshell=FindWindow(HookClass, NULL);
   }
//   Beep(100, 100);
   if(  nCode==HSHELL_WINDOWACTIVATED ||
        nCode==HSHELL_WINDOWCREATED ||
        nCode==HSHELL_WINDOWDESTROYED ||
        nCode==HSHELL_REDRAW){
        if(hwshell!=NULL){
           COPYDATASTRUCT cpdat;
           char buf[256];
//           Beep(1000, 100);
           cpdat.dwData=nCode;
           cpdat.cbData=GetWindowText((HWND)wParam,buf,256);
//           if(cpdat.cbData==0)
//              cpdat.cbData=GetClassName((HWND)wParam,buf,256);
           cpdat.lpData=(void *)buf;
           SendMessage(hwshell, WM_COPYDATA, wParam, (LPARAM)&cpdat);
        }
   }
   CallNextHookEx(HookHandle,nCode,wParam,lParam);
   return 0;
} 
 
//DllExport
LRESULT CALLBACK set_shell_hook(HANDLE dll_handle, char *hook_class){
    int res=0;
    if(HookHandle==0){
        HookHandle=SetWindowsHookEx(WH_SHELL, (HOOKPROC)shell_proc, dll_handle, 0);
        if(HookHandle==NULL) res=GetLastError();
    }
    lstrcpy(HookClass, hook_class);

//    log(0, HookClass);
    return res;
}

LRESULT CALLBACK reset_shell_hook(){
    if(HookHandle!=NULL){
        UnhookWindowsHookEx(HookHandle);
        HookHandle=0;
    }
    return 0;
}


LRESULT CALLBACK idle_ms_proc(
  int nCode,      // hook code
  WPARAM wParam,  // event-specific information
  LPARAM lParam   // event-specific information
){
//   if(LastActTick==0) 
//   Beep(10000,50);
   PMOUSEHOOKSTRUCT p;
   p=(PMOUSEHOOKSTRUCT)lParam;

   if(nCode==HC_ACTION){
       if(abs((prev_ms_x-p->pt.x))>5 || abs((prev_ms_y-p->pt.y))>5){
          LastActTick=GetTickCount();
          prev_ms_x=p->pt.x;
          prev_ms_y=p->pt.y;
       }
   }
   
   return CallNextHookEx(hhMOUSE,nCode,wParam,lParam);;

}

LRESULT CALLBACK idle_kb_proc(
  int nCode,      // hook code
  WPARAM wParam,  // event-specific information
  LPARAM lParam   // event-specific information
){
   if(nCode==HC_ACTION)
       LastActTick=GetTickCount();
   
   return CallNextHookEx(hhKB,nCode,wParam,lParam);;

}

LRESULT CALLBACK set_idle_hook(HANDLE dll_handle, int mask){
//    Beep(10000,500);
    if(hhMOUSE==0 && (mask & 1)){
        hhMOUSE=SetWindowsHookEx(WH_MOUSE, (HOOKPROC)idle_ms_proc, dll_handle, 0);
        if(hhMOUSE==NULL) return GetLastError();
    }

    if(hhKB==0 && (mask & 2)){
        hhKB=SetWindowsHookEx(WH_KEYBOARD, (HOOKPROC)idle_kb_proc, dll_handle, 0);
        if(hhKB==NULL) return GetLastError();
    }

    LastActTick=GetTickCount();
    return 0;
}

LRESULT CALLBACK reset_idle_hook(){
//    Beep(8000,1000);
    if(hhMOUSE!=NULL) UnhookWindowsHookEx(hhMOUSE);
    if(hhKB!=NULL) UnhookWindowsHookEx(hhKB);
    hhMOUSE=hhKB=0;
    return 0;
}

LRESULT CALLBACK GetIdleTime(){
    return GetTickCount()-LastActTick;
}
