REQUIRE get-string ~nn/lib/getstr.f
VARIABLE out-filename
VARIABLE ini-filename
VARIABLE ini-pre
VARIABLE <load-ini>
0 VALUE OUTFILE

: (ini-name@) @ ?DUP IF ASCIIZ> ELSE S" " THEN ;
: ini-filename@ ini-filename (ini-name@) ;
: out-filename@ out-filename (ini-name@) ;

: STRV! ( a u v -- ) HERE 1+ SWAP ! S", 0 C, ;

: ININAME ini-filename STRV! ; 
: OUTNAME out-filename STRV! ; 

: >outfile
    out-filename @ ?DUP
    IF ASCIIZ> R/W CREATE-FILE-SHARED
        IF DROP ELSE DUP TO H-STDOUT TO OUTFILE THEN
    THEN
;

: SET-CL
  GetCommandLineA ASCIIZ> \ 2DUP TYPE CR
  TIB SWAP C/L MIN DUP #TIB ! MOVE >IN 0!
  get-string 2DROP
;

: set-ini-file
  SET-CL
  BEGIN get-string ?DUP WHILE
    S" -ini" COMPARE 0=
    IF get-string ININAME 1 WORD DROP EXIT THEN
  REPEAT
  DROP
;


WARNING @ WARNING 0!
: BYE
    OUTFILE ?DUP
    IF
        CLOSE-FILE DROP
        out-filename @ ?DUP IF ASCIIZ> DELETE-FILE DROP THEN
    THEN
    BYE
;
WARNING !

: load-ini
    <load-ini> @ ?DUP IF EXECUTE EXIT THEN
    POSTPONE [
    ['] <PRE> BEHAVIOR >R
    ini-pre @ ?DUP IF TO <PRE> THEN
    ini-filename @ ?DUP 
    IF COUNT ['] INCLUDED CATCH
       IF 2DROP THEN THEN
    R> TO <PRE>
;

: DEF-INI
    >outfile
    load-ini
;

' DEF-INI ' SPF-INI JMP
