\ FTP interface
REQUIRE Connection ~nn/lib/net/connect.f
REQUIRE xx ~nn/lib/xx.f


CLASS: FTP
    var vHostname       \ az
    var vPort           \ number
    var vBaseDir        \ az,  i.g. /public_html
    var vUserName       \ az
    var vPassword       \ az
    var vProxy          \ az or 0 (no proxy)
    var vProxyPort      \ number
    var vProxyType      \ type of proxy
    var vAfterOpen

    var vRas

    var vSystem         \ az, Response of SYST command
    var vInpBuf         \   ⢥⮢ ࢥ
    var vLog            \ xt, ᫮ ୠ樨 ( a u log-level --)


    Connection OBJ CtrlSock

    Socket OBJ DataSock

    M: SetVars
        vProxy @ 0= IF vHostname @ vPort @ ELSE vProxy @ vPort @ THEN
        CtrlSock vPort ! CtrlSock vAddr !
        vRas @ CtrlSock vRas !
    ;
        
    M: Open
        SetVars
        CtrlSock Open 0= 
        IF CtrlSock vIOR @ THROW 
            
        ELSE vAfterOpen @ ?DUP IF EXECUTE THEN THEN
    ;

    M: ?OPEN ( -- )
        \ ᮧ ᮥ, ᫨  
        \ ᫨ ᮥ  - 祣  
        CtrlSock IsConnected 0=  IF Open THEN
    ;
    : FTP-LOG ( a u level --)   vLog @ EXECUTE ;

    S" ftp-cmd.f" INCLUDED
    : DefAfterOpen
        CtrlRead 
        ESTABL-CONN-RL EXEC-RESP
        vSystem @ 0= IF system vInpBuf @ 4 + ASCIIZ> S>ZALLOC vSystem ! THEN
        binary
    ;
    : DefLog ( a u level --)    DROP TYPE CR  ;
    CONSTR: init
        ['] DefAfterOpen vAfterOpen !
        1024 ALLOCATE THROW vInpBuf !
        ['] DefLog vLog !
        1020 vCurPort !
    ;

    
M: Host! S>ZALLOC vHostname ! ;
M: Port! vPort ! ;
M: Proxy! S>ZALLOC vProxy ! ;

M: Close bye ;
M: get ( az-remotepath az-localpath --)
;
M: NextPort ( -- )
    vPort
;

: ,# S>D #S 2DROP [CHAR] , HOLD ;
: port-arg ( -- a u )
    64 PAD gethostname IF WSAGetLastError THROW THEN
    PAD ASCIIZ> GetHostIP THROW 
    <#
        vCurPort @ 256 /MOD SWAP ,# ,#
        [ HEX ]
            1000000 /MOD ,#
            10000   /MOD ,#
            100     /MOD ,#
            S>D #S
        [ DECIMAL ]
    #>
;

M: List ( az-dirpath -- az)
    port
;
;CLASS