REQUIRE Window    ~ac/lib/win/window/window.f
REQUIRE LoadIcon  ~ac/lib/win/window/image.f
REQUIRE TrackMenu ~ac/lib/win/window/popupmenu.f

WINAPI: Shell_NotifyIcon SHELL32.DLL

0 CONSTANT NIM_ADD
1 CONSTANT NIM_MODIFY
2 CONSTANT NIM_DELETE

1 CONSTANT NIF_MESSAGE
2 CONSTANT NIF_ICON
4 CONSTANT NIF_TIP

0
4 -- cbSize
4 -- hWnd
4 -- uID
4 -- uFlags
4 -- uCallbackMessage
4 -- hIcon
64 -- szTip
CONSTANT /NOTIFYICONDATA


: INIT-ICON-DATA ( -- IconData)
    /NOTIFYICONDATA ALLOCATE THROW >R
    /NOTIFYICONDATA R@ cbSize !
    R@ R@ uID !
    NIF_MESSAGE NIF_ICON OR NIF_TIP OR R@ uFlags !
    R>
;


: TRAY-ICON-DELETE ( IconData -- )
  DUP NIM_DELETE Shell_NotifyIcon DROP
  FREE THROW
;
: TRAY-ICON-CREATE ( addr u icona iconu cmd hwnd -- IconData )
\  || a u ia iu cmd h mem || (( a u ia iu cmd h ))
  INIT-ICON-DATA >R
  R@ hWnd !
  R@ uCallbackMessage !
  LoadIcon R@ hIcon !
  R@ szTip 64 ERASE
  R@ szTip SWAP MOVE
\  R@ TrayIconDelete
  R@ NIM_ADD Shell_NotifyIcon DROP
  R>
;
: TRAY-ICON-CREATE-FROM-RESOURCE ( addr u iconid cmd hwnd -- IconData)
\  || a u id cmd h mem || (( a u id cmd h ))
  INIT-ICON-DATA >R
  R@ hWnd !
  R@ uCallbackMessage !
  LoadIconResource16 R@ hIcon !
  R@ szTip 64 ERASE
  R@ szTip SWAP MOVE
\  TrayIconDelete
  R@ NIM_ADD Shell_NotifyIcon DROP
  R>
;
: TRAY-ICON-MODIFY ( addr u icona iconu IconData -- )
\  || a u ia iu cmd h mem || (( a u ia iu cmd h ))
  >R
\  R@ hWnd !
\  R@ uCallbackMessage !
  LoadIcon R@ hIcon !
  R@ szTip 64 ERASE
  R@ szTip SWAP MOVE
  R@ NIM_MODIFY Shell_NotifyIcon DROP
  RDROP
;
: TRAY-ICON-MODIFY-TEXT ( addr u IconData -- )
\  || a u cmd h mem || (( a u cmd h ))
  >R
\  R@ hWnd !
\  R@ uCallbackMessage !
  R@ szTip 64 ERASE
  R@ szTip SWAP 63 MIN MOVE
  R@ NIM_MODIFY Shell_NotifyIcon DROP
  RDROP
;

\ S"  " S" ico\mail10.ico" 1997 S" STATIC" 0 0 Window TrayIconCreate KEY DROP TrayIconDelete

