REQUIRE RasGetErrorStringA ~nn/LIB/RAS.F

WINAPI: RasEnumEntriesA    RASAPI32.DLL

\ DWORD RasEnumEntries (
\  LPCTSTR reserved,       // reserved, must be NULL
\  LPTCSTR lpszPhonebook,  // pointer to full path and filename of 
\                          // phone-book file
\  LPRASENTRYNAME lprasentryname,
\                          // buffer to receive phone-book entries
\  LPDWORD lpcb,           // size in bytes of buffer
\  LPDWORD lpcEntries      // number of entries written to buffer
\ );
 
\ typedef struct _RASENTRYNAME { 
\    DWORD  dwSize; 
\    TCHAR  szEntryName[RAS_MaxEntryName + 1]; 
\ }RASENTRYNAME; 

0
1 CELLS -- RASEN.dwSize
260     -- RASEN.szEntryName
\ DROP
\ 532
CONSTANT /RASEN
USER RASEN_num
USER RASEN_len

: RasGetEntries ( -- a cnt)
    /RASEN 20 * RASEN_len !
    RASEN_len @ ALLOCATE THROW >R
    /RASEN R@ RASEN.dwSize !
    RASEN_num RASEN_len R@ 0 0
    RasEnumEntriesA ?DUP
    IF 
        [ DEBUG? ] [IF] >R
                        256 PAD R@ RasGetErrorStringA DROP
                        PAD ASCIIZ> TYPE
                        CR R>
                        [THEN]
        TO RASError
        R> FREE DROP PAD 0 EXIT
    THEN
    R> RASEN_num @
;

WINAPI: RasGetCredentialsA RASAPI32.DLL
\ DWORD RasGetCredentials(
\  LPCTSTR lpszPhonebook,            // pointer to the full path and
\                                    // filename of a phone-book file
\  LPCTSTR lpszEntry,                // pointer to the name of a
\                                    // phone-book entry
\  LPRASCREDENTIALS lpCredentials    // pointer to structure that
\                                    // receives credentials
\ );
 
0
1 CELLS -- RASCR.dwSize
1 CELLS -- RASCR.dwMask
257     -- RASCR.szUserName
257     -- RASCR.szPassword
16      -- RASCR.szDomain
2 + CONSTANT /RASCREDENTIALS
 
: RasGetCred ( a u -- astruct ior )
    /RASCREDENTIALS ALLOCATE THROW >R
    /RASCREDENTIALS R@ RASCR.dwSize !
    7 R@ RASCR.dwMask !
    DROP R@ SWAP 0 RasGetCredentialsA 
    R> SWAP
;