REQUIRE CLASS: ~nn/class/class.f
REQUIRE SONLINE? ~nn/lib/ras.f

WINAPI: RasGetConnectionStatistics RASAPI32.DLL

CLASS: RasStats
    RECORD: RAS_STATS
     var dwSize
     var dwBytesXmited
     var dwBytesRcved
     var dwFramesXmited
     var dwFramesRcved
     var dwCrcErr
     var dwTimeoutErr
     var dwAlignmentErr
     var dwHardwareOverrunErr
     var dwFramingErr
     var dwBufferOverrunErr
     var dwCompressionRatioIn
     var dwCompressionRatioOut
     var dwBps
     var dwConnectDuration
    ;RECORD /RAS_STATS
    var hconn

CONSTR: init /RAS_STATS dwSize ! ;

M: GetRasStat ( -- ) RAS_STATS hconn @ RasGetConnectionStatistics THROW ;

;CLASS

USER rasstat

: RAS-BPS ( S" conn" -- bps)
    RASSTAT-OPEN
    rasstat @ >CLASS RasStats dwBps @
    RASSTAT-CLOSE
;

: RAS-DURATION ( S" conn" -- bps)
    RASSTAT-OPEN
    rasstat @ >CLASS RasStats dwBps @
    RASSTAT-CLOSE
;
