REQUIRE /STRING lib/ext/string.f
REQUIRE S>ZALLOC ~nn/lib/az.f

UseDLL ADVAPI32.DLL
\ WINAPI: RegQueryValueExA ADVAPI32.DLL
\ WINAPI: RegOpenKeyA      ADVAPI32.DLL
\ WINAPI: RegOpenKeyExA    ADVAPI32.DLL
\ WINAPI: RegDeleteKeyA    ADVAPI32.DLL
\ WINAPI: RegDeleteValueA  ADVAPI32.DLL
\ WINAPI: RegCloseKey      ADVAPI32.DLL
\ WINAPI: RegCreateKeyA    ADVAPI32.DLL
\ WINAPI: RegCreateKeyExA  ADVAPI32.DLL
\ WINAPI: RegSetValueExA   ADVAPI32.DLL
\ WINAPI: RegDeleteValueA  ADVAPI32.DLL
\ WINAPI: RegQueryValueA   ADVAPI32.DLL
\ WINAPI: RegSetValueA     ADVAPI32.DLL
\ WINAPI: RegEnumValueA    ADVAPI32.DLL

HEX
\ 80000002 CONSTANT HKEY_LOCAL_MACHINE
DECIMAL

CREATE MS C" SOFTWARE\Microsoft" ", 0 C,  \ "
\ *  0 CONSTANT REG_NONE
\ *  1 CONSTANT REG_SZ
\ *  2 CONSTANT REG_EXPAND_SZ
\ *  3 CONSTANT REG_BINARY
\ *  4 CONSTANT REG_DWORD
\ *  4 CONSTANT REG_DWORD_LITTLE_ENDIAN
\ *  5 CONSTANT REG_DWORD_BIG_ENDIAN
\ *  6 CONSTANT REG_LINK
\ *  7 CONSTANT REG_MULTI_SZ
\ *  8 CONSTANT REG_RESOURCE_LIST
\ *  9 CONSTANT REG_FULL_RESOURCE_DESCRIPTOR
\ * 10 CONSTANT REG_RESOURCE_REQUIREMENTS_LIST

0 [IF] \ old
USER HREGKEY
0
256         -- REG.ValueName
1 CELLS     -- REG.cbValueName
1 CELLS     -- REG.Type
256         -- REG.Data
1 CELLS     -- REG.cbData
2 CELLS     -- REG.findName
1 CELLS     -- REG.user-data
1 CELLS     -- REG.index
CONSTANT /REG-VALUE
USER-VALUE REG-VALUE

: (GET-REG-VALUE) ( Address S" ValueName" S" keypath" branch -- )
    >R DROP >R
    REG-VALUE REG.findName 2!
    0 OVER !
    REG-VALUE REG.user-data !

    HREGKEY R> R> RegOpenKeyA IF EXIT THEN

    REG-VALUE REG.index 0!
    BEGIN
        255 REG-VALUE REG.cbValueName !
        255 REG-VALUE REG.cbData !
        REG-VALUE REG.cbData
        REG-VALUE REG.Data
        REG-VALUE REG.Type
        0
        REG-VALUE REG.cbValueName
        REG-VALUE REG.ValueName
        REG-VALUE REG.index @
        HREGKEY @
        RegEnumValueA ERROR_SUCCESS =
    WHILE
        REG-VALUE REG.findName 2@
        REG-VALUE REG.ValueName
        REG-VALUE REG.cbValueName @
        COMPARE 0=
        IF REG-VALUE REG.Data REG-VALUE REG.user-data @
           REG-VALUE REG.cbData @ 1+ CMOVE
           HREGKEY @ RegCloseKey DROP
           EXIT
        THEN
        REG-VALUE REG.index 1+!
    REPEAT
    HREGKEY @ RegCloseKey DROP
;

: GET-REG-VALUE1 ( Address S" ValueName" S" keypath" branch -- )
    /REG-VALUE ALLOCATE THROW TO REG-VALUE
    (GET-REG-VALUE)
    REG-VALUE FREE DROP
;
[THEN]

: REG-OPEN-KEY ( keypath u branch -- h )
    NIP 2>R
    0 SP@ KEY_ALL_ACCESS 0 2R> RegOpenKeyExA THROW
;

: REG-OPEN-KEY-RO ( keypath u branch -- h )
    NIP 2>R
    0 SP@ KEY_READ 0 2R> RegOpenKeyExA THROW
;

255 VALUE def-GRV-SIZE
: GET-REG-VALUE ( buf ValueName u1 keypath u2 branch -- )
    REG-OPEN-KEY-RO >R
    DROP >R >R def-GRV-SIZE SP@ R> 0 0 R>
    R@ RegQueryValueExA 
    R> RegCloseKey THROW
    THROW DROP
;

: HKLM-VALUE ( address S" value" S" path" -- )  HKEY_LOCAL_MACHINE GET-REG-VALUE ;
: HKCU-VALUE ( address S" value" S" path" -- )  HKEY_CURRENT_USER  GET-REG-VALUE ;

: REG-BR ( *br branch a1 a2 u2 -- *br )
    SWAP OVER COMPARE 0= IF OVER ! ELSE DROP THEN ;

: REG-PARSE { a u value? \ branch apath aval -- branch apath aval }
    0 TO branch
    AT branch
    HKEY_CURRENT_CONFIG     a S" HKEY_CURRENT_CONFIG"   REG-BR
    HKEY_CURRENT_USER       a S" HKEY_CURRENT_USER"     REG-BR
    HKEY_LOCAL_MACHINE      a S" HKEY_LOCAL_MACHINE"    REG-BR
    HKEY_USERS              a S" HKEY_USERS"            REG-BR
    HKEY_PERFORMANCE_DATA   a S" HKEY_PERFORMANCE_DATA" REG-BR
    HKEY_DYN_DATA           a S" HKEY_DYN_DATA"         REG-BR
    DROP
    a u S" \" SEARCH
    IF 1 /STRING
        value?
        IF
            2DUP
            BEGIN S" \" SEARCH WHILE
              1 /STRING
            REPEAT
            2DUP S" @" COMPARE 0=
            IF S" " ELSE 2DUP THEN  S>ZALLOC TO aval
            NIP - 1- S>ZALLOC TO apath
        ELSE
            S>ZALLOC TO apath
        THEN
        branch apath aval
    ELSE
        0 0 0
    THEN
;

: SET-REG-VALUE { data len type a u \ branch apath aval hkey dispos -- }
    a u TRUE REG-PARSE TO aval TO apath TO branch
    AT dispos AT hkey 0 KEY_WRITE 0 S" " DROP 0
        apath branch RegCreateKeyExA ?DUP 0=
    IF  len data type 0 aval hkey RegSetValueExA THEN
    aval FREE DROP apath FREE DROP
    hkey RegCloseKey THROW THROW
;

: REG-KEY-EXIST? ( a u -- ?)
    FALSE REG-PARSE DROP >R R@ ASCIIZ> ROT
    ['] REG-OPEN-KEY-RO CATCH
    IF 2DROP DROP FALSE ELSE RegCloseKey DROP TRUE THEN
    R> FREE DROP
;

: REG-SZ    { apath upath aval uval -- }  aval uval REG_SZ apath upath SET-REG-VALUE ;
: REG-DWORD { apath upath n -- }   n SP@ 4 REG_DWORD apath upath SET-REG-VALUE DROP ;

: REG-DELETE-VALUE { a u \ branch apath aval hkey -- }
    a u TRUE REG-PARSE TO aval TO apath TO branch
    apath 0 branch REG-OPEN-KEY TO hkey
    aval hkey RegDeleteValueA
       hkey RegCloseKey THROW
    aval FREE DROP apath FREE DROP
    THROW
;

1 [IF]
WINAPI: SHDeleteKeyA shlwapi.dll
: REG-DELETE-KEY { a u \ branch apath hkey -- }
    a u FALSE REG-PARSE DROP TO apath TO branch
    apath branch SHDeleteKeyA
    apath FREE DROP
    THROW
;
[ELSE]
: REG-DELETE-KEY { a u \ branch apath hkey -- }
    a u FALSE REG-PARSE DROP TO apath TO branch
    apath branch RegDeleteKeyA
    apath FREE DROP
    THROW
;
[THEN]

: GET-REG { buf a u \ branch apath aval hkey -- }
    a u TRUE REG-PARSE TO aval TO apath TO branch
    buf aval ASCIIZ> apath ASCIIZ> branch GET-REG-VALUE
;

\ 1 SP@ 4 REG_DWORD S" HKEY_LOCAL_MACHINE\Software\NNemtsev\NNCron\test" SET-REG-VALUE
\ S" hello!!!" REG_SZ S" HKEY_LOCAL_MACHINE\Software\NNemtsev\NNCron\test" SET-REG-VALUE

\ S" HKEY_LOCAL_MACHINE\Software\NNemtsev\NNCron\test" 12345 REG-DWORD
\ KEY DROP
\ S" HKEY_LOCAL_MACHINE\Software\NNemtsev\NNCron\test" REG-DELETE-VALUE
\ KEY DROP
\ S" HKEY_LOCAL_MACHINE\Software\NNemtsev\NNCron" REG-DELETE-KEY


\ PAD S" HKEY_CURRENT_USER\Software\Far\Language\help" GET-REG
\ PAD ASCIIZ> TYPE CR