REQUIRE WinNT? ~nn/lib/winver.f
REQUIRE { ~nn/lib/locals.f

\ WINAPI: GetFileSecurityA ADVAPI32.DLL
\ WINAPI: SetFileSecurityA ADVAPI32.DLL
WINAPI: GetNamedSecurityInfoA ADVAPI32.DLL
WINAPI: SetNamedSecurityInfoA ADVAPI32.DLL

\ BOOL GetFileSecurity(
\   LPCTSTR lpFileName,       // address of string for file name
\   SECURITY_INFORMATION RequestedInformation, // requested information
\   PSECURITY_DESCRIPTOR pSecurityDescriptor, // address of security descriptor
\   DWORD nLength,            // size of security descriptor buffer
\   LPDWORD lpnLengthNeeded   // address of required size of buffer
\ );

: SEC-INFO
    DACL_SECURITY_INFORMATION
\    [ DACL_SECURITY_INFORMATION OWNER_SECURITY_INFORMATION OR
\      GROUP_SECURITY_INFORMATION OR ] LITERAL 
;

1 CONSTANT SE_FILE_OBJECT
 
: GetFileSD { a u \ sd dacl -- sd dacl }
    WinNT? 0= IF 0 0 EXIT THEN
    AT sd
    0 AT dacl
    0 0
    SEC-INFO SE_FILE_OBJECT a GetNamedSecurityInfoA ?DUP 
    IF 0 0 ELSE dacl sd THEN
;

CREATE fsa 3 CELLS , 0 , 0 , 

: H. BASE @ >R HEX U. R> BASE ! ;
: GetFileSA { a u - dacl }
    WinNT? 0= IF 0 EXIT THEN
    fsa CELL+ @ ?DUP IF LocalFree DROP THEN
    fsa CELL+ 0!
    a u GetFileSD ?DUP
    IF fsa CELL+ !  ELSE  DROP 0  THEN
    ." get=" DUP H. CR
;

: SetFileSA { a u dacl -- ior }
    ." set=" dacl H. CR
    WinNT? 0= IF 0 EXIT THEN
    dacl IF
           0 dacl 0 0 SEC-INFO SE_FILE_OBJECT a SetNamedSecurityInfoA ERR 
       ELSE 0 THEN
;
\ S" file.f" GetFileSA . CR

