REQUIRE { ~nn/lib/locals.f
REQUIRE WinNT? ~nn/lib/winver.f

WINAPI: GetSecurityInfo ADVAPI32.DLL
\ DWORD GetSecurityInfo(
\   HANDLE handle,     // handle to the object
\   SE_OBJECT_TYPE ObjectType,  // type of object
\   SECURITY_INFORMATION SecurityInfo, // type of security information to retrieve
\   PSID *ppsidOwner,  // receives a pointer to the owner SID
\   PSID *ppsidGroup,  // receives a pointer to the primary group SID
\   PACL *ppDacl,      // receives a pointer to the DACL
\   PACL *ppSacl,      // receives a pointer to the SACL
\   PSECURITY_DESCRIPTOR *ppSecurityDescriptor
\                      // receives a pointer to the security descriptor
\ );

: GetSD { handle \ sid1 sid2 acl1 acl2 sd -- psd ior }
    AT sd
    AT acl2 AT acl1 AT sid2 AT sid1
    OWNER_SECURITY_INFORMATION GROUP_SECURITY_INFORMATION OR
    DACL_SECURITY_INFORMATION OR 
\    SACL_SECURITY_INFORMATION OR 
\    0
    1 handle GetSecurityInfo 
    sd SWAP
;

CREATE sa 3 CELLS , 0 , 0 , 

: GetHSA ( handle -- sa )
    WinNT? 0= IF 2DROP 0 EXIT THEN
    sa CELL+ @ ?DUP IF LocalFree DROP THEN
    sa CELL+ 0!
    GetSD THROW sa CELL+ !
    sa
;
: (GetFileSA) { a u dir -- sa }
    0 dir IF FILE_FLAG_BACKUP_SEMANTICS ELSE 0 THEN
        OPEN_EXISTING 0 3 R/O a CreateFileA 
        DUP INVALID_HANDLE_VALUE <> ERR THROW >R
    R@ GetHSA
    R> CLOSE-FILE THROW
;

: GetFileSA ( a u -- sa ) FALSE (GetFileSA) ;
: GetDirSA ( a u -- sa ) TRUE (GetFileSA) ;

( 
WINAPI: CreateDirectoryA KERNEL32.DLL
0 VALUE fh
0 VALUE fh2
0 VALUE sd
CREATE sa 3 CELLS , 0 , 0 , 
: test
    S" e:\home\src\cron\nncron.exe" R/O OPEN-FILE THROW TO fh
    fh GetSD THROW TO sd
    sd sa CELL+ !
    0 0 CREATE_ALWAYS sa 0 R/W S" e:\tmp\test2.txt" DROP CreateFileA 
    DUP INVALID_HANDLE_VALUE <> ERR THROW TO fh2
    sd LocalFree 0= ERR THROW
    fh CLOSE-FILE THROW
    fh2 CLOSE-FILE THROW
;
test
)