\ SET
\ REQUIRE UseDLL ~nn/lib/usedll.f

REQUIRE DEBUG? ~nn/lib/qdebug.f
\ REQUIRE AddNode ~nn/lib/list.f
REQUIRE SHEADER ~nn/lib/sheader.f
REQUIRE >NAME lib/ext/to-name.f
REQUIRE EVAL-SUBST ~nn/lib/subst.f
REQUIRE { ~nn/lib/locals.f
REQUIRE PLACE ~lib/ext/string.f
REQUIRE <EOF> ~nn/lib/eof.f

\ WINAPI: GetEnvironmentVariableA KERNEL32.DLL
WINAPI: SetEnvironmentVariableA KERNEL32.DLL

VARIABLE SET-LIST

: >SET-LIST ( xt -- )
    SET-LIST @ HERE SET-LIST ! , 
    >NAME , ;

: >ENV { xt \ name -- }
    xt EXECUTE \ 2DUP TYPE CR
    DROP
    xt >NAME COUNT DUP CELL+ ALLOCATE THROW TO name
    SWAP OVER name SWAP CMOVE name + 0 SWAP C!
    name SetEnvironmentVariableA DROP
    name FREE DROP
;

: SET
    BL SKIP [CHAR] = PARSE -TRAILING
\    2DUP TYPE CR
    SHEADER
    BL SKIP
    :NONAME >R
    
\    HERE SMUDGE ]
    SOURCE DROP >IN @ + C@ [CHAR] " =
    IF [CHAR] " ELSE 1 THEN
    DUP SKIP
    PARSE \ 2DUP TYPE CR
    POSTPONE SLITERAL
    POSTPONE EVAL-SUBST
    RET, SMUDGE POSTPONE [
    R> DUP >SET-LIST >ENV
    ;

: ALL>ENV
    SET-LIST 
    BEGIN @ ?DUP WHILE
        DUP CELL+ @ NAME> >ENV
    REPEAT
;

: set SET ;
: Set SET ;

<EOF>
REQUIRE ENV ~nn/lib/env.f
: view-list
    SET-LIST 
    BEGIN @ ?DUP WHILE
        DUP CELL+ @ COUNT TYPE CR
    REPEAT
;
: ENV. { \ vars -- } 
    GetEnvironmentStrings TO vars
    vars
    BEGIN ASCIIZ> ?DUP WHILE
      2DUP TYPE CR
      + 1+
      KEY? IF KEY DROP KEY DROP THEN
    REPEAT
    DROP
    vars FreeEnvironmentStringsA DROP
;



\ SET PATH = ">  1xjhcjksdhkjcs  dhkj2<"
SET PATH1=%PATH2% and my tail %ComSpec%
SET PATH2=My header
set PATH2=another value

S" PATH" ENV TYPE CR
PATH2 TYPE CR
PATH1 TYPE CR
CR
view-list
ENV.
