\ String resources

REQUIRE CLASS: ~nn/class/class.f
REQUIRE S>ZALLOC ~nn/lib/az.f
REQUIRE AddNode ~nn/lib/list.f
REQUIRE GLOBAL ~nn/lib/globalloc.f
REQUIRE S>NUM ~nn/lib/s2num.f

CLASS: StrRes
\    var list    \ list of strings
    var list
    var filename
    var deffilename
    var vBuf
    10240 CONSTANT max-size

    CLASS: StrItem
        var number
        var string
        CONSTR: init ( a u n --)
            number !
            GLOBAL S>ZALLOC LOCAL string ! ;
        DESTR: free
           string @ ?DUP IF GLOBAL FREE LOCAL THROW THEN  ;
    ;CLASS

    CONSTR: init ( -- )
        filename 0!
        list 0!
    ;

    : del_item ( node -- )    NodeValue DELETE   ;

    M: Unload
        ['] del_item list DoList
        GLOBAL list FreeList LOCAL
        list 0!
    ;

    M: SetFilename GLOBAL S>ZALLOC LOCAL filename ! ;
    M: SetDefFilename GLOBAL S>ZALLOC LOCAL deffilename ! ;

    DESTR: free
        filename @ ?DUP IF GLOBAL FREE LOCAL THROW THEN
        deffilename @ ?DUP IF GLOBAL FREE LOCAL THROW THEN
        Unload
        filename 0!
        deffilename 0!
        list 0!
    ;

    StrItem POINTER cur_item
    StrRes  POINTER cur_res

    M: Add ( a u -- )
        0 0 2SWAP >NUMBER 2SWAP D>S >R
        BEGIN
          DUP IF OVER C@ BL = ELSE FALSE THEN
        WHILE
          1 /STRING
        REPEAT
        R>
\        [ DEBUG? ] [IF] DUP . ." = " >R 2DUP TYPE CR R> [THEN]
        StrItem NEW list GLOBAL AppendNode LOCAL
    ;

    : num? ( a u -- ?) S>NUM 0<> ;
    M: ?Add ( a -- ) DUP C@ IF ASCIIZ> Add ELSE DROP THEN ;
    M: Load1File ( a u -- )
        { \ f buf line -- }
        R/O OPEN-FILE-SHARED 0=
        IF TO f
          max-size ALLOCATE THROW TO buf
          max-size ALLOCATE THROW TO line
          buf 0!
          BEGIN line max-size CELL- f READ-LINE THROW WHILE
              line SWAP -TRAILING
              ?DUP
              IF
                 OVER C@ [CHAR] \ <>
                 IF
                   2DUP num?
                   IF buf ?Add  buf 0!
                   ELSE
                     buf C@ IF LT LTL @ buf +ZPLACE THEN
                   THEN
                   buf +ZPLACE
                 ELSE 2DROP THEN
              ELSE
                 DROP
              THEN
          REPEAT DROP
          buf ?Add
          f CLOSE-FILE DROP
          buf FREE DROP
          line FREE DROP
        ELSE
          DROP
        THEN
    ;
    M: Load ( adef udef a u -- )
        free
\        ." load RES " 2DUP TYPE CR
        SetFilename
        SetDefFilename
        filename @ ASCIIZ>    Load1File
        deffilename @ ASCIIZ> Load1File
    ;

    M: Get ( n -- a u )
        >R
        list
        BEGIN @ ?DUP WHILE
          DUP NodeValue TO cur_item
          cur_item number @ R@ =
          IF RDROP DROP
             cur_item string @ ASCIIZ>
             EXIT
          THEN
        REPEAT
        RDROP
        \ S" not found"
        S" resource string not found"
    ;
;CLASS

