REQUIRE EVAL-SUBST ~nn/lib/subst1.f
REQUIRE { ~nn/lib
REQUIRE MODULE: ~nn/lib/spf4/spf_modules.f
REQUIRE ZPLACE ~nn/lib/az.f

MODULE: STR-SUBST-MODULE

: ADD2BUF { a u buf len \ cur-len new-len -- buf new-len }
\    ." -->" a u TYPE CR
    buf ASCIIZ> TO cur-len DROP
    cur-len u + 1+ len >
    IF
        len 2* TO new-len
\        ." resize to" new-len . CR
\        buf len DUMP CR
        buf new-len RESIZE THROW TO buf
\        buf new-len DUMP CR
    ELSE
        len TO new-len
    THEN
    a u buf cur-len + ZPLACE
\    buf new-len DUMP CR
    buf new-len
;

EXPORT

: STR-SUBST { a1 u1 a2 u2 a3 u3 \ pos rest buf len -- a4 u4}
    u1 0= IF a1 u1 EXIT THEN
    u1 TO len
    a1 TO pos
    u1 TO rest
    len ALLOCATE THROW TO buf  0 buf C!
    BEGIN
        pos rest a2 u2 SEARCH
    WHILE
\        2DUP TYPE CR
        ( abegin urest -- )
        rest OVER - pos SWAP buf len ADD2BUF TO len TO buf
                    a3 u3    buf len ADD2BUF TO len TO buf
        u2 /STRING ( new-pos new-rest )
        TO rest TO pos
    REPEAT
    buf len ADD2BUF DROP ASCIIZ>
    SWAP OVER 1+ RESIZE THROW SWAP
;
;MODULE

REQUIRE \EOF ~nn/lib/eof.f
\EOF
: t 2>R 2>R 2DUP TYPE SPACE 2R> 2DUP TYPE ." ->" 2R> 2DUP TYPE CR STR-SUBST TYPE CR ;
: test
\    S" xxxxx'zzzzz'eeeeee'" S" '" S" *" t
    S" xxxxxYYzzzzYYYzzzzz" S" YY" S" |------------|" t
;
test
