REQUIRE PLACE lib/ext/string.f
REQUIRE <TIB  ~nn/lib/tib.f
: PAD1 PAD 257 + ;
: PAD2 PAD 514 + ;

\ : asTib ( addr u -- )  #TIB ! TO TIB >IN 0! ;

\ : <TIB ( a u --) R> >IN @ >R #TIB @ >R TIB >R >R asTib >IN 0! ;
\ : TIB> ( --)  R> R> R> asTib R> >IN ! >R ;



USER-VALUE ENV-VAR-NAME 

5   CONSTANT SUBST-MAX-NUM-BUF
257 CONSTANT SUBST-LEN-STR

USER-CREATE SUBST-BUF0 SUBST-LEN-STR SUBST-MAX-NUM-BUF * USER-ALLOT
USER-VALUE SUBST-LEN

USER-VALUE #SUBST
USER-VALUE SUBST-BUF
USER-CREATE SUBST-SRC 2 CELLS USER-ALLOT

: INIT-SUBST
    #SUBST ABS SUBST-MAX-NUM-BUF MOD TO #SUBST
    #SUBST SUBST-LEN-STR * SUBST-BUF0 + TO SUBST-BUF
    #SUBST 1+ TO #SUBST
    256 ALLOCATE THROW TO ENV-VAR-NAME
;

: SUBST-ERROR ." Error macro variable substitution:" CR ;
: EVAL-SUBST ( a u -- a1 u1)
\  [ DEBUG? ] [IF] ." Subst inp: " 2DUP TYPE CR [THEN]
  SUBST-SRC 2@ 2>R SUBST-BUF >R ENV-VAR-NAME >R
  SUBST-SRC 2!
  INIT-SUBST
  SUBST-BUF 0!
  STATE 0!
  SUBST-SRC 2@ <TIB
  BEGIN
                        \  ." 1:" TIB >IN @ + #TIB @ >IN @ - TYPE CR
      [CHAR] % PARSE    \  ." 2:" 2DUP TYPE CR
      SUBST-BUF +PLACE
      [CHAR] % PARSE DUP \  ." 3:" .S CR
  WHILE
    ENV-VAR-NAME PLACE ENV-VAR-NAME $+0
    255 SUBST-BUF C@ - DUP 
    SUBST-BUF COUNT + ENV-VAR-NAME 1+ GetEnvironmentVariableA ( avail-size need)
    ?DUP
    IF SWAP OVER <
        IF  ( NOT ENAUGH SIZE ) DROP
        ELSE SUBST-BUF C@ + SUBST-BUF C! THEN
    ELSE
        DROP
        >IN @ >R SP@ >R
        ENV-VAR-NAME COUNT ['] EVALUATE CATCH   \   ." 4:" .S CR
        IF 2DROP RDROP R> 
           TIB> SUBST-SRC 2@ <TIB >IN !
           SUBST-ERROR ENV-VAR-NAME COUNT TYPE CR
        ELSE
            SP@ R@ ( sp) SWAP - DUP 2 CELLS =
            IF \  
               DROP RDROP SUBST-BUF +PLACE
            ELSE
            1 CELLS =
            IF \  
                RDROP DUP >R ABS S>D <# #S R> SIGN #>
                SUBST-BUF +PLACE
            ELSE \        
                R> SP!
                SUBST-ERROR
                SUBST-SRC 2@ TYPE CR
            THEN THEN
            RDROP
        THEN
     THEN
  REPEAT
  2DROP
  TIB>
  SUBST-BUF $+0
  SUBST-BUF COUNT
\  [ DEBUG? ] [IF] ." Subst out: " 2DUP TYPE CR [THEN]
  ENV-VAR-NAME FREE DROP
  R> TO ENV-VAR-NAME
  R> TO SUBST-BUF
  2R> SUBST-SRC 2! 
\  SUBST-BUF 100 DUMP CR
;

