\ File copy

512 VALUE sector-size
0 VALUE fill-value

REQUIRE get-string ~nn/lib/getstr.f
REQUIRE S>ZALLOC ~nn/lib/az.f
REQUIRE D= lib/ext/double.f


VARIABLE from-filename
VARIABLE to-filename

VARIABLE from-file
VARIABLE to-file

VARIABLE buffer
VARIABLE buffer-err


: SET-CL
  GetCommandLineA ASCIIZ> \ 2DUP TYPE CR
  TIB SWAP C/L MIN DUP #TIB ! MOVE >IN 0!
  get-string 2DROP
;

: HELP ." Usage: fc.exe from_filename to_filename" CR BYE ;

: set-filenames ( -- ) \   
  SET-CL
  get-string ?DUP 0= IF HELP THEN S>ZALLOC from-filename ! 
  get-string ?DUP 0= IF HELP THEN S>ZALLOC to-filename ! 
;

: EOF? ( h -- ?)
    >R R@ FILE-POSITION THROW 
    R> FILE-SIZE THROW D=
;

: copy { \ sector-number read -- } 
    from-filename @ ASCIIZ> R/O OPEN-FILE-SHARED THROW from-file !
    to-filename @ ASCIIZ> W/O CREATE-FILE-SHARED THROW to-file !
    sector-size ALLOCATE THROW buffer !
    sector-size ALLOCATE THROW buffer-err !
    buffer-err @ sector-size fill-value FILL
    
    0 TO sector-number
    
    BEGIN from-file @ EOF? 0= WHILE
        sector-number . 
        sector-number sector-size UM* from-file @ REPOSITION-FILE THROW
        buffer @ sector-size from-file @ READ-FILE .S SWAP TO read
        buffer @ read to-file @ WRITE-FILE THROW 
\        DUP . CR KEY DROP
\        buffer @ 100 DUMP CR
        IF 
            buffer-err @ sector-size read - to-file @ WRITE-FILE THROW 
            CR
        THEN
        sector-number 1+ TO sector-number
        13 EMIT
    REPEAT
    to-file @ CLOSE-FILE THROW
    from-file @ CLOSE-FILE THROW
;

: main set-filenames copy BYE ;

: 1BYE 1 HALT ;
' main TO <MAIN>
0 MAINX !

BASE @ HEX
: JMP  >R  0E9 R@ C! R@ 1+ CELL+ - R> 1+ ! ;
BASE !
' 1BYE ' QUIT JMP
' NOOP ' OPTIONS JMP
FALSE TO SPF-INIT?
S" fc.exe" SAVE
BYE

