REQUIRE SPLIT ~nn/lib/split.f
REQUIRE ENV   ~nn/lib/env.f
REQUIRE {     ~nn/lib/locals.f
REQUIRE ZPLACE ~nn/lib/az.f

WINAPI: SearchPathA KERNEL32.DLL
\ DWORD SearchPath(
\   LPCTSTR lpPath,      // pointer to search path
\   LPCTSTR lpFileName,  // pointer to filename
\   LPCTSTR lpExtension, // pointer to extension
\   DWORD nBufferLength, // size, in characters, of buffer
\   LPTSTR lpBuffer,     // pointer to buffer for found filename
\   LPTSTR *lpFilePart   // pointer to pointer to file component
\ );

VARIABLE EXT-LIST 
: PATHEXT  S" PATHEXT" ENV ?DUP 0= IF DROP S" .exe;.com;.cmd;.bat" THEN ;
: SET-EXT-LIST
    EXT-LIST @ 0=
    IF PATHEXT [CHAR] ; SPLIT EXT-LIST ! THEN
;

: WHICH { a u \ lpFilePart ext -- full-path u1 }
    SET-EXT-LIST
    EXT-LIST
    BEGIN @ ?DUP WHILE
        DUP NodeValue TO ext
        a u PAD ZPLACE
        AT lpFilePart PAD 1024 ext PAD 0 SearchPathA
        ?DUP IF NIP PAD SWAP EXIT THEN
    REPEAT
    PAD 0
;