REQUIRE CLASS: ~nn/class/class.f

1024 CONSTANT max-path
2   CONSTANT short

WINAPI: GetOpenFileNameA COMDLG32.DLL
WINAPI: GetSaveFileNameA COMDLG32.DLL

\ << :execute
\ << :setFilter
\ << :fileName
\ << :setTitle

CLASS: OpenDialog 

      RECORD:  OFStruct
          CELL FIELD   lStructSize
          CELL FIELD   hwndOwner  
          CELL FIELD   hInstance
          CELL FIELD   lpstrFilter
          CELL FIELD   lpstrCustomFilter
          CELL FIELD   nMaxCustFilter
          CELL FIELD   nFilterIndex
          CELL FIELD   lpstrFile   \    !
          CELL FIELD   nMaxFile
          CELL FIELD   lpstrFileTitle
          CELL FIELD   nMaxFileTitle
          CELL FIELD   lpstrInitialDir
          CELL FIELD   lpstrTitle
          CELL FIELD   Flags
         short FIELD   nFileOffset
         short FIELD   nFileExtension
          CELL FIELD   lpstrDefExt
          CELL FIELD   lCustData
          CELL FIELD   lpfnHook
          CELL FIELD   lpTemplateName
        ;RECORD /OFStruct
        var CurDir
        var LastDir

CONSTR: init
    max-path ALLOCATE THROW lpstrFile !
    max-path nMaxFile !
    /OFStruct lStructSize !
;

: save-last
    LastDir @ 0= IF 1024 ALLOCATE THROW LastDir ! THEN
    LastDir @ 1024 GetCurrentDirectoryA DROP ;

: rest-last
    LastDir @ ?DUP IF SetCurrentDirectoryA DROP THEN ;

: save-dir
    CurDir @ 0=
    IF 1024 ALLOCATE THROW CurDir !
        CurDir @ 1024 GetCurrentDirectoryA DROP THEN
    rest-last
;

: rest-dir
    save-last
    CurDir @ ?DUP IF SetCurrentDirectoryA DROP THEN ;

M: Execute ( -- bool )   save-dir OFStruct GetOpenFileNameA rest-dir ;    

M: SetFilter ( addr -- )    lpstrFilter ! ;

M: FileName ( -- addr u )    lpstrFile @ ASCIIZ> ;

M: FileName! ( a u -- )    lpstrFile @ ZPLACE ;

M: SetTitle ( addr u -- )   DROP lpstrTitle ! ;

;CLASS  


CLASS: SaveDialog <SUPER OpenDialog

M: Execute  save-dir OFStruct GetSaveFileNameA rest-dir ;

;CLASS


0 VALUE FMarker
VOCABULARY VOC-FILTER

: FILTER:
    CREATE 
       ALSO VOC-FILTER
       HERE TO FMarker 0 ,
    DOES> @
;

GET-CURRENT
ALSO VOC-FILTER DEFINITIONS

: EXT" ( "name" -- )
   [CHAR] " PARSE
   HERE OVER ALLOT
   SWAP CMOVE 0 C,
;

: NAME" ( -- )
   FMarker @ 0= IF HERE FMarker ! THEN
   EXT"
;

: ;FILTER
   0 C,
   PREVIOUS
;

SET-CURRENT PREVIOUS
