REQUIRE { ~nn/lib/locals.f
REQUIRE HOLDS lib/ext/string.f

WINAPI: mciSendStringA winmm.dll

\ MCIERROR mciSendString(
\  LPCTSTR lpszCommand,  
\  LPTSTR lpszReturnString,  
\  UINT cchReturn,       
\  HANDLE hwndCallback   
\ );

\ 0 0 0 S" Set cdaudio door open wait" DROP mciSendStringA DROP
\ 0 0 0 S" Set cdaudio door closed wait" DROP mciSendStringA DROP
\ open d: type cdaudio alias cd

: mciSendString ( a u -- ior ) DROP >R 0 0 0 R> mciSendStringA 0xFFFF AND ;

0 [IF]
: OP-CD-TRAY { letter a u -- ior }
    0 0
    <# 0 HOLD S"  shareable" HOLDS letter HOLD S" : type cdaudio alias CD" HOLDS
        letter HOLD  S" open " HOLDS #>
    mciSendString ?DUP IF EXIT THEN
    0 0
    <# 0 HOLD S"  wait" HOLDS a u HOLDS S"  door " HOLDS
        letter HOLD S" Set CD" HOLDS #>
    mciSendString ?DUP IF EXIT THEN
    0 0
    <# 0 HOLD S"  wait" HOLDS
        letter HOLD S" close CD" HOLDS #>
    mciSendString
\    S" open d: type cdaudio alias CD"
;

: CD-TRAY-EJECT ( letter -- ior )  S" open" OP-CD-TRAY ;
: CD-TRAY-CLOSE ( letter -- ior )  S" closed" OP-CD-TRAY ;
[THEN]

: mciOpen { letter -- ior }
    0 0 
    <# 0 HOLD S"  shareable" HOLDS letter HOLD S" : type cdaudio alias CD" HOLDS 
        letter HOLD  S" open " HOLDS #> \ 2DUP TYPE CR
    mciSendString 
;

: mciClose { letter -- ior }
    0 0
    <# 0 HOLD S"  wait" HOLDS 
        letter HOLD S" close CD" HOLDS #> \ 2DUP TYPE CR
    mciSendString 
;

: IS-CD-PRESENT { letter \ buf -- flag } 
    letter mciOpen ?DUP IF FALSE EXIT THEN
    32 ALLOCATE THROW TO buf
    0 0 
    <# 0 HOLD S"  wait " HOLDS S"  media present " HOLDS 
        letter HOLD S" status CD" HOLDS #> \  2DUP TYPE CR

    DROP >R 0 31 buf R> mciSendStringA 0xFFFF AND 
    ?DUP IF buf FREE DROP FALSE EXIT THEN
    letter mciClose ?DUP IF FALSE EXIT THEN
    buf ASCIIZ> S" true" ICOMPARE 0= 
    buf FREE DROP
;

: mciSetOpen/Close { letter a u -- ior }
    letter mciOpen ?DUP IF EXIT THEN
    0 0
    <# 0 HOLD S"  wait" HOLDS a u HOLDS S"  door " HOLDS
        letter HOLD S" Set CD" HOLDS #>
    mciSendString ?DUP IF EXIT THEN
    letter mciClose
;

: CD-TRAY-EJECT ( letter -- ior )  S" open" mciSetOpen/Close ;
: CD-TRAY-CLOSE ( letter -- ior )  S" closed" mciSetOpen/Close ;



REQUIRE \EOF ~nn/lib/eof.f
\EOF

: test
    1 2 3
    [CHAR] F CD-TRAY-EJECT . CR
    5000 PAUSE
    [CHAR] F CD-TRAY-CLOSE . CR
    .S 
;
test

