
WINAPI: LookupAccountSidA ADVAPI32.DLL
\ BOOL LookupAccountSid(
\   LPCTSTR lpSystemName,  // name of local or remote computer
\   PSID Sid,              // security identifier
\   LPTSTR Name,           // account name buffer
\   LPDWORD cbName,        // size of account name buffer
\   LPTSTR DomainName,     // domain name
\   LPDWORD cbDomainName,  // size of domain name buffer
\   PSID_NAME_USE peUse    // SID type
\ );

: SID2NAME { psid \ buf cbN cbDN Use -- a u ior}
    512 ALLOCATE THROW TO buf
    250 TO cbN     250 TO cbDN
    AT Use AT cbDN buf 256 + AT cbN buf
    psid 0 LookupAccountSidA
    IF
        buf ASCIIZ> 0
    ELSE
        buf FREE DROP        
        S" " GetLastError
    THEN
;

REQUIRE <EOF> ~nn/lib/eof.f
<EOF>
\ BOOL GetTokenInformation(
\   HANDLE TokenHandle,                            // handle to access token
\   TOKEN_INFORMATION_CLASS TokenInformationClass, // token type
\   LPVOID TokenInformation,                       // buffer
\   DWORD TokenInformationLength,                  // size of buffer
\   PDWORD ReturnLength                            // required buffer size
\ );
WINAPI: GetTokenInformation advapi32.dll

REQUIRE GetTrayToken ~nn\lib\win\sec\traytoken.f 

: test { \ need htoken buf -- }
    GetTrayToken THROW TO htoken
    AT need 0 0 1 htoken GetTokenInformation ERR 122 =
    IF
\    8 TO need
    need ALLOCATE THROW TO buf
    AT need need buf 1 htoken GetTokenInformation ERR THROW
    htoken CloseHandle DROP
    buf @ SID2NAME
    buf FREE DROP
    THEN
    htoken CloseHandle DROP
;
test