\ S" ~nn/lib/usedll.f" LH-INCLUDED

\ UseDLL USER32.DLL
\ UseDLL GDI32.DLL
\ UseDLL kernel32.DLL


REQUIRE FrameWindow ~nn/lib/win/framewindow.f
REQUIRE MENU ~nn/lib/win/menu.f

REQUIRE POINTER ~nn/class/pointer.f


CLASS: StickWinClass <SUPER WinClass

CONSTR: init
     init
     S" Clock Class" DROP lpszClassName !
     style @ CS_SAVEBITS OR style !     
;

;CLASS

StickWinClass OBJECT: iStickClass
: StickClass S" StickClass" ;
StickClass DROP iStickClass lpszClassName !

101 CONSTANT ID_ABOUT
102 CONSTANT ID_CLOSE

CLASS: StickWindow <SUPER FrameWindow
        CELL FIELD text

        Font OBJ iFont

        
MM: ID_ABOUT
    S" This clock is presented by Dmitry Yakimov" ShowMessage
;

MM: ID_CLOSE BYE ;
 
VM: CreatePopup
   POPUPMENU
     S" About" ID_ABOUT MENUITEM
     S" Close" ID_CLOSE MENUITEM
   END-MENU
;

CONSTR: init
   init
   WS_DLGFRAME WS_POPUP OR vStyle !
   WS_EX_TOPMOST vExStyle !    
   iStickClass SELF vClass !
   S" Times" DROP iFont lpszFace !
   18 iFont height !
   FW_BOLD iFont weight !   
;
M: Create
   BLACK_BRUSH GetStockObject iStickClass hbrBackground !
   Create
;

W: WM_CREATE
    0 220 0 rgb handle @ GetDC DUP >R SetTextColor DROP    
    0 R@ SetBkColor DROP
    iFont Create
    iFont handle @ R> SelectObject DROP    
    0
;

W: WM_NCHITTEST
    HTCAPTION \  Windows :)
;

W: WM_NCRBUTTONDOWN
   WM_CONTEXTMENU this WM:
;
 W: WM_NCLBUTTONDBLCLK 
    0 S" Hello!!!" DROP DUP 0 MessageBoxA DROP
    0
 ;

VM: OnPaint text @ COUNT 1 1 TextOut ;

;CLASS

FrameWindow POINTER wpar
StickWindow POINTER w

: test 
    FrameWindow NEW TO wpar
    0 wpar Create
    wpar Hide
    StickWindow NEW TO w 
    wpar SELF w Create 
    230 1 50 15 w Move
    S" Stick window" w SetText
    S" HELLO" DROP 1- w text !
    w Show
    w Run
    w SELF DELETE
    wpar SELF DELETE
    BYE
;


\ 85000 TO IMAGE-SIZE
test BYE
' test MAINX !
TRUE TO ?GUI
S" stick.exe" SAVE BYE )