REQUIRE Z" ~nn/lib/az.f
MODULE: PERF-COUNTERS-95
VARIABLE bInitialized

EXPORT
: GetCpuUsage95 { \ hKey CPUUsage size buf typ -- n}
    4 TO size
    REG_DWORD TO typ
    bInitialized @ 0=
    IF
        AT hKey Z" PerfStats\StartSrv" HKEY_DYN_DATA RegOpenKeyA DUP . DROP
\          RegOpenKey HKEY_DYN_DATA, "PerfStats\StartSrv", hKey        
        AT size AT buf AT typ 0 Z" KERNEL" hKey RegQueryValueExA  DUP . DROP
\          RegQueryValueEx hKey, "KERNEL", 0, REG_DWORD, 0, 4
        hKey RegCloseKey DROP
\          RegCloseKey hKey
        AT hKey  Z" PerfStats\StartData" HKEY_DYN_DATA RegOpenKeyA DUP . DROP
\          RegOpenKey HKEY_DYN_DATA, "PerfStats\StartData", hKey
        AT size AT buf AT typ 0 Z" KERNEL\CPUUsage" hKey RegQueryValueExA DUP . DROP
\          RegQueryValueEx hKey, "KERNEL\CPUUsage", 0, REG_DWORD, 0, 4
        hKey RegCloseKey DROP
\          RegCloseKey hKey
        AT hKey  Z" PerfStats\StopSrv" HKEY_DYN_DATA RegOpenKeyA DUP . DROP
\          RegOpenKey HKEY_DYN_DATA, "PerfStats\StopSrv", hKey
        AT size AT buf AT typ 0 Z" KERNEL" hKey RegQueryValueExA  DUP . CR DROP
\          RegQueryValueEx hKey, "KERNEL", 0, REG_DWORD, 0, 4
        hKey RegCloseKey DROP
\          RegCloseKey hKey
        TRUE bInitialized !
\          bInitialized = True
    THEN
    AT hKey  Z" PerfStats\StatData" HKEY_DYN_DATA RegOpenKeyA DUP . DROP
\      RegOpenKey HKEY_DYN_DATA, "PerfStats\StatData", hKey
    AT size AT CPUUsage AT typ 0 Z" KERNEL\CPUUsage" hKey RegQueryValueExA DUP . CR DROP
\      RegQueryValueEx hKey, "KERNEL\CPUUsage", 0, REG_DWORD, GetCPULoad, 4
    hKey RegCloseKey DROP
\      RegCloseKey hKey
\      GetCPULoad = Int(GetCPULoad)
    CPUUsage
\  End Function
;
 
: CpuUsage95Cleanup { \ hKey size buf typ -- }
    4 TO size
    REG_DWORD TO typ
    bInitialized @ 
    IF
        AT hKey  Z" PerfStats\StopData" HKEY_DYN_DATA RegOpenKeyA DUP . DROP
        AT size AT buf AT typ 0 Z" KERNEL\CPUUsage" hKey RegQueryValueExA  DUP . DROP
        hKey RegCloseKey DROP
\      RegOpenKey HKEY_DYN_DATA, "PerfStats\StopData", hKey
\      RegQueryValueEx hKey, "KERNEL\CPUUsage", 0, REG_DWORD, 0, 4
\      RegCloseKey hKey
        bInitialized 0!
    THEN
;
;MODULE

: test
    2 0
    DO
        GetCpuUsage95 ." CPU Usage " . ." %  " 13 EMIT 
    LOOP
    CpuUsage95Cleanup
;
test
BYE