\ jobedit

REQUIRE Control     ~nn/lib/win/control.f
REQUIRE TabControl  ~nn/lib/win/controls/tab.f
REQUIRE ComboBox ~nn/lib/win/controls/combobox.f
REQUIRE RES ~nn/lib/res.f

CLASS: TabDialog <SUPER FrameWindow
    var vFileName

30 VALUE header_height \    tab-
5 VALUE left_margin \    tab-
5 VALUE right_margin \    tab-
40 VALUE footer_height \    tab-

13 CONSTANT but_h   \  
37 CONSTANT but_w   \  


USER tab1
: tab+ ( index -- )  this SWAP tab1 @ ->CLASS TabControl AddEl ;

  
TabControl OBJ tab
        :init a v 
            this tab1 !
            left_margin header_height pos
            vStyle @ WS_TABSTOP OR vStyle !
            ;


M: onOk ;

Button OBJ but_ok
    :init a v  but_w but_h size
            130 RES text  tabstop  ;


M: onCancel  ;
Button OBJ but_cancel
    :init a v  but_w but_h size
            131 RES text  ['] onCancel OnClick ! ;
            
M: onHelp  ;
Button OBJ but_help
    :init a v  but_w but_h size
            132 RES text  ['] onHelp OnClick ! ;


M: setGeometry
   GetPos         parGuiJobEditY set parGuiJobEditX set 
   GetWindowSize  parGuiJobEditH set parGuiJobEditW set
;

DESTR: free
    setGeometry
    free
    vFileName @ ?DUP IF FREE DROP THEN ;

: but_comm_y but_h 5 2 */ - ;
: but_comm_x ( w n-from-right -- x )  but_w right_margin + * - right_margin - ;

M: SetElementsPS { \ w h } 
\ tab-control
    GetWindowSize ( w h ) FromPixels TO h TO w
    w left_margin - right_margin - 3 -
    h header_height - footer_height - 
    tab SetSize
\ buttons
    w 1 but_comm_x h but_comm_y ToPixels but_ok SetPos
    w 2 but_comm_x h but_comm_y ToPixels but_cancel SetPos
    w 4 but_comm_x h but_comm_y ToPixels but_help SetPos
;

W: WM_SIZE
    SetElementsPS
;

CREATE (tab-select)  ' NOOP , ' NOOP , ' NOOP ,  ' NOOP ,  ' NOOP ,  ' NOOP ,  

M: TabSelect (tab-select) tab Current CELLS + @ EXECUTE  TRUE ;

M: BeforeTabSelect 0 ( 0 -  ,   ) 
    ( tab Current TAB-ADV = IF adv-parse is-adv @ ELSE 0 THEN ) ;

: CreateTab
    6 0 DO 103 I + RES I tab Insert LOOP
\    S" testttt" 4 tab Insert
    ['] TabSelect tab OnSelChange !
    ['] BeforeTabSelect tab OnSelChanging !
;

VM: Style WS_THICKFRAME ;
M: open-help ;
: processKeyDown
    wparam @
    CASE
    VK_F1  OF onHelp TRUE ENDOF
    VK_TAB OF
\                 ed_scr isActive
\                 IF isShift? IF cmb_action SetFocus ELSE ok_button SetFocus THEN ELSE
\                 ed_adv isActive
\                 IF isShift? IF tab SetFocus ELSE ok_button SetFocus THEN ELSE
\                 ed_cron_tim isActive
\                 IF isShift? IF rb_cron_tim SetFocus ELSE cb_log SetFocus THEN ELSE
\                 FALSE THEN THEN THEN
                FALSE
           ENDOF
        FALSE SWAP
    ENDCASE
;

M: Create ( parent -- )

    Create
    vFileName @ ?DUP IF ASCIIZ> S" %102 RES% : %1 esPICKS%" EVAL-SUBST ELSE 101 RES THEN  SetText
    
    parGuiJobEditX get parGuiJobEditY get SetPos
    parGuiJobEditW get parGuiJobEditH get FromPixels SetSize


    AutoCreate
    CreateTab
    SetElementsPS
  
    handle @ set-window-icons
;

M: SetFile S>ZALLOC vFileName ! ;

;CLASS

TabDialog POINTER jed

: RunJobEdit ( a u h -- )
    TabDialog NEW TO jed
    >R
    jed SetFile
    R> jed Create
    jed ShowModal
    jed Run
    jed SELF DELETE
;

\  : RunJobNew ( h -- )
\      TabDialog NEW TO jed
\      jed Create
\      jed ShowModal
\      jed Run
\      jed SELF DELETE
\  ;
