
REQUIRE LoadIcon  ~nn/lib/win/image.f
REQUIRE Window    ~nn/lib/win/window-ac.f

REQUIRE CLASS: ~nn/class/class.f

DECIMAL

CLASS: TrayIcon
\ HERE
WINAPI: Shell_NotifyIcon SHELL32.DLL

\ 0 CONSTANT NIM_ADD
\ 1 CONSTANT NIM_MODIFY
\ 2 CONSTANT NIM_DELETE

\ 1 CONSTANT NIF_MESSAGE
\ 2 CONSTANT NIF_ICON
\ 4 CONSTANT NIF_TIP

1 CELLS FIELD cbSize
1 CELLS FIELD hWnd
1 CELLS FIELD uID
1 CELLS FIELD uFlags
1 CELLS FIELD uCallbackMessage
1 CELLS FIELD hIcon
64      FIELD szTip
CURR .SIZE CONSTANT /NOTIFYICONDATA

1 CELLS FIELD OnLB
1 CELLS FIELD OnRB

1997 CONSTANT MsgID

CONSTR: MakeTrayIcon  ( -- )
    OnRB 0! OnLB 0!
    /NOTIFYICONDATA cbSize !
    this uID !
    NIF_MESSAGE NIF_ICON OR NIF_TIP OR uFlags !
;    

M: Tip! ( a u -- )
  szTip 64 ERASE
  szTip SWAP 63 MIN MOVE
;

M: Delete ( -- )  this NIM_DELETE Shell_NotifyIcon DROP ;

: (tray-proc) ( lParam wParam uMsg hwnd -- )
    DROP
    ." Tray:" DUP . CR
    MsgID =
    IF
        >R
        ." Message:" DUP . CR
        DUP WM_LBUTTONDOWN =
        IF DROP
          R@ => OnLB @  ELSE 
          WM_RBUTTONDOWN =
        IF
          R@ => OnRB @
        ELSE
          0
        THEN THEN
        ?DUP IF EXECUTE THEN
        RDROP
    ELSE
        2DROP
    THEN
    TRUE
;

' (tray-proc) WNDPROC: tray-proc

M: Create ( addr u hicon -- )
  hIcon ! Tip!
  S" Static" SPF_STDEDIT 0 Window hWnd !
  ['] tray-proc hWnd @ WindowSubclass
  MsgID uCallbackMessage !
  this NIM_ADD Shell_NotifyIcon DROP ;

M: ModifyIcon ( hicon -- )
   hIcon !
   this NIM_MODIFY Shell_NotifyIcon DROP ;

M: ModifyText ( addr u -- ) Tip! hIcon @ ModifyIcon ;

;CLASS

\ S"  " S" nncron16x16.ico" 1997 S" STATIC" 0 0 Window TrayIconCreate 



\ HERE SWAP - .( Notify size is ) . CR
