REQUIRE FrameWindow ~nn/lib/win/framewindow.f
REQUIRE Edit ~nn/lib/win/control.f

C" ServiceName" FIND NIP 0= [IF] : ServiceName S" Console test" ; [THEN]

CLASS: ConsoleWindow <SUPER FrameWindow

200 VALUE width
200 VALUE height

    var vBrush

    Edit OBJ text
        :init a v 0 0 pos width height size
           \ ['] onURL vOnUrl !
            ES_MULTILINE vStyle ! ;

W: WM_SIZE { \ w h -- }
  lparam @ LOWORD TO w 
  lparam @ HIWORD TO h
\  -1 -1 w h text MovePixels
;

CLASS: ConsoleClass <SUPER WinClass

CONSTR: init
    init
    ( COLOR_WINDOW)  COLOR_BTNFACE ( COLOR_BACKGROUND) GetSysColorBrush hbrBackground !
;             
DESTR: free 
free ;

;CLASS

CONSTR: init init DefConsoleClass SELF vClass ! ;

DESTR: free free
    vBrush @ ?DUP IF DeleteObject DROP THEN
;

CREATE LOGBRUSH
    BS_SOLID ,
    0xFF ,
    0 ,
M: Create 
     WS_THICKFRAME  vStyle @ OR vStyle !
     0 Create
     AutoCreate
     LOGBRUSH CreateBrushIndirect DUP . vBrush !
     vBrush @ handle @ GetDC DUP . SelectObject DUP . CR DROP
     width height Center
     ServiceName SetText
;

;CLASS

ConsoleWindow POINTER cw
: GUI-CONSOLE
    ConsoleWindow NEW TO cw
    cw Create
    cw Show
\    mw vNoNotify 0!
    cw Run
    cw SELF DELETE
;

: test
 GUI-CONSOLE
 BYE
;
test
