REQUIRE (DIALOG) ~nn/lib/win/windows/dlgres.f
REQUIRE get-string ~nn/lib/getstr.f
REQUIRE PICK lib/ext/core-ext.f
REQUIRE [NONAME ~nn/lib/noname.f

REQUIRE #define ~nn/lib/define.f

MODULE: FORM-MODULE

BASE @ HEX
0080 CONSTANT DI_Button 
0081 CONSTANT DI_Edit 
0082 CONSTANT DI_Static 
0083 CONSTANT DI_Listbox 
0084 CONSTANT DI_Scrollbar 
0085 CONSTANT DI_Combobox
BASE !


VARIABLE <DLG-FONT>
VARIABLE <DLG-ITEMS>    \    (id, xt-init,xt-after, data)
VARIABLE <DLG-ITEM-ID>  \   
VARIABLE 
8  VALUE DLG-HST    \  static
12 VALUE DLG-HED   \  edit box

: ?FONT <DLG-FONT> @ 0= IF S" MS Sans Serif" 8 0 DIALOG-FONT <DLG-FONT> ON THEN ;

: FORM-ITEM ?FONT <DLG-ITEM-ID> @ DIALOG-ITEM <DLG-ITEM-ID> 1+! ;

EXPORT

: EDITTEXT ( N x y cx cy style S" text" -- N+1 )
    { a u -- }
  WS_BORDER OR WS_TABSTOP OR DI_Edit a u FORM-ITEM
;

: PUSHBUTTON ( N x y cx cy S" text" -- N+1 )
    { a u -- }
  WS_TABSTOP DI_Button a u FORM-ITEM
;

: LTEXT ( N x y cx cy S" text" -- N+1 )
    { a u -- }
  0 DI_Static a u FORM-ITEM
;

: DLG-ADD-EDIT
\ init-code
    [NONAME ( data -- )
    NONAME]
\ exit-code
    [NONAME
    NONAME]
    2DROP
;

: CREATE-DLG-ITEM
    CREATE <DLG-ITEM-ID> @ ,
;

: FORM ( cx cy \ name "title" -- )
    101 <DLG-ITEM-ID> !
    CREATE HERE 0 , 12345 ( tag) 2>R
    0 0 2SWAP
    [ WS_POPUP WS_SYSMENU OR WS_CAPTION OR DS_MODALFRAME OR
      DS_SETFONT OR DS_CENTER OR ] LITERAL
    get-string BEGIN-DIALOG
    2R> 2SWAP
;

: ;FORM
    END-DIALOG
    DIALOG, ( a1 12345 a2 )
    >R
    12345 <> -22 ?ERROR
    R> SWAP !
;


: Label
    CREATE-DLG-ITEM
    ( N x y cx -- N+1)
    DLG-HST get-string LTEXT
;

: EditBox ( N id x y cx)
    CREATE-DLG-ITEM
    ( N x y cx -- N+1)
\    3 PICK DLG-ADD-EDIT
    DLG-HED ES_AUTOHSCROLL get-string EDITTEXT
;
;MODULE

REQUIRE \EOF ~nn/lib/eof.f

\EOF